/*
 * Written by Volker Augustin <snowbird@bigfoot.de> (03/2001)
 */

#include "interactive_close.h"
#include "global.h"
#include <qlabel.h>
#include <qlayout.h>
#include <qmessagebox.h>
#include <qpushbutton.h>
#include <qstyle.h>

InteractiveCloseDialog::InteractiveCloseDialog(QWidget *parent, const char *name)
	: QDialog(parent, name, true)
{
	setCaption(QString(PROGRAM_NAME) + " " + XCOCOA_VERSION);

	QVBoxLayout *vb = new QVBoxLayout(this, 10);
	QHBoxLayout *hb = new QHBoxLayout();
	vb->addLayout(hb, 5);

	QLabel *iconLabel = new QLabel("", this);
	iconLabel->setPixmap(QMessageBox::standardIcon(QMessageBox::Warning
	/* QTPORT_OBSOLETE , style().guiStyle() */
	));
	hb->addWidget(iconLabel);

	QLabel *textLabel = new QLabel(
		QString("If you quit ") + PROGRAM_NAME + " now, unsaved changes\n"
		"to the Interactive Document will be lost.\n"
		"Do you want to quit anyway?", this);
	textLabel->setAlignment(AlignVCenter);
	hb->addWidget(textLabel);

	vb->addSpacing(15);
	hb = new QHBoxLayout();
	vb->addLayout(hb, 5);
	hb->addStretch(1);
	QPushButton *ok = new QPushButton("Quit", this);
	connect(ok, SIGNAL(clicked()), this, SLOT(accept()));
	hb->addWidget(ok, 1);
	QPushButton *cancel = new QPushButton("Don't quit", this);
	cancel->setDefault(true);
	cancel->setFocusPolicy(QWidget::StrongFocus);
	cancel->setFocus();
	connect(cancel, SIGNAL(clicked()), this, SLOT(reject()));
	hb->addWidget(cancel, 1);
	hb->addStretch(1);

	hb = new QHBoxLayout();
	vb->addLayout(hb, 5);
	checkBox = new QCheckBox("Don't show this dialog again", this);
	hb->addWidget(checkBox);
}

bool InteractiveCloseDialog::showAgain()
{
	return !checkBox->isChecked();
}

