<?xml version="1.0" encoding="ascii"?>

<!-- this file creates toc.html and commands.html -->

<xsl:stylesheet version="1.1"
		xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

  <xsl:preserve-space elements="coc-quotes"/>
  <xsl:preserve-space elements="code"/>

<!--xslt document for creating the GUI_help directory for CoCoA-->

  <xsl:output method="text"/>
  <xsl:strip-space elements="*"/>	

  <xsl:template match="help">

<!-- ____ BIG INDEX ___________________________ -->

<!-- <xsl:variable name="file_cmd" select="'commands.html'"/> -->
<xsl:variable name="file_cmd" select="'toc.html'"/>
<xsl:document href="{$file_cmd}">

&lt;HTML&gt;
&lt;HEAD&gt;
&lt;link REL="stylesheet" TYPE="text/css" href="gui.css"&gt;
&lt;TITLE&gt;
  <xsl:apply-templates select="title"/>
&lt;/TITLE&gt;
&lt;/HEAD&gt;

&lt;BODY&gt;



&lt;H2&gt;
&lt;A HREF=&quot;#list&quot;&gt;Alphabetical list of commands&lt;/a&gt;
&lt;BR&gt;
&lt;A HREF=&quot;#4&quot;&gt;Commands and functions by type&lt;/a&gt;
&lt;BR&gt;
&lt;A HREF=&quot;#Tutorial&quot;&gt;Tutorial&lt;/a&gt;
&lt;/H2&gt;


&lt;HR&gt;



<!-- ____ table of contents CHAPTERS ____________________________ -->

<!-- <xsl:variable name="file_toc" select="concat('toc','.html')"/>  -->
<!-- <xsl:document href="{$file_toc}"> -->
  
<!-- &lt;HTML&gt; -->
<!-- &lt;HEAD&gt; -->
<!-- &lt;link REL="stylesheet" TYPE="text/css" href="gui.css"&gt; -->
<!-- &lt;TITLE&gt; -->
<!--   <xsl:apply-templates select="title"/> -->
<!-- &lt;/TITLE&gt; -->
<!-- &lt;/HEAD&gt; -->

<!-- &lt;BODY&gt; -->

<!-- &lt;TABLE WIDTH=100% BORDER=1 CELLPADDING=4 &gt; -->
<!-- &lt;TR&gt; -->
<!-- &lt;TD VALIGN=TOP&gt; -->

  <xsl:for-each select="manual_parts/part">
    <xsl:sort select="@number" data-type="number"/> 
    <xsl:variable name="part_num" select="@number"/>


<!-- <xsl:if test="@number=4"> -->
<!-- &lt;/TD&gt;&lt;TD VALIGN=TOP&gt; -->
<!-- </xsl:if> -->


&lt;DIV CLASS=P<xsl:value-of select="$part_num"/>&gt;

  &lt;A NAME=&quot;<xsl:value-of select="$part_num"/>&quot;&gt;&lt;/A&gt;

&lt;H2&gt;Part <xsl:value-of select="$part_num"/>
:  <xsl:value-of select="name"/>&lt;/H2&gt;

    <xsl:for-each select="chapter"> 
      <xsl:sort select="@number" data-type="number"/>
      <xsl:variable name="chap_num" select="@number"/>

  &lt;A NAME=&quot;<xsl:value-of select="concat('p',$part_num,'c',$chap_num)"/>&quot;&gt;&lt;/A&gt;
  &lt;A NAME=&quot;<xsl:apply-templates select="chapter_name"/>&quot;&gt;&lt;/A&gt;
&lt;H3&gt;
  Part <xsl:value-of select="$part_num"/> - 
  Chapter <xsl:value-of select="$chap_num"/> - <xsl:apply-templates select="chapter_name"/>
&lt;/H3&gt;  

      <xsl:for-each select="section">
	<xsl:sort select="@number" data-type="number"/>
	<xsl:variable name="sect_num" select="@number"/>

  &lt;A NAME=&quot;<xsl:value-of select="title"/>&quot;&gt;&lt;/A&gt;

 <xsl:value-of select="$part_num"/>.<xsl:value-of select="$chap_num"/>.<xsl:value-of select="$sect_num"/>.

  &lt;A HREF=&quot;<xsl:value-of select="concat('p',$part_num,'c',$chap_num, 's',$sect_num,'.html')"/>&quot;
    &gt;<xsl:apply-templates select="title"/>&lt;/A&gt;
  &lt;BR&gt;

	</xsl:for-each>
      </xsl:for-each>

&lt;/DIV&gt;
&lt;BR&gt;

    </xsl:for-each>

<!-- &lt;/TD&gt; -->
<!-- &lt;/TR&gt; -->
<!-- &lt;/TABLE&gt; -->



<!-- ____ alphabetical list of COMMANDS ___________________________ -->



&lt;A NAME=&quot;list&quot;&gt;&lt;/A&gt;


&lt;DIV CLASS=commands&gt;

&lt;H2&gt;
Alphabetical list of commands

&lt;BR&gt;

&lt;A HREF= "#A"&gt;A&lt;/A&gt;
&lt;A HREF= "#B"&gt;B&lt;/A&gt;
&lt;A HREF= "#C"&gt;C&lt;/A&gt;
&lt;A HREF= "#D"&gt;D&lt;/A&gt;
&lt;A HREF= "#E"&gt;E&lt;/A&gt;
&lt;A HREF= "#F"&gt;F&lt;/A&gt;
&lt;A HREF= "#G"&gt;G&lt;/A&gt;
&lt;A HREF= "#H"&gt;H&lt;/A&gt;
&lt;A HREF= "#I"&gt;I&lt;/A&gt;
&lt;A HREF= "#J"&gt;J&lt;/A&gt;
&lt;A HREF= "#K"&gt;K&lt;/A&gt;
&lt;A HREF= "#L"&gt;L&lt;/A&gt;
&lt;A HREF= "#M"&gt;M&lt;/A&gt;
&lt;A HREF= "#N"&gt;N&lt;/A&gt;
&lt;A HREF= "#O"&gt;O&lt;/A&gt;
&lt;A HREF= "#P"&gt;P&lt;/A&gt;
&lt;A HREF= "#Q"&gt;Q&lt;/A&gt;
&lt;A HREF= "#R"&gt;R&lt;/A&gt;
&lt;A HREF= "#S"&gt;S&lt;/A&gt;
&lt;A HREF= "#T"&gt;T&lt;/A&gt;
&lt;A HREF= "#U"&gt;U&lt;/A&gt;
&lt;A HREF= "#V"&gt;V&lt;/A&gt;
&lt;A HREF= "#W"&gt;W&lt;/A&gt;
&lt;A HREF= "#X"&gt;X&lt;/A&gt;
&lt;A HREF= "#Y"&gt;Y&lt;/A&gt;
&lt;A HREF= "#Z"&gt;Z&lt;/A&gt;
&lt;/H2&gt;


<xsl:call-template name="one_letter">
  <xsl:with-param name="initial">A</xsl:with-param>
</xsl:call-template>
  
<xsl:call-template name="one_letter">
  <xsl:with-param name="initial">B</xsl:with-param>
</xsl:call-template>
  
<xsl:call-template name="one_letter">
  <xsl:with-param name="initial">C</xsl:with-param>
</xsl:call-template>
  
<xsl:call-template name="one_letter">
  <xsl:with-param name="initial">D</xsl:with-param>
</xsl:call-template>
  
<xsl:call-template name="one_letter">
  <xsl:with-param name="initial">E</xsl:with-param>
</xsl:call-template>
  
<xsl:call-template name="one_letter">
  <xsl:with-param name="initial">F</xsl:with-param>
</xsl:call-template>
  
<xsl:call-template name="one_letter">
  <xsl:with-param name="initial">G</xsl:with-param>
</xsl:call-template>
  
<xsl:call-template name="one_letter">
  <xsl:with-param name="initial">H</xsl:with-param>
</xsl:call-template>
  
<xsl:call-template name="one_letter">
  <xsl:with-param name="initial">I</xsl:with-param>
</xsl:call-template>
  
<xsl:call-template name="one_letter">
  <xsl:with-param name="initial">J</xsl:with-param>
</xsl:call-template>
  
<xsl:call-template name="one_letter">
  <xsl:with-param name="initial">K</xsl:with-param>
</xsl:call-template>
  
<xsl:call-template name="one_letter">
  <xsl:with-param name="initial">L</xsl:with-param>
</xsl:call-template>
  
<xsl:call-template name="one_letter">
  <xsl:with-param name="initial">M</xsl:with-param>
</xsl:call-template>
  
<xsl:call-template name="one_letter">
  <xsl:with-param name="initial">N</xsl:with-param>
</xsl:call-template>
  
<xsl:call-template name="one_letter">
  <xsl:with-param name="initial">O</xsl:with-param>
</xsl:call-template>
  
<xsl:call-template name="one_letter">
  <xsl:with-param name="initial">P</xsl:with-param>
</xsl:call-template>
  
<xsl:call-template name="one_letter">
  <xsl:with-param name="initial">Q</xsl:with-param>
</xsl:call-template>
  
<xsl:call-template name="one_letter">
  <xsl:with-param name="initial">R</xsl:with-param>
</xsl:call-template>
  
<xsl:call-template name="one_letter">
  <xsl:with-param name="initial">S</xsl:with-param>
</xsl:call-template>
  
<xsl:call-template name="one_letter">
  <xsl:with-param name="initial">T</xsl:with-param>
</xsl:call-template>
  
<xsl:call-template name="one_letter">
  <xsl:with-param name="initial">U</xsl:with-param>
</xsl:call-template>
  
<xsl:call-template name="one_letter">
  <xsl:with-param name="initial">V</xsl:with-param>
</xsl:call-template>
  
<xsl:call-template name="one_letter">
  <xsl:with-param name="initial">W</xsl:with-param>
</xsl:call-template>
  
<xsl:call-template name="one_letter">
  <xsl:with-param name="initial">X</xsl:with-param>
</xsl:call-template>
  
<xsl:call-template name="one_letter">
  <xsl:with-param name="initial">Y</xsl:with-param>
</xsl:call-template>
  
<xsl:call-template name="one_letter">
  <xsl:with-param name="initial">Z</xsl:with-param>
</xsl:call-template>
  

&lt;/DIV&gt;

<!-- &lt;/BODY&gt; -->
<!-- &lt;/HTML&gt; -->
<!-- </xsl:document> -->





&lt;/BODY&gt;
&lt;/HTML&gt;

  </xsl:document>
  </xsl:template>
  
  <!-- ____  ______________________________________________ -->

  <xsl:template match="title"><xsl:apply-templates/></xsl:template>
  <xsl:template match="description"><xsl:apply-templates/></xsl:template>

  <xsl:template match="coc_version">
    <xsl:value-of select="/help/version/cocoa_version"/>
  </xsl:template>


  <xsl:template match="em">&lt;B&gt;<xsl:value-of select="."/>&lt;/B&gt;</xsl:template>

  <xsl:template match="coc-quotes">&quot;<xsl:apply-templates/>&quot;</xsl:template>


  <xsl:template match="code">&lt;code&gt;<xsl:apply-templates/>&lt;/code&gt;</xsl:template>

  <xsl:template match="lt">&amp;lt;</xsl:template>
  <xsl:template match="less_eq">&amp;lt;=</xsl:template>
  <xsl:template match="tilde">~</xsl:template>
  <xsl:template match="dollar">$</xsl:template>
  <xsl:template match="ocb">{</xsl:template>
  <xsl:template match="ccb">}</xsl:template>
   <xsl:template match="times"> x </xsl:template>
  <xsl:template match="_">_</xsl:template>

  <xsl:template match="ref">&quot;<xsl:apply-templates/>&quot;</xsl:template>

  <xsl:template match="example">
    &lt;h2&gt;example&lt;/h2&gt;
    &lt;pre&gt;
    <xsl:apply-templates/>
    &lt;/pre&gt;
  </xsl:template>

  <xsl:template match="see">
    &lt;h2&gt;See also&lt;/h2&gt;
    &lt;pre&gt;
    <xsl:apply-templates/>
    &lt;/pre&gt;
  </xsl:template>

  <xsl:template match="coc_date">
    <xsl:value-of select="/help/version/date"/>
  </xsl:template>

  <xsl:template match="verbatim">&lt;PRE&gt;<xsl:apply-templates/>&lt;/PRE&gt;</xsl:template>

<xsl:template name="one_letter">
  <!-- default value... never used -->
  <xsl:param name="initial" select="A"/>
  &lt;A NAME= "<xsl:value-of select="$initial"/>"&gt;&lt;/A&gt;
  &lt;H2&gt;<xsl:value-of select="$initial"/>&lt;/H2&gt;

    <xsl:for-each select="cocoa_commands/command">
      <xsl:sort select="title"/>
      <xsl:if test="substring(title,1,1)=$initial">
	&lt;A NAME= &quot;<xsl:value-of select="title"/>&quot;&gt;
	&lt;A HREF=
	&quot;cmd<xsl:value-of select="position()"/>.html&quot;
	&gt;&lt;B&gt;<xsl:apply-templates select="title"/>&lt;/B&gt;&lt;/A&gt;
	--
	<xsl:apply-templates select="short_description"/>
	&lt;BR&gt;
      </xsl:if>      
    </xsl:for-each>
</xsl:template>

<!-- ===== -->

</xsl:stylesheet> 

