/* arpoly.h */

/* [ MONOPOLI ] [ TRIPOLI ] [ EEE ] TODO */

#ifndef ARPOLY_H

arpoly 	arpoly_der_nn(arpoly p, int * der_list, ring R);
coc_bool arpoly_is_zero(arpoly p, ring R);
coc_bool 	arpoly_is_one(arpoly p, ring R);
arpoly 	arpoly_homog(arpoly p, unknown x, ring R);
coc_bool 	arpoly_div(arpoly f, arpoly g, arpoly * q, arpoly * r, ring R);
arpoly 	arpoly_power(arpoly p, expType exp, ring R);
arpoly 	arpoly_full_support_of_degree(int deg, ring R);
arpoly 	arpoly_sub_these(arpoly p1, arpoly p2, ring R);
int 	this_arpoly2int(arpoly p, ring R);
arbint 	this_arpoly2arbint(arpoly p, ring R);
arbrat 	this_arpoly2arbrat(arpoly p, ring R);
arpoly 	cterm2arpoly(cterm t, ring R);
unknown arpoly2indet(arpoly p, ring R);

#define int2arpoly(n,R) 	this_coeff2arpoly(int2coeff(n,R),R)
#define arpoly_one(R) 		this_coeff2arpoly(coeff_one(R),R)
#define arpoly_x_coeff(p,c,R) 	arpoly_this_x_coeff(arpoly_dup(p,R),c,R)

#define arpoly_is_const(p,R) ((p)==NULL || arpoly_is_nonzero_const(p,R))
#define arpoly_plus_mxp(p,m,p1,R) \
  arpoly_sum_these(p,arpoly_x_monomial(p1,m,R),R)

/* -------[ MONOPOLI ]--------------------*/

#ifdef ARPOLY_MONOPOLI

#define pvcomp2arpoly(p,R) 	pvcomp2monopoli(p,R)
#define this_pvcomp2arpoly(p,R) 	this_pvcomp2monopoli(p,R)
#define arpoly2monopoli(p,R) 	monopoli_dup(p,R)
#define this_arpoly2monopoli(p,R) 	(p)
#define arpoly2eee(p,R) 	monopoli2eee(p,R)
#define this_arpoly2eee(p,R) 	this_monopoli2eee(p,R)
#define arpoly2tripoli(p,R) 	monopoli2tripoli(p,R)
#define this_arpoly2tripoli(p,R) 	this_monopoli2tripoli(p,R)

#define arpoly_dup(p,R) 	monopoli_dup(p,R)
#define arpoly_map(p,R,S,m) 	monopoli_map(p,R,S,m)
#define arpoly_der(p,x,R) 	monopoli_der(p,x,R)
#define arpoly_deg(p,R) 	monopoli_deg(p)
#define arpoly_ispurelt(p) 	monopoli_ispurelt(p)
#define arpoly_mult(p,q,R) 	monopoli_mult(p,q,R)
#define arpoly_eq(p,q,R) 	monopoli_eq(p,q,R)
#define arpoly_free(p,R) 	monopoli_free(p,R)
#define arpoly_mdeg(p,R) 	monopoli_mdeg(p,R)
#define arpoly_size(p,R) 	monopoli_size(p,R)
#define arpoly_is_homog(p,R) 	monopoli_is_homog(p,R)
#define arpoly_sum(p,q,R) 	monopoli_sum(p,q,R)
#define arpoly_len(p,R) 	monopoli_len(p)
#define arpoly_square(p,R) 	monopoli_square(p,R)
#define arpoly2cterm(p,R)	monopoli2cterm(p,R)
#define arpoly2sppnum(p,R)	monopoli2sppnum(p,R)
#define arpoly_x_monomial(p,m,R)	monopoli_x_monomial(p,m,R)
#define arpoly_leading_term(p,R) 	monopoli_leading_term(p)
#define arpoly_change_sign(p,R) 	monopoli_change_sign(p,R)
#define arpoly_leading_monomial(p,R) 	monopoli_leading_monomial(p,R)
#define arpoly_this_leading_coeff(p,R) 	monomial_coeff(p)
#define arpoly_this_term2arpoly(t,R) 	monopoli_this_term2monopoli(t,R)
#define arpoly_sum_these(p,q,R) 	monopoli_sum_these(p,q,R)
#define arpoly_this_x_term(p,t,R)	monopoli_this_x_term(p,t,R)
#define arpoly_leading_coeff(p,R) 	monopoli_leading_coeff(p,R)
#define arpoly_only_leading_term(p,R) 	monopoli_only_leading_term(p,R)
#define arpoly_is_nonzero_const(p,R) 		monopoli_is_nonzero_const(p,R)
#define arpoly_this_monomial2arpoly(m,R) 	this_monomial2monopoli(m,R)
#define this_arbint2arpoly(n,R)		this_coeff2monopoli(this_arbint2coeff(n,R),R)
#define arbint2arpoly(n,R) 		this_coeff2monopoli(arbint2coeff(n,R),R)
#define arpoly_unknown_pow2arpoly(u,n,R) 	unknown_pow2monopoli(u,n,R)
#define arpoly_unknown2arpoly(u,R) 		unknown_pow2monopoli(u,1,R)
#define this_coeff2arpoly(c,R) 		this_coeff2monopoli(c,R)
#define arpoly_randomize(p,R) 			monopoli_randomize(p,R)
#define arpoly_this_x_coeff(p,c,R) 		monopoli_this_x_coeff(p,c,R)
#define arpoly_add_this_monomial(p,m,R) 	monopoli_add_this_monomial(p,m,R)
#define arpoly_this_minus_term_x_arpoly(p,t,q,R)	monopoli_this_minus_term_x_monopoli(p,t,q,R)
#define arpoly_this_plus_term_x_arpoly(p,t,q,R)		monopoli_this_plus_term_x_monopoli(p,t,q,R)
#define arpoly_this_minus_term_x_arpoly_truncated(p,t,q,n,R) 	monopoli_this_minus_term_x_monopoli_truncated(p,t,q,n,R)
#define arpoly_this_plus_term_x_arpoly_truncated(p,t,q,n,R) 	monopoli_this_plus_term_x_monopoli_truncated(p,t,q,n,R)


/* -------[ TRIPOLI ]---------------------*/

#elif defined(ARPOLY_TRIPOLI)

#define pvcomp2arpoly(p,R) 		pvcomp2tripoli(p,R)
#define this_pvcomp2arpoly(p,R) 	this_pvcomp2tripoli(p,R)

#define arpoly2eee(p,R) 		tripoli2eee(p,R)
#define this_arpoly2eee(p,R) 	this_tripoli2eee(p,R)
#define arpoly2tripoli(p,R) 		tripoli_dup(p,R)
#define this_arpoly2tripoli(p,R) 	(p)
#define arpoly2monopoli(p,R)		tripoli2monopoli(p,R)
#define this_arpoly2monopoli(p,R)		this_tripoli2monopoli(p,R)

#define arpoly_dup(p,R) 	tripoli_dup(p,R)
#define arpoly_map(p,R,S,m) 	tripoli_map(p,R,S,m)
#define arpoly_der(p,x,R) 	tripoli_der(p,x,R)
#define arpoly_deg(p,R) 	tripoli_deg(p,R)
#define arpoly_mult(p,q,R) 	tripoli_mult(p,q,R)
#define arpoly_eq(p,q,R) 	tripoli_eq(p,q,R)
#define arpoly_free(p,R) 	tripoli_free(p,R)
#define arpoly_mdeg(p,R) 	tripoli_mdeg(p,R)
#define arpoly_size(p,R) 	tripoli_size(p,R)
#define arpoly_is_homog(p,R) 	tripoli_is_homog(p,R)
#define arpoly_sum(p,q,R) 	tripoli_sum(p,q,R)
#define arpoly_len(p,R) 	tripoli_len(p,R)
#define arpoly_square(p,R) 	tripoli_square(p,R)
#define arpoly2cterm(p,R)	tripoli2cterm(p,R)
#define arpoly2sppnum(p,R)	tripoli2sppnum(p,R)
#define arpoly_x_monomial(p,m,R)	tripoli_x_monomial(p,m,R)
#define arpoly_leading_term(p,R) 	tripoli_leading_term(p,R)
#define arpoly_change_sign(p,R) 	tripoli_change_sign(p,R)
#define arpoly_leading_monomial(p,R) 	tripoli_leading_monomial(p,R)
#define arpoly_this_leading_coeff(p,R) 	tripoli_this_leading_coeff(p,R)
#define arpoly_this_term2arpoly(t,R) 	this_term2tripoli(t,R)
#define arpoly_sum_these(p,q,R) 	tripoli_sum_these(p,q,R)
#define arpoly_this_x_term(p,t,R)	tripoli_this_x_term(p,t,R)
#define arpoly_leading_coeff(p,R) 	tripoli_leading_coeff(p,R)
#define arpoly_only_leading_term(p,R) 	tripoli_only_leading_term(p,R)
#define arpoly_is_nonzero_const(p,R) 		tripoli_is_nonzero_const(p,R)
#define arpoly_this_monomial2arpoly(m,R) 	this_monomial2tripoli(m,R)
#define this_arbint2arpoly(n,R)			this_coeff2tripoli(this_arbint2coeff(n,R),R)
#define arbint2arpoly(n,R) 			this_coeff2tripoli(arbint2coeff(n,R),R)
#define arpoly_unknown_pow2arpoly(u,n,R) 	unknown_pow2tripoli(u,n,R)
#define arpoly_unknown2arpoly(u,R) 		unknown_pow2tripoli(u,1,R)
#define this_coeff2arpoly(c,R) 		this_coeff2tripoli(c,R)
#define arpoly_randomize(p,R) 			tripoli_randomize(p,R)
#define arpoly_this_x_coeff(p,c,R) 		tripoli_this_x_coeff(p,c,R)
#define arpoly_add_this_monomial(p,m,R) 	tripoli_add_this_monomial(p,m,R)
#define arpoly_this_minus_term_x_arpoly(p,t,q,R)	tripoli_this_minus_term_x_tripoli(p,t,q,R)
#define arpoly_this_plus_term_x_arpoly(p,t,q,R)		tripoli_this_plus_term_x_tripoli(p,t,q,R)
#define arpoly_this_minus_term_x_arpoly_truncated(p,t,q,n,R) 	tripoli_this_minus_term_x_tripoli_truncated(p,t,q,n,R)
#define arpoly_this_plus_term_x_arpoly_truncated(p,t,q,n,R) 	tripoli_this_plus_term_x_tripoli_truncated(p,t,q,n,R)


/* -------[ EEE ]-------------------------*/

#elif defined(ARPOLY_EEE)

#define pvcomp2arpoly(p,R) 		pvcomp2eee(p,R)
#define this_pvcomp2arpoly(p,R) 	this_pvcomp2eee(p,R)
#define arpoly2eee(p,R) 		eee_dup(p,R)
#define this_arpoly2eee(p,R) 	(p)
#define arpoly2monopoli(p,R)		eee2monopoli(p,R)
#define this_arpoly2monopoli(p,R)		this_eee2monopoli(p,R)

#define arpoly_dup(p,R) 	eee_dup(p,R)
#define arpoly_map(p,R,S,m) 	eee_map(p,R,S,m)
#define arpoly_der(p,x,R) 	eee_der(p,x,R)
#define arpoly_deg(p,R) 	eee_deg(p,R)
#define arpoly_mult(p,q,R) 	eee_mult(p,q,R)
#define arpoly_eq(p,q,R) 	eee_eq(p,q,R)
#define arpoly_free(p,R) 	eee_free(p,R)
#define arpoly_mdeg(p,R) 	eee_mdeg(p,R)
#define arpoly_size(p,R) 	eee_size(p,R)
#define arpoly_is_homog(p,R) 	eee_is_homog(p,R)
#define arpoly_sum(p,q,R) 	eee_sum(p,q,R)
#define arpoly_len(p,R) 	eee_len(p,R)
#define arpoly_square(p,R) 	eee_square(p,R)
#define arpoly2cterm(p,R)	eee2cterm(p,R)
#define arpoly2sppnum(p,R)	eee2sppnum(p,R)
#define arpoly_x_monomial(p,m,R)	eee_x_monomial(p,m,R)
#define arpoly_leading_term(p,R) 	eee_leading_term(p,R)
#define arpoly_change_sign(p,R) 	eee_change_sign(p,R)
#define arpoly_leading_monomial(p,R) 	eee_leading_monomial(p,R)
#define arpoly_this_leading_coeff(p,R) 	eee_this_leading_coeff(p,R)
#define arpoly_this_term2arpoly(t,R) 	this_term2eee(t,R)
#define arpoly_sum_these(p,q,R) 	eee_sum_these(p,q,R)
#define arpoly_this_x_term(p,t,R)	eee_this_x_term(p,t,R)
#define arpoly_leading_coeff(p,R) 	eee_leading_coeff(p,R)
#define arpoly_only_leading_term(p,R) 	eee_only_leading_term(p,R)
#define arpoly_is_nonzero_const(p,R) 		eee_is_nonzero_const(p,R)
#define arpoly_this_monomial2arpoly(m,R) 	this_monomial2eee(m,R)
#define this_arbint2arpoly(n,R)			this_coeff2eee(this_arbint2coeff(n,R),R)
#define arbint2arpoly(n,R) 			this_coeff2eee(arbint2coeff(n,R),R)
#define arpoly_unknown_pow2arpoly(u,n,R) 	unknown_pow2eee(u,n,R)
#define arpoly_unknown2arpoly(u,R) 		unknown_pow2eee(u,1,R)
#define this_coeff2arpoly(c,R) 		this_coeff2eee(c,R)
#define arpoly_randomize(p,R) 			eee_randomize(p,R)
#define arpoly_this_x_coeff(p,c,R) 		eee_this_x_coeff(p,c,R)
#define arpoly_add_this_monomial(p,m,R) 	eee_add_this_monomial(p,m,R)
#define arpoly_this_minus_term_x_arpoly(p,t,q,R)	eee_this_minus_term_x_eee(p,t,q,R)
#define arpoly_this_plus_term_x_arpoly(p,t,q,R)		eee_this_plus_term_x_eee(p,t,q,R)
#define arpoly_this_minus_term_x_arpoly_truncated(p,t,q,n,R) 	eee_this_minus_term_x_eee_truncated(p,t,q,n,R)
#define arpoly_this_plus_term_x_arpoly_truncated(p,t,q,n,R) 	eee_this_plus_term_x_eee_truncated(p,t,q,n,R)

#else
# error "Undefined ARPOLY macro"

#endif

#endif /* ARPOLY_H */
