/* $Id: auxtypes.h,v 4.4.1.1 2004/06/18 14:24:25 cocoa Exp $ */

#ifndef AUXTYPES_H
#define AUXTYPES_H

#include <limits.h>
#include <stdio.h>
#include "cocdefs.h"

/* ====================================== */

/* mutually RECURSIVE types */

typedef struct cterm_node_aux *cterm;

/* -----------[ charbuf ]-------------- */

typedef struct charbuf_info * charbuf;

typedef struct charbuf_info {
  char * buffer;
  int size;
  int len;
  int blocksize;
} charbuf_info;


/* -----------[ utils ]-------------- */

typedef char ** charstars;

typedef int coc_bool;

#define deg_NULL INT_MAX

/* bool_NULL is for errors */
#define FALSE 0
#define TRUE 1
#define bool_NULL 2

#define ZERO 0

/* MultiVariate Hilbert */

#define MVP_RING_NAME "MVP"
#define MVP_RESULT_ID "LAST_PS"

/* MATH OPTIONS */

#define trunc_NONE INT_MAX

/* Miscellaneous OPTIONS */

#define NOT_COMPUTED -2
#define ANSWER_EQ 0
#define ANSWER_BOTH 0
#define ANSWER_FIRST 1
#define ANSWER_SECOND 2
#define ANSWER_NC 3

#define ZP_MAX SHRT_MAX

/* -----------[ ivector ]-------------- */

#define iv_NULL NULL

typedef  int  iv_elem;

typedef  iv_elem    * ivector;
/* v[0] = len(v) */
/* v[1] = sum of components(v) */

/* -----------[ ivec ]-------------- */

typedef iv_elem ivec_elem;
typedef ivec_elem * ivec;

#define ivec_NULL NULL

/* -----------[ map ]-------------- */

typedef char * nome;
typedef nome * map;

/* m[0]=last_id(m) */
/* m[1]=size(m) */

#define map_NULL NULL
#define name_NULL NULL
#define name_id_NULL (-1)
#define first_name_id 2

#define SIZE_OF_MAP_BLOCK 100

#define name_id int

/* -----------[ pipe ]-------------- */

typedef struct pipe_aux *coc_pipe;

typedef int * pipe_elem;

/* the hope is that NULL is not a valid pipe_elem */
#define pipe_elem_NULL NULL
#define pipe_cork NULL
#define pipe_NULL NULL

typedef struct pipe_atom_aux *pipe_atom;

typedef struct pipe_atom_aux {
  pipe_atom l; /* the pipe_atom to the left of this */
  pipe_atom r; /* the pipe_atom to the right of this */
  pipe_elem e; /* the pipe_element contained in this pipe_atom */
} pipe_atom_info;

typedef struct pipe_aux {
  pipe_atom lm; /* leftmost pipe_atom of this pipe */
  pipe_atom rm; /* rightmost pipe_atom of this pipe */
  int len;
} pipe_info;

/* -----------[ rum ]-------------- */

/* nothing */

/* -----------[ sbitsets ]-------------- */

typedef unsigned long bs_subset;
typedef bs_subset shortbitset;

/* -----------[ options ]-------------- */

typedef int opt_type;

typedef int opt_value;

typedef struct
{
  opt_type t; 
  /* - t=-2 => the option is a flag (flag_ON/flag_OFF)
     - t=-1 => the option is a numeric value
     - t=N  => the option is enumerative */
  opt_value v;
  char * d; /* description */
  charstars vd; /* values descriptions (only for enumerative) */
} opt_entry;

typedef opt_entry * opt_panel;

#define opt_panel_NULL NULL

typedef int opt_id;

typedef int optv_id;
#define opt_id_NULL ZERO

#define flagstatus opt_value

#define flag_OFF 0
#define flag_ON 1

#define opt_type_PANEL -3
#define opt_type_FLAG -2
#define opt_type_NUM -1
#define opt_type_ENUM 0
/* opt_type(p,o) could be greater of opt_type_ENUM */


/* ====================================== */

/* -----------[ matrix ]-------------- */

#define matrix_el int

typedef matrix_el* matrix_row;
typedef matrix_row* matrix;

typedef struct submat_aux * submat;

typedef struct submat_aux 
{
  matrix elems;
  int m,n; /* num of rows, num of columns */
  ivector rr; /* rows indices */
  ivector cc; /* columns indices */
} submat_info;

#define matrix_NULL NULL

/* ====================================== */

/* -----------[ ck ]-------------- */

typedef struct ring_el * ring;
typedef struct object_info * object;
typedef object ck_handler(cterm t, ring R);

/* -----------[ coop ]-------------- */

typedef int coop;

typedef struct op_info_aux * op_info;

typedef struct op_info_aux {
  int arity;
  /* object (* handler)(); */
  cterm handler;
  char * help;
} op_info_aux;

/* -----------[ cterm ]-------------- */

typedef cterm *cterm_list; /* cterm_list is terminated by NULL */

typedef struct cterm_node_aux cterm_node;

struct cterm_node_aux{
  coop op; /* the coop number (OP_NBS if it is an NBS) */
  char * string; /* a zero-arity coop not better specified */
  int arity;
  cterm_list params;
};

#define cterm_NULL NULL


/* -----------[ ctbuf ]-------------- */

typedef coc_pipe ctbuf;

#define ctbuf_NULL pipe_NULL

#endif
