/* $Id: ck.h,v 4.4.1.1 2004/06/18 14:24:25 cocoa Exp $ */

#include "cocdefs.h"
#include "coctypes.h"

/*

[ ck PUBLIC ] [ option panels ]

*/

#define ck_NOERR 0
#define ck_ERR_example 1000
#define ck_ERR_interrupted 1000

extern ring ring_Z,ring_Q,ring_ShZ;
extern env current_env, cocoa_env, ring_env, panels_env, memory_env, pkg_env;
extern env cdev_env, err_env;
extern cterm cterm_newline, cterm_dashes;
extern ctbuf comp_stack;

extern gmp_randstate_t GMP_RANDSTATE;
extern int GMP_RANDSIZE;


/* ---[ coops ]-------------------------------------------- */

extern ck_handler * ck_handlers[MAX_NUM_OPERATORS];

extern coop op_POLYNOMIAL,
op_MAT, op_FLOAT, op_ZPVALUE, op_ZP, op_SHORT_INT, op_BREAK,
op_SHORT_RAT, op_SHORT_DOUBLE, op_LONG_INT, op_LONG_RAT, op_DASHES, 
op_MEM_STAT,
#ifdef DEBUG
op_OBJECTS,
#endif
#ifdef RUM_DEBUG
op_RUM_STAT,
#endif
op_PANELS, op_MEMORY, op_HANDLER, op_ERROR, op_MKERR,
op_PAIR, op_IDEAL, op_GLOBAL_MEMORY, op_objtype_NULL, 
op_objtype_coeff, op_objtype_ring, op_objtype_poly, op_objtype_bool, 
op_objtype_cterm, op_objtype_int, op_objtype_ideal, op_objtype_cocfun,
op_objtype_pvector, op_objtype_vlist, op_objtype_string, op_objtype_module, 
op_objtype_pseries, op_objtype_objtype, op_objtype_mat, 
op_objtype_olist, op_objtype_omat, op_objtype_ratfun, op_objtype_panel, 
op_objtype_err, op_objtype_arbint, op_objtype_arbrat, op_objtype_record, 
op_objtype_zp, op_objtype_double, op_objtype_tagged, op_objtype_cdev,
op_CURR_RING, op_ISDEF, op_PROGRAM2, op_BUILTIN,
op_INDET_NTH, op_LEX, op_XEL, op_DEGLEX, op_DEGREVLEX, op_POS_TO, op_TO_POS, 
op_LEVEL, op_ORD, op_WEIGHTS, op_ENV, op_ENV_SLOT, op_MODULE, op_MONOMIAL, 
op_OBJECT, op_VECTOR, op_RATFUN, op_TERM, op_EEE, op_EEE_MON, op_EEE_LBL,
op_TRIPOLI, op_HOMO, op_CLASSIC, op_SCALARS, op_MON, op_AT;

extern coop op_ALIAS,
op_ALIASES, op_ALIAS_CMD, op_ALIAS_IN, op_ALL, op_AND, op_ADD_DEVICE,
op_ASSIGN, op_CARTESIAN, op_CATCH, op_CHANGE_SIGN, op_CLEAR,
op_CLOSE, op_CIP,
op_CLOSELOG, op_COLON, op_COMMANDS, op_COMPONENT, op_COND, op_CALL,
op_DEFINE_AND_USE_RING, op_DEFINE_RING, op_DELETE_RINGS, op_DELETE_VARS, 
op_DESCRIBE, op_DOTS, op_ELIM, op_EOF, op_EOD,
op_EVAL, op_EXPORT, op_FOR, op_FOREACH, op_FUNCTION, 
op_FRAC, op_FUN_APPL, op_FLUSH,
op_HELP, op_IF, op_IMPORT, op_INIT_CDEV, op_INDET,
op_INDET_DECL, op_INDET_INFO, op_IS_EQ, op_IS_GE, op_IS_GT, op_IS_IN, op_IS_LE, 
op_IS_LT, op_MULT, op_NEWLINE, op_NOT, op_NULL_VALUE, op_OPENLOG, op_OR,
op_OPTION, op_MAP,
op_PACKAGE, op_PARENTHESIS, op_PKG_ID, op_POLY_RING, op_POWER, op_PRINT, 
op_PRINTON, op_PRINTON_AND_CR, op_PRINT_AND_CR, op_PROGRAM, op_QUIT, op_RANGE,
op_REMOVE_DEVICE, op_PACKAGES,
op_RECORD, op_RECORDSEL, op_REPEAT, op_RETURN, op_RING_MODIFIERS, op_RING_ZP, 
op_SET, op_SET_CURRENT_RING, op_SKIP, op_SOURCE, op_SUBTRACT, op_SUM, 
op_TERROR, op_TIME, op_UNLABEL, op_VAR, op_WHILE, op_ZPMK, op_PANEL_CMD,
op_SHIFTS;

extern coop op_RING, op_LIMITS,
op_ADJOINT, op_APPEND, op_REMOVE, op_CAST, op_CHAR, op_CONCAT, op_DATE, op_DEG,
op_DENSE_POLY, op_DER, op_DET, op_DIV, op_FACT, op_FACTOR, op_GCD, op_GB_ALL, op_MDEG,
op_GB_INIT, op_GB_ONE_MOVE, op_GB_STAT,
op_GENS, op_HEAD, op_HOMOG, op_INDET_IND, op_INDET_INDEX, op_INDET_NAME,
op_LABEL, op_LEADING_COEFF, 
op_LEADING_TERM, op_LEN, op_LISTCAST, op_LOG, op_MINIMALIZE, op_MINORS, op_MOD,
op_MVPOINCARE, op_NEWLIST, op_NEWMAT, op_NEWVECTOR, op_NEXTPRIME, op_MOD2RAT,
op_NUM_INDETS, op_PLATFORM, op_POINCARE, op_POLY, op_POLY_VERSION, op_RANDOMIZE,
op_RES, op_SHOW_ALIASES, op_SIZE, op_STARTING, op_SUBST, op_SYZ, op_SYSTEM,
op_TAG, op_TAIL, op_TAO, op_TYPEOF, op_FIELDS, op_IS_HOMOG, op_IS_RING_INDEP,
op_COCOLON, op_USING;

extern coop op_SUPPORT, op_MONOMIALS, op_COEFFS,
op_ISPOSTO, op_ISTOPOS, op_FIRSTNONZERO, op_FIRSTNONZEROPOS, op_ISTERM, op_LPOS,
op_LPP, op_LM, op_COEFFOFTERM, op_NR, op_NEWPPSTREAM, op_NEXTPP, op_AVOIDLASTPP;

/* ---[ ck PUBLIC ]----------------------------------------------- */

#define ck_NOERR 0

int ck_init(void);
int ck_engine_top(cterm t);
int ck_engine(cterm t);
int ck_source_top(cdev D);
int ck_source(cdev D);
int ck_source_from_string(const char * s);
int ck_engine_test(cterm t);
void ck_continue(void);
coc_bool ck_finished(void);
void ck_quit(void);

/* ---[ option panels ]-------------------------------------------- */

extern opt_panel opt_panel_DEBUG;
extern opt_id flag_DEBUG_MEM,flag_DEBUG_OBJ,flag_DEBUG_MEMFILE,
  opt_DEBUG_EEE_PP, flag_SHOW_TODO, flag_SHOW_OPTIMIZE, flag_DEBUG_GB,
  flag_DEBUG_FASTSOURCE, flag_SHOW_OBJNUM;
extern opt_value optv_DEBUG_EEE_PP_GRAPH1, optv_DEBUG_EEE_PP_GRAPH2, 
  optv_DEBUG_EEE_PP_NORMAL;

#ifdef DEBUG
extern opt_panel opt_panel_MONITOR;
extern opt_id flag_MON_GB_STATUS;
extern opt_id flag_MON_GB_SPOLY, flag_MON_GB_REDUNDANT_POLY,
  flag_MON_GB_KILLED_PAIRS,flag_MON_GB_SKIPPED_PAIRS, flag_MON_GBASIS;
#endif

extern opt_panel opt_panel_ENGINE;
extern opt_id flag_ENGINE_ECHO, 
  flag_ENGINE_TRACE, flag_ENGINE_TIMER, flag_ENGINE_MEMORY,
  flag_ENGINE_INDENT, flag_ENGINE_TRACE_SOURCES, flag_ENGINE_WARNINGS,
  flag_ENGINE_COMP_STACK, flag_ENGINE_NO_ERROR_CONTEXT;

#ifdef PRETTY_EXPONENTS
extern opt_id flag_ENGINE_PP_EXP;
#endif

extern opt_panel opt_panel_INTERNAL;
extern opt_id flag_ENGINE_EXIT;

extern opt_panel opt_panel_GROBNER;

extern opt_id flag_GB_SUGAR, flag_GB_RED_FULL, flag_GB_STEP, flag_GB_VERBOSE;

extern opt_panel opt_panel_IMATH;

extern opt_id opt_IM_INS_TYPE;
extern opt_value optv_IM_INS_TYPE_AT_END, optv_IM_INS_TYPE_BY_LEN, 
  optv_IM_INS_TYPE_BY_ECART;

extern opt_id flag_IM_SUGAR;

extern opt_panel opt_panel_INTERNAL;
extern opt_id flag_ENGINE_EXIT;
