/* coc_mac.c : 0.1 : 4 Oct 93 : cocoa MAC dependent functions */	

/*-------------------------------------------------------------------------

	part of project cocoa

	revision history

--------------------------------------------------------------------------*/

#include "cocdefs.h"

#ifndef MACHINE_H
#include "machine.h"
#endif

#ifndef UTILS_H
# include "utils.h"
#endif

#ifndef IO_H
# include "io.h"
#endif

#ifdef COCOA3MAC
#ifndef MACINTF_H
# include "macIntf.h"
#endif
#endif

#include <time.h>

#ifndef LINE_LENGTH
#define LINE_LENGTH 80
#endif

void get_time(long int * t)
{
  *t = (long int)clock();
}

void cocoa_display_elapsed_time(long int t)
{
  char aux_s[100];
  double aux_t;
  aux_t=(double)t/CLOCKS_PER_SEC;
	/* SC sprintf(&aux_s[0],"(elapsed time: %4.2f s)",aux_t);*/
  sprintf(&aux_s[0],"(elapsed time: %4.2f s)",aux_t);
  cocoa_message(aux_s);
}

void get_cputime(long int * t) {}

void cocoa_display_elapsed_cputime(long int t) {}

void cocoa_display_elapsed_time_cputime(long int t,long int ct)
{
  char aux_s[100];
  double aux_t;
  aux_t=(double)t/CLOCKS_PER_SEC;
	/* SC sprintf(&aux_s[0],"(elapsed time: %4.2f s)",aux_t);*/
  sprintf(&aux_s[0],"(elapsed time: %4.2f s)",aux_t);
  cocoa_message(aux_s);
}


void my_fputs_format(char *s, FILE * f, int width)
{
  static int counter=0;
  int l=strlen(s);
  char * aux_s=s;
	char * aux_s1;
	
  if (counter + l<=width) {
    fputs(aux_s,f);
    if (aux_s[strlen(aux_s)-1]=='\n') counter = 0;
    else counter+=l; }
  else {
    int d;
   
		aux_s1 = malloc_str(width);
    aux_s1[width]='\0';
		
    d = width-counter;
    strncpy(aux_s1,aux_s,d);
    aux_s1[d]='\0';
    fputs(aux_s1,f);
    fputs("\n",f);
    aux_s+=d;
    while (strlen(aux_s)>width) {
      strncpy(aux_s1,aux_s,width);
      fputs(aux_s1,f);
      fputs("\n",f);
      aux_s+=width; }
		free_str(width, aux_s1);
    fputs(aux_s,f);
    if (aux_s[strlen(aux_s)-1]=='\n') counter = 0;
    else counter = strlen(aux_s); }
}


void my_fputs(char *s, FILE * f)
{
  if (f == stdout || f == stderr) {
#ifndef COCOA3MAC
    my_fputs_format(s,f, LINE_LENGTH);
		
#else
    oi_buffer_append(s);
		my_fflush(NULL);

#endif
	} else if ( f == NULL ) {
	  oi_buffer_append(s);
	} else {
	  my_fputs_format(s,f,LINE_LENGTH);
	}
}



void my_fflush(FILE * f)
{
  if (f == NULL) {
	
#ifndef COCOA3MAC

     my_fputs(oi_buffer, stdout);

#else

    TEHandle textH;
		short slEnd;
		short	oldLines, newLines;
		GrafPtr	savePort;

			GetPort(&savePort);
			SetPort(curOutWindow);
			textH = GetTextH(curOutWindow);
			slEnd = (*textH)->selEnd;
			oldLines = (*textH)->nLines;
			TESetSelect(slEnd, slEnd, textH);
			TEInsert ((void*)oi_buffer, strlen(oi_buffer), textH);
			newLines = (*textH)->nLines;
			if (oldLines != newLines) {
				AdjustScrollBar(curOutWindow);
				ShowSelection(curOutWindow);
			}
			SetPort(savePort);
			if (strlen(oi_buffer) > 0)
				SetChangedFlag(curOutWindow, TRUE);

#endif
     oi_buffer_empty();
		
  } else {
    fflush(f);
  }
}


char expchar2digit(char c)
{
  switch (c) {
	case '\301' : return '1';
	case '\252' : return '2';
	case '\243' : return '3';
	case '\242' : return '4';
	case '\260' : return '5';
	case '\244' : return '6';
	case '\246' : return '7';
	case '\245' : return '8';
	case '\273' : return '9';
	case '\274' : return '0';
	case '\320' : return '-';
	default: return c; }
}

char * expnum(char * s)
{
  char * res_s, * dup;
  res_s = dup = malloc_str(strlen(s));
	while (*s!='\0')
	  *dup++ = expchar2digit(*s++);
	*dup='\0';
	return res_s;
}


char digit2expchar(char c)
{
  switch (c) {
	case '1' : return '\301';
	case '2' : return '\252';
	case '3' : return '\243';
	case '4' : return '\242';
	case '5' : return '\260';
	case '6' : return '\244';
	case '7' : return '\246';
	case '8' : return '\245';
	case '9' : return '\273';
	case '0' : return '\274';
	case '-' : return '\320';
	default: return c; }
}

void numexp(char * s, char res_s[])
{
  char * dup;
	dup = &res_s[0];
  while (*s!='\0')
	  *dup++ = digit2expchar(*s++);
	*dup='\0';
}



