/* $id */
/* UNIX dependent functions */

#include "cocdefs.h"

#ifndef MACHINE_H
# include "machine.h"
#endif

#include <sys/times.h>
#include <sys/time.h>
#include <sys/resource.h>
#include <stdlib.h>
#include <unistd.h>

#include "utils.h"
#include "cterm.h"
#include "operator.h"


char * build_path(char * p /* slash separated path */)
{
  return my_strdup(p);
}

char * get_date(char * fmt)
{
  clock_t c;
  char buffer[100];
  c=time(NULL);
  if (*fmt == '\0') 
    strftime (buffer, 100, "%c", localtime(&c));
  else
    strftime (buffer, 100, fmt, localtime(&c));
  return my_strdup(buffer);
}

void get_time(clock_t * t)
{
  *t = (clock_t)time(NULL);
}

void get_cputime(clock_t * t) /* expressed in thousandths of seconds */
{
  struct rusage used;
  double cpu;

  getrusage(RUSAGE_SELF, &used);
  cpu = used.ru_utime.tv_sec + used.ru_utime.tv_usec/1.0e6;
  *t = 100*cpu+0.5; /* 100 here tallies with 100 in coclib.cpkg: Print_Time */
}

clock_t cputime_diff(clock_t t1, clock_t t2)
{
  return (t1-t2);
}

void my_fflush(FILE * f)
{
  fflush(f);
}

void my_fputs(char *s, FILE * f)
{
  fputs(s,f);
}
