/* $Id: cocfun.c,v 4.4.1.1 2004/06/18 14:24:25 cocoa Exp $ */

#include "cocfun.h"
#include "cterm.h"
#include "ck.h"
#include "utils.h"

cocfun cocfun_init() {
  cocfun res_f;
  res_f = malloc_cocfun();
  cocfun_set_pkg_id(res_f,NULL);
  cocfun_set_fun_id(res_f,NULL);
  cocfun_set_arity(res_f,0);
  cocfun_set_header(res_f,cterm_NULL);
  cocfun_set_body(res_f,cterm_NULL);
  cocfun_set_rc(res_f,1);
  cocfun_set_is_short(res_f,FALSE);
  return res_f;
}

cocfun cocfun_mk(char * p_id, char * fun_id, int arity, cterm header, 
    cterm body, coc_bool is_short) {
  cocfun res_f;
  res_f = cocfun_init();
  cocfun_set_pkg_id(res_f,my_strdup(p_id));
  cocfun_set_fun_id(res_f,my_strdup(fun_id));
  cocfun_set_arity(res_f,arity);
  cocfun_set_header(res_f,header);
  cocfun_set_body(res_f,body);
  cocfun_set_is_short(res_f,is_short);
  return res_f;
}

void cocfun_free(cocfun f)
{
  free_str1(cocfun_pkg_id(f));
  free_str1(cocfun_fun_id(f));
  free_cocfun(f);
}

cterm cocfun2cterm(cocfun f)
{
  cterm res_t;
  cterm params[5];
  params[0]=cterm_mk_NBS(cocfun_fun_id(f));
  if (cocfun_header(f) != cterm_NULL)
    params[1]=cterm_dup(cocfun_header(f));
  else
    params[1]=int2cterm(cocfun_arity(f));
  if (cocfun_header(f) != cterm_NULL)
    params[2]=cterm_dup(cocfun_body(f));
  else {
    params[2]=cterm_mk_const(op_BUILTIN);
  }
  params[3]=bool2cterm(cocfun_is_short(f));
  params[4]=cterm_mk_const(op_NULL_VALUE);
  return cterm_mk_classic(op_PROGRAM2,5,params);
}

cterm cocfun_description(cocfun f)
{
  cterm t;
  t = cocfun2cterm(f);
  cterm_set_op(t,op_PROGRAM);
  return t;
}
