/* $Id: cocfun.h,v 4.4.1.1 2004/06/18 14:24:25 cocoa Exp $ */

#ifndef COCFUN_H
#define COCFUN_H

#ifndef AUXTYPES_H
# include "auxtypes.h"
#endif

#ifndef COCTYPES_H
# include "coctypes.h"
#endif

#define malloc_cocfun() (cocfun)mymalloc(sizeof(cocfun_info),"cocfun")
#define free_cocfun(p) myfree(sizeof(cocfun_info),p,"cocfun")

#define cocfun_NULL NULL

#define cocfun_pkg_id(f) ((f)->pkg_id)
#define cocfun_fun_id(f) ((f)->fun_id)
#define cocfun_arity(f) ((f)->arity)
#define cocfun_header(f) ((f)->header)
#define cocfun_body(f) ((f)->body)
#define cocfun_is_short(f) ((f)->is_short)

#define cocfun_set_pkg_id(f,id) (f)->pkg_id=id
#define cocfun_set_fun_id(f,id) (f)->fun_id=id
#define cocfun_set_arity(f,a) (f)->arity=a
#define cocfun_set_header(f,h) (f)->header=h
#define cocfun_set_body(f,b) (f)->body=b
#define cocfun_set_is_short(f,b) (f)->is_short=b

#define cocfun_rc(f) ((f)->rc)
#define cocfun_set_rc(f,R) (f)->rc=R
#define cocfun_incr_rc(f) ((f)->rc++)
#define cocfun_decr_rc(f) ((f)->rc--)

#define cocfun_link(f) \
  (f != cocfun_NULL ? (cocfun_incr_rc(f),f) : cocfun_NULL)

#define cocfun_unlink_do(f) \
  do { cocfun_decr_rc(f); \
       if (cocfun_rc(f)==0) cocfun_free(f);} while(FALSE)

#define cocfun_unlink(f) if ((f)!=cocfun_NULL) cocfun_unlink_do(f)

cocfun cocfun_init();
cocfun cocfun_mk(char * p_id, char * fun_id, int arity, cterm header, 
  cterm body, coc_bool is_short);
void cocfun_free(cocfun f);
cterm cocfun2cterm(cocfun f);
cterm cocfun_description(cocfun f);

#endif
