/* $Id: coeffs.h,v 4.4.1.1 2004/06/18 14:24:25 cocoa Exp $ */

#ifndef COEFFS_H
#define COEFFS_H

#ifndef AUXTYPES_H
# include "auxtypes.h"
#endif

#ifndef COCTYPES_H
# include "coctypes.h"
#endif

#define malloc_rat() (rat)mymalloc(sizeof(aux_rat),"rat")
#define free_rat(p) myfree(sizeof(aux_rat),p,"rat")

#define malloc_double() (double *)mymalloc(sizeof(double),"double")
#define free_double(p) myfree(sizeof(double),p,"double")

#define malloc_verylongint() (verylongint)mymalloc(sizeof(MP_INT),"MP_INT*")
#define free_verylongint(p) myfree(sizeof(MP_INT),p,"MP_INT*")

#define malloc_verylongrat() (verylongrat)mymalloc(sizeof(MP_RAT),"MP_RAT*")
#define free_verylongrat(p) myfree(sizeof(MP_RAT),p,"MP_RAT*")

#define malloc_zmod() (zmod)mymalloc(sizeof(aux_zmod),"zmod")
#define free_zmod(p) myfree(sizeof(aux_zmod),p,"zmod")

/* (__mpz_struct *) instead of (mpz_t) for gcc reasons */ /* i.e. tappullo */

#define arbint_is_int(n) \
  ((mpz_cmp_si((__mpz_struct *)n,INT_MIN) >= 0) \
  && (mpz_cmp_si((__mpz_struct *)n,INT_MAX) <= 0))

#define arbrat_is_int(n) \
  (arbint_is_int(arbrat_num(n)) && (mpz_cmp_si((__mpz_struct *)arbrat_den(n),1) == 0))

#define arbint2int(n) mpz_get_si(n)

/* non e' un medicinale, ma usare con cautela... */
#define arbrat2arbint(n,r) mpq_get_num((verylongint)(n),(verylongrat)r)

#define arbrat_is_arbint(r) (mpz_cmp_si( &((verylongrat)(r))->_mp_den, 1 ) == 0)

#define this_arbrat2int(r) this_arbint2int(this_arbrat2arbint(r))

#define arbrat_num(r) ((arbint) &(((verylongrat)(r))->_mp_num))
#define arbrat_den(r) ((arbint) &(((verylongrat)(r))->_mp_den))

#define rat_set_num(R,N) (R)->num=N
#define rat_set_den(R,N) (R)->den=N
#define rat_num(R) (R)->num
#define rat_den(R) (R)->den

#define zmod_p(z) ((z)->p)
#define zmod_n(z) ((z)->n)
#define zmod_set_p(z,P) (z)->p=P
#define zmod_set_n(z,N) (z)->n=N

#define zmod_sum(z1,z2) zmod_mk_norm(zmod_n(z1)+zmod_n(z2),zmod_p(z1))
#define zmod_mult(z1,z2) zmod_mk_norm(zmod_n(z1)*zmod_n(z2),zmod_p(z1))
#define zmod_sub(z1,z2) zmod_mk_norm(zmod_n(z1)-zmod_n(z2),zmod_p(z1))
#define zmod_change_sign(z) zmod_mk_norm(-zmod_n(z),zmod_p(z))
#define zmod_frac(z1,z2) zmod_mult(z1,zmod_inv(z2))
#define zmod_eq(z1,z2) (zmod_n(z1)==zmod_n(z2) && zmod_p(z1)==zmod_p(z2))
#define zmod_invertible(z) (ABS(IntGCD(zmod_n(z),zmod_p(z))) == 1)

#define coeff2int(c,R) this_coeff2int(coeff_dup(c,R),R)
#define coeff_eq(c1,c2,R) ((R)->AreEqualsCoeff(c1,c2))

#define coeff_free(c,R) (R)->ClearCoeff(&(c))

int coeff_size(coeff c, ring R);

double * double_dup(double * d);
int zmod_sym_n(zmod z);
zmod zmod_dup(zmod z);
zmod zmod_mk(int n, int p);
zmod zmod_mk_norm(int n, int p);
zmod zmod_inv(zmod z);
zmod zmod_mult_arbint( zmod z, arbint n);
zmod zmod_mult_int( zmod z, int n);
cterm double2cterm(double * d);
cterm zmod2cterm(zmod z);

arbint this_arbrat2arbint(arbrat r);
arbrat arbrat_mk(arbint n1, arbint n2);
arbrat arbint2arbrat(arbint n);
arbrat this_arbint2arbrat(arbint n);
coc_bool eq_int_arbint(int n1, arbint n2);
arbint int2arbint(int n);
arbrat int2arbrat(int n);
coeff coeff_opposite(coeff c,ring R);
coeff int2coeff(int n,ring R);
coeff this_arbint2coeff(arbint n,ring R);
coeff arbint2coeff(arbint n,ring R);
coeff arbrat2coeff(arbrat q, ring R);
coeff coeff_init(ring R);
coeff coeff_x_int(coeff c, int n, ring R);
arbint arbint_dup(arbint n);
arbrat arbrat_dup(arbrat n);

coc_bool IsGreaterCoeff( coeff c1, coeff c2, ring R );
/* return TRUE iff c1>c2 */

coc_bool IsLiGreater( coeff c1, coeff c2, ring R );
coc_bool IsLrGreater( coeff c1, coeff c2, ring R );

coeff coeff_power(coeff c,int exponent,ring R);
/* return c^exponent */

coc_bool coeff_is_int(coeff c,ring R);

int this_coeff2int(coeff c,ring R);
int this_arbint2int(arbint r);
arbint this_coeff2arbint(coeff c,ring R);
/* convert a coefficient to an integer */
arbrat this_coeff2arbrat(coeff c,ring R);
/* convert a coefficient to an rational number */

/* START GDD (941221) */
long coeff2long(coeff c,ring R);
/* convert a coefficient to a long */
/* for c in Zp it use the representation (-p/2,p/2) */
/* END GDD */

coeff cterm2coeff(cterm t,ring R);
/* return the coeff described by t:coeff */

cterm coeff2cterm(coeff c,ring R);
/* return the cterm corresponding to the coeff c */

coeff coeff_one(ring R);
/* return 1(R) */

coeff coeff_zero(ring R);
/* return 0(R) */

coeff coeff_dup(coeff c,ring R);
coeff coeff_sum(coeff c1, coeff c2, ring R);
coeff coeff_sub(coeff c1, coeff c2, ring R);
coeff coeff_sum_these(coeff c1, coeff c2, ring R);
coeff coeff_sum_these_free_if_zero(coeff c1, coeff c2, ring R);
coeff coeff_sub_these(coeff c1, coeff c2, ring R);

#define coeff_set_mult(c,c1,c2,R) do {\
  R->InitCoeff(&c); \
  R->MulCoeff(&c,c1,c2,R); } while(FALSE)

coeff coeff_random( ring R);
coeff coeff_div(coeff c1, coeff c2, ring R);
coeff coeff_mmod(coeff c1, coeff c2, ring R);
coeff coeff_mult(coeff c1, coeff c2, ring R);
coeff coeff_inverse(coeff c, ring R);

#define coeff_change_sign(c,R) (R)->ChangeSignToCoeff(c,R)
#define coeff_mult_this(c,c1,R) (R)->MulCoeff((coeff *)&c,c,c1,R)
#define coeff_is_zero(c,R) ((R)->IsZeroCoeff(c))
#define coeff_is_one(c,R) ((R)->IsOneCoeff(c))

/*  ------------------------------------------------------ *\
          integers modulo p
\*  ------------------------------------------------------ */

void ZpInit ( coeff * c );
void ZpClear ( coeff * c );
void ZpCopy ( coeff * theCopy, coeff c ); 
void ZpMakeCoeff( coeff * c, int num, int den, ring R );
void ZpStr2Coeff( coeff * c, char * s, ring R );
void ZpCterm2Coeff( coeff * c, cterm t );

void ZpInvert( coeff * theInv, coeff c, ring R );
void ZpNeg( coeff * theOpp, coeff c, ring R );
void ZpChangeSign( coeff * c, ring R);
void ZpRandomize( coeff * c, ring R);

void ZpAdd( coeff * c, coeff c1, coeff c2, ring R );
void ZpSub( coeff * c, coeff c1, coeff c2, ring R );
void ZpMul( coeff * c, coeff c1, coeff c2, ring R );
void ZpDiv( coeff * c, coeff c1, coeff c2, ring R );
void ZpMod( coeff * c, coeff c1, coeff c2, ring R );

coc_bool AreZpEquals( coeff c1, coeff c2 );
coc_bool IsZpPositive( coeff c1, ring R );
coc_bool IsZpZero( coeff c );
coc_bool IsZpOne( coeff c );
coc_bool IsZpMinusOne( coeff c, ring R );

void Zp2Cterm( cterm *t, coeff c, ring R );
void Li2Li( coeff * c, verylongint n, ring R);
void Li2Zp( coeff * c, verylongint n, ring R);

/*  --------------------------------------------------------
          short integers
  --------------------------------------------------------
*/

void SiInit ( coeff * c );
void SiClear ( coeff * c );
void SiCopy ( coeff * theCopy, coeff c ); 
void SiMakeCoeff( coeff * c, int num, int den, ring R );
void SiStr2Coeff( coeff * c, char * s, ring R );
void SiCterm2Coeff( coeff * c, cterm t );

void SiInvert( coeff * theInv, coeff c, ring R );
void SiNeg( coeff * theOpp, coeff c, ring R );
void SiChangeSign( coeff * c, ring R);
void SiRandomize( coeff * c, ring R);

void SiAdd( coeff * c, coeff c1, coeff c2, ring R );
void SiSub( coeff * c, coeff c1, coeff c2, ring R );
void SiMul( coeff * c, coeff c1, coeff c2, ring R );
void SiDiv( coeff * c, coeff c1, coeff c2, ring R );
void SiMod( coeff * c, coeff c1, coeff c2, ring R );

coc_bool AreSiEquals( coeff c1, coeff c2 );
coc_bool IsSiPositive( coeff c1, ring R );
coc_bool IsSiZero( coeff c );
coc_bool IsSiOne( coeff c );
coc_bool IsSiMinusOne( coeff c, ring R );

void Si2Cterm( cterm *t, coeff c, ring R );
void Li2Si( coeff * c, verylongint n, ring R);

/*  --------------------------------------------------------
          short rationals
  --------------------------------------------------------
*/

void SrInit ( coeff * c );
void SrClear ( coeff * c );
void SrCopy ( coeff * theCopy, coeff c ); 
void SrMakeCoeff( coeff * c, int num, int den, ring R );
void SrStr2Coeff( coeff * c, char * s, ring R );
void SrCterm2Coeff( coeff * c, cterm t );

void SrInvert( coeff * theInv, coeff c, ring R );
void SrNeg( coeff * theOpp, coeff c, ring R );
void SrChangeSign( coeff * c, ring R);
void SrRandomize( coeff * c, ring R) ;

void SrAdd( coeff * c, coeff c1, coeff c2, ring R );
void SrSub( coeff * c, coeff c1, coeff c2, ring R );
void SrMul( coeff * c, coeff c1, coeff c2, ring R );
void SrDiv( coeff * c, coeff c1, coeff c2, ring R );
void SrMod( coeff * c, coeff c1, coeff c2, ring R );

coc_bool AreSrEquals( coeff c1, coeff c2 );
coc_bool IsSrPositive( coeff c1, ring R );
coc_bool IsSrZero( coeff c );
coc_bool IsSrOne( coeff c );
coc_bool IsSrMinusOne( coeff c, ring R );

void Sr2Cterm( cterm *t, coeff c, ring R );
void Li2Sr( coeff * c, verylongint n, ring R);

/*  --------------------------------------------------------
          doubles
  --------------------------------------------------------
*/

void SdInit ( coeff * c );
void SdClear ( coeff * c );
void SdCopy ( coeff * theCopy, coeff c ); 
void SdMakeCoeff( coeff * c, int num, int den, ring R );
void SdStr2Coeff( coeff * c, char * s, ring R );
void SdCterm2Coeff( coeff * c, cterm t );

void SdInvert( coeff * theInv, coeff c, ring R );
void SdNeg( coeff * theOpp, coeff c, ring R );
void SdChangeSign( coeff * c, ring R);
void SdRandomize( coeff * c, ring R) ;

void SdAdd( coeff * c, coeff c1, coeff c2, ring R );
void SdSub( coeff * c, coeff c1, coeff c2, ring R );
void SdMul( coeff * c, coeff c1, coeff c2, ring R );
void SdDiv( coeff * c, coeff c1, coeff c2, ring R );
void SdMod( coeff * c, coeff c1, coeff c2, ring R );

coc_bool AreSdEquals( coeff c1, coeff c2 );
coc_bool IsSdPositive( coeff c1, ring R );
coc_bool IsSdZero( coeff c );
coc_bool IsSdOne( coeff c );
coc_bool IsSdMinusOne( coeff c, ring R );

void Sd2Cterm( cterm *t, coeff c, ring R );
void Li2Sd( coeff * c, verylongint n, ring R);

/*  --------------------------------------------------------
          big integers
  --------------------------------------------------------
*/

void LiInit ( coeff * c );
void LiClear ( coeff * c );
void LiCopy ( coeff * theCopy, coeff c ); 
void LiMakeCoeff( coeff * c, int num, int den, ring R );
void LiStr2Coeff( coeff * c, char * s, ring R );
void LiCterm2Coeff( coeff * c, cterm t );

void LiInvert( coeff * theInv, coeff c, ring R );
void LiNeg( coeff * theOpp, coeff c, ring R );
void LiChangeSign( coeff * c, ring R);
void LiRandomize( coeff * c, ring R) ;

void LiAdd( coeff * c, coeff c1, coeff c2, ring R );
void LiSub( coeff * c, coeff c1, coeff c2, ring R );
void LiMul( coeff * c, coeff c1, coeff c2, ring R );
void LiDiv( coeff * c, coeff c1, coeff c2, ring R );
void LiMod( coeff * c, coeff c1, coeff c2, ring R );

coc_bool AreLiEquals( coeff c1, coeff c2 );
coc_bool IsLiPositive( coeff c1, ring R );
coc_bool IsLiZero( coeff c );
coc_bool IsLiOne( coeff c );
coc_bool IsLiMinusOne( coeff c, ring R );

void Li2Cterm( cterm *t, coeff c, ring R );
void Li2Li( coeff * c, verylongint n, ring R);

/*  --------------------------------------------------------
          big rationals
  --------------------------------------------------------
*/

void LrInit ( coeff * c );
void LrClear ( coeff * c );
void LrCopy ( coeff * theCopy, coeff c ); 
void LrMakeCoeff( coeff * c, int num, int den, ring R );
void LrStr2Coeff( coeff * c, char * s, ring R );
void LrCterm2Coeff( coeff * c, cterm t );

void LrInvert( coeff * theInv, coeff c, ring R );
void LrNeg( coeff * theOpp, coeff c, ring R );
void LrChangeSign( coeff * c, ring R);
void LrRandomize( coeff * c, ring R) ;

void LrAdd( coeff * c, coeff c1, coeff c2, ring R );
void LrSub( coeff * c, coeff c1, coeff c2, ring R );
void LrMul( coeff * c, coeff c1, coeff c2, ring R );
void LrDiv( coeff * c, coeff c1, coeff c2, ring R );
void LrMod( coeff * c, coeff c1, coeff c2, ring R );

coc_bool AreLrEquals( coeff c1, coeff c2 );
coc_bool IsLrPositive( coeff c1, ring R );
coc_bool IsLrZero( coeff c );
coc_bool IsLrOne( coeff c );
coc_bool IsLrMinusOne( coeff c, ring R );

void Lr2Cterm( cterm *t, coeff c, ring R );
void Li2Lr( coeff * c, verylongint n, ring R);

#endif
