/* $Id: ctbuf.c,v 4.4.1.1 2004/06/18 14:24:25 cocoa Exp $ */

#include "cocdefs.h"

#include "cterm.h"
#include "ctbuf.h"
#include "operator.h"
#include "pipe.h"

#include <stdlib.h>

/* CONSTRUCTORS of ctbuf */

ctbuf ctbuf_empty(void)
{
  coc_pipe b;
  b=pipe_new();
  return b;
}

ctbuf ctbuf_new(cterm t)
{
  coc_pipe b;
  b=pipe_new();
  pipe_rpush(b,(int*)t);
  return b;
}

ctbuf ctbuf_append(ctbuf b,cterm t)
{
  return pipe_rpush(b,(int*)t);
}

void ctbuf_push(ctbuf * b,cterm t)
{
  *b = pipe_lpush(*b,(int*)cterm_dup(t));
}

void ctbuf_pop(ctbuf b)
{
  cterm t;
  t = (cterm)pipe_lpop(b);
  cterm_free(t);
}


/* SPECIAL operations on ctbuf */

cterm ctbuf_mk_cterm(ctbuf b,coop op)
{
  int arity,i;
  cterm res_t;
  cterm_list params;
  arity=ctbuf_len(b);
  if (arity == 0) {
    res_t=cterm_mk_const(op);
  } else {
    params=malloc_cterm_list(arity);
    for (i=0;i<arity;i++) 
      params[i]=ctbuf_lpop(b);
    res_t=cterm_mk_classic(op,arity,params);
    free_cterm_list(arity,params);
  }
  ctbuf_free(b);
  return res_t;
}

cterm ctbuf_mk_cterm_rev(ctbuf b,coop op)
{
  int arity,i;
  cterm res_t;
  cterm_list params;
  arity=ctbuf_len(b);
  params=malloc_cterm_list(arity);
  for (i=0;i<arity;i++) 
    params[i]=ctbuf_rpop(b);
  ctbuf_free(b);
  res_t=cterm_mk_classic(op,arity,params);
  free_cterm_list(arity,params);
  return res_t;
}
