/* ctbuf.h : 0.3 : 29 APR 93 : ctbuf structure header */

/*------------------------------------------------------------------------------

	Part of project Cocoa3

	Revision history

	0.3	new function ctbuf_empty
		
------------------------------------------------------------------------------*/

#ifndef CTBUF_H
#define CTBUF_H

#ifndef AUXTYPES_H
# include "auxtypes.h"
#endif

#define ctbuf_concat_these(B1,B2) pipe_concat_these(B1,B2)
#define ctbuf_free(B) pipe_free(B)

#define ctbuf_lpop(b) ((cterm)pipe_lpop(b))
#define ctbuf_rpop(b) ((cterm)pipe_rpop(b))
#define ctbuf_len(b) pipe_len(b)
#define ctbuf_is_empty(b) (ctbuf_len(b)==0)

/* CONSTRUCTORS of ctbuf */

ctbuf ctbuf_empty(void);
/* create a new empty ctbuf */

ctbuf ctbuf_new(cterm t);
/* ctbuf_new(t) creates a new ctbuf containing only t and returns it */

ctbuf ctbuf_append(ctbuf b,cterm t);
/* ctbuf_append(b,t) appends the term t to the buffer b and return the new b */

void ctbuf_push(ctbuf *b,cterm t);
void ctbuf_pop(ctbuf b);


/* SPECIAL operations on ctbuf */

cterm ctbuf_mk_cterm(ctbuf b,coop op);
/* ctbuf_mk_cterm(b,op) makes a new cterm using the coop op and 
  the parameters contained in the buffer b */

cterm ctbuf_mk_cterm_rev(ctbuf b,coop op);
/* like ctbuf_mk_cterm but reversing parameters */

#endif
