/* $Id: eee.h,v 4.4.1.1 2004/06/18 14:24:25 cocoa Exp $ */

#ifndef EEE_H
#define EEE_H

#ifndef AUXTYPES_H
# include "auxtypes.h"
#endif

#ifndef COCTYPES_H
# include "coctypes.h"
#endif

#ifdef EEE

/* -----[ EEE_L ]-------------- */

eee eee_dup_l(eee p, int l, ring R);
monopoli eee2monopoli_l(eee p, int l, ring R);
eee eee_mult_l(eee p1, eee p2, int l, ring R);
eee eee_sum_these_l(eee p1, eee p2, int l, ring R);
void eee_free_l(eee p, int l, ring R);
int eee_size_l(eee p, int l, ring R);
cterm eee2cterm_l(eee p, int l, ring R);
void eee_change_sign_l(eee * p, int l, ring R);

void eee_shift_this_and_coeff(eee * p, eee_lbl ss, coeff c, int l, ring R);
void eee_shift_this(eee * p, eee_lbl ss, int l, ring R);
void eee_this_x_coeff_l(eee * p, coeff c, int l, ring R);

eee eee_shift_and_coeff(eee p, eee_lbl ss, coeff c, int l, ring R);
eee eee_shift(eee p, eee_lbl ss, int l, ring R);
eee eee_x_coeff_l(eee p, coeff c, int l, ring R);

/* -----[ EEE_MON ]-------------- */

#define malloc_eee_mon_array(n) \
  (eee_mon *)mymalloc((n)*sizeof(eee_mon),"eee_mon_array")
#define free_eee_mon_array(n,p) myfree((n)*sizeof(eee_mon),p,"eee_mon_array")

#define eee_mon_dup(m,l,R) \
  eee_mon_mk(eee_mon_lbl_hd(m), \
    eee_lbl_dup_ck(eee_mon_lbl_tl(m)),\
    eee_dup_l(eee_mon_cff(m),l-eee_mon_lbl_len(m),R))

#define malloc_eee_mon() (eee_mon)mymalloc(sizeof(eee_mon_aux),"eee_mon")
#define free_eee_mon(p) myfree(sizeof(eee_mon_aux),p,"eee_mon")

#define eee_mon_lbl_hd(m) ((m)->hd)
#define eee_mon_lbl_tl(m) ((m)->tl)
#define eee_mon_cff(m) ((m)->c)
#define eee_mon_next(m) ((m)->next)
#define eee_dummy(R,l) (R)->eee_dum[l]

#define eee_mon_set_lbl_hd(m,H) (m)->hd=H
#define eee_mon_set_lbl_tl(m,L) (m)->tl=L
#define eee_mon_set_cff(m,C) (m)->c=C
#define eee_mon_set_next(m,M) (m)->next=M
#define eee_set_dummy(R,l,m) (R)->eee_dum[l]=m

#define eee_mon_lbl_len(m) (eee_lbl_len_ck(eee_mon_lbl_tl(m))+1)

#define eee_mon_lbl_hd_gt(m1, m2) (eee_mon_lbl_hd(m1)>eee_mon_lbl_hd(m2))
#define eee_mon_lbl_gt(m1, m2) \
 (eee_mon_lbl_hd_gt(m1,m2) || \
  eee_lbl_gt_ck(eee_mon_lbl_tl(m1),eee_mon_lbl_tl(m2)))

coc_bool eee_mon_eq(eee_mon m1, eee_mon m2, int l, ring R);
coc_bool eee_mon_is_const(eee_mon m, int l, ring R);
eee_mon eee_mon_mult(eee_mon m1, eee_mon m2, int l, ring R);
eee_mon eee_mon_mk(expType hd, eee_lbl tl, eee p);
eee eee_x_eee_mon(eee p, eee_mon m, int l, ring R);
eee eee_mon_x_eee(eee_mon m, eee p, int l, ring R);
eee_mon eee_mon_sum_these(eee_mon m1, eee_mon m2, int l, ring R);
cterm eee_mon2cterm(eee_mon m, int l, ring R);
eee_mon this_monomial2eee_mon(monomial m, ring R);
eee_mon eee_mon_mk_special(eee_lbl l, eee p, ring R);
/* int eee_mon_lbl_which_gt(eee_mon m1,eee_mon m2); */ /* TODO: REMOVE */
void eee_mon_lift_this(eee_mon m);

#define eee_mon_lbl_which_gt(m1,m2) \
  ((eee_mon_lbl_hd(m1)>eee_mon_lbl_hd(m2)) ? ANSWER_FIRST : \
    ((eee_mon_lbl_hd(m2)>eee_mon_lbl_hd(m1)) ? ANSWER_SECOND : \
        eee_lbl_which_gt_ck(eee_mon_lbl_tl(m1),eee_mon_lbl_tl(m2))))

/* -----[ EEE_MONOPOLI ]-------------- */

eee eee_monopoli_mult(eee p1, eee p2, ring R);
eee eee_monopoli_mon_x_monopoli(eee_mon m, eee p, ring R);
eee_mon eee_monopoli_mon_mult(eee_mon m1, eee_mon m2, ring R);
eee eee_monopoli_sum_these(eee p1, eee p2, ring R);
eee_mon eee_monopoli_mon_sum_these(eee_mon m1, eee_mon m2, ring R);

/* -----[ EEE_LBL ]-------------- */

/* TODO_OPT: HERE IS IMPORTANT TO OPTIMIZE */
/* TODO: control if the check (_ck) is necessary */

#define eee_lbl_NULL ivec_NULL

#define eee_lbl2cterm(l) ivec2cterm(l)
#define eee_lbl_len(l) ivec_len(l)
#define eee_lbl_len_ck(l) ivec_len_ck(l)
#define eee_lbl_free(l) ivec_free(l)
#define eee_lbl_free_ck(l) ivec_free_ck(l)
#define eee_lbl_init(n) ivec_init(n)
#define eee_lbl_nth(l,n) ivec_nth(l,n)
#define eee_lbl_set_nth(l,n,i) ivec_set_nth(l,n,i)
#define eee_lbl_dup_from(l,n) ivec_dup_from(l,n)
#define eee_lbl_dup_to(l,n) ivec_dup_to(l,n)
#define eee_lbl_dup_to_ck(l,n) ivec_dup_to_ck(l,n)
#define eee_lbl_sum(l1,l2) ivec_sum(l1,l2)
#define eee_lbl_sum_ck(l1,l2) ivec_sum_ck(l1,l2)
#define eee_lbl_dup(l) ivec_dup(l)
#define eee_lbl_dup_ck(l) ivec_dup_ck(l)
#define eee_lbl_gt(l1,l2) (ivec_which_gt_lex(l1,l2) == ANSWER_FIRST)
#define eee_lbl_gt_ck(l1,l2) (ivec_which_gt_lex_ck(l1,l2) == ANSWER_FIRST)
#define eee_lbl_which_gt(l1,l2) ivec_which_gt_lex(l1,l2)
#define eee_lbl_which_gt_ck(l1,l2) ivec_which_gt_lex_ck(l1,l2)
#define eee_lbl_is_zero(l) ivec_is_zero(l)
#define eee_lbl_is_zero_ck(l) ivec_is_zero_ck(l)

cterm eee_mon_lbl2cterm(eee_mon m);

/* -----[ EEE ]-------------- */

#define eee_dup(p,R) (((p) == NULL) ? NULL : eee_dup_l(p,ring_indets_num(R),R))

#define eee_sum_this_monomial_list(m,R)	eee_sum_this_monomial_list_to_this_eee(m,NULL,R)

#define malloc_eee() 	(eee)mymalloc(sizeof(eee_mon_aux),"eee")
#define free_eee(p) 	myfree(sizeof(eee_mon_aux),p,"eee")
#define eee_sum(p1,p2,R) 	eee_sum_these(eee_dup(p1,R),eee_dup(p2,R),R)
#define eee_sub(p1,p2,R) 	eee_sub_these(eee_dup(p1,R),eee_dup(p2,R),R)
#define eee_free(p,R) 	eee_free_l(p,ring_indets_num(R),R)
#define eee_mdeg(p,R) 	eee_max_mdeg(p,R)
#define eee_size(p,R) 	eee_size_l(p,ring_indets_num(R),R)+sizeof(eee)
#define eee_len(p,R) 	eee_num_leaves(p,ring_indets_num(R),R)
#define eee2cterm(p,R) 	eee2cterm_l(p,ring_indets_num(R),R)
#define eee_change_sign(p,R) 	eee_change_sign_l(&p,ring_indets_num(R),R)
#define eee_leading_monomial(p,R) 	eee_first(p,R)
#define eee_extract_lm(p,R) 	eee_get_first(p,R)
#define eee_this_x_term(p,t,R) 	eee_this_x_monomial(p,this_term2monomial(t,R),R)
#define eee_only_leading_term(p,R) 	this_term2eee(eee_leading_term(p,R),R)
#define this_monopoli2eee(p,R)	eee_sum_this_monopoli(p,R)
#define monopoli2eee(p,R)	eee_sum_monopoli(p,R)
#define eee_is_nonzero_const(p,R) (((p)==NULL) ? FALSE : eee_mon_is_const(p,ring_indets_num(R),R))
#define this_monomial2eee(m,R)	this_monomial2eee_mon(m,R)

#define this_term2eee(t,R) 	this_monomial2eee(this_term2monomial(t,R),R)
#define unknown_pow2eee(u,n,R)  this_monomial2eee(this_term2monomial(unknown_pow2term(u,n,R),R),R)
#define eee2monopoli(p,R) 	eee2monopoli_l(p,ring_indets_num(R),R)

#define eee_is_mon(p) 	(eee_mon_next(p)==eee_mon_NULL)
#define eee_lm_which_gt(p1, p2, R) \
  eee_first_which_gt(p1,p2,ring_indets_num(R),R)

monopoli 	this_eee2monopoli	(eee p, ring R);
monomial 	eee_get_first	(eee *p, ring R);
monomial 	eee_first	(eee p, ring R);
eee 	eee_der	(eee p, unknown x, ring R);
eee	eee_map	(eee p, ring R, ring S, ivector m);
coc_bool 	eee_eq	(eee p1, eee p2, ring R);
int 	eee_deg	(eee p, ring R);
olist 	eee2sppnum	(eee p, ring R);
coc_bool 	eee_is_homog	(eee p, ring R);
coc_bool 	eee_is_homog_deg	(eee p, int hd, ring R);
int 	eee_is_homog_return_deg	(eee p, ring R);
ivector eee_max_mdeg	(eee p, ring R);
eee 	eee_square	(eee p, ring R);
eee 	eee_sum_these	(eee p1, eee p2, ring R);
eee 	eee_sub_these	(eee p1, eee p2, ring R);
eee 	eee_mult	(eee p1, eee p2, ring R);
eee 	eee_x_monomial	(eee p, monomial m, ring R);
term 	eee_leading_term	(eee p, ring R);
eee 	eee_this_x_monomial	(eee p, monomial m, ring R);
eee 	eee_this_x_coeff	(eee p, coeff c, ring R);
coeff 	eee_this_leading_coeff	(eee p, ring R);
coeff 	eee_leading_coeff	(eee p, ring R);
eee 	eee_sum_this_monopoli	(monopoli m, ring R);
eee	eee_sum_monopoli	(monopoli m, ring R);
eee 	eee_add_this_monomial	(eee p, monomial m, ring R);
eee 	this_coeff2eee	(coeff c, ring R);
eee	eee_randomize	(eee p, ring R);
eee 	eee_this_minus_term_x_eee	(eee p1, term ME, eee p2, ring R);
eee 	eee_this_plus_term_x_eee	(eee p1, term ME, eee p2, ring R);
eee 	eee_this_minus_term_x_eee_truncated	(eee p1, term ME, eee p2, iv_elem Trunc, ring R);
eee 	eee_this_plus_term_x_eee_truncated	(eee p1, term ME, eee p2, iv_elem Trunc, ring R);
eee 	eee_remove_lm	(eee p, ring R);
eee 	eee_sum_this_monomial_list_to_this_eee	(monomial m, eee p, ring R);
void eee_change_order(eee * p, ring R1, ring R2);
void eee_add_this_monomial_unique(monomial m, eee *p, ring R);



/****************************************************************/




#if 0 /* TODO PUBLIC */

/* -----[ EEE ]-------------- */

/*

polynomial poly_der(polynomial p, unknown x, ring R);
polynomial poly_this_x_monomial(polynomial p, monomial m, ring R);
int poly_deg(polynomial p, ring R);
int poly_len(polynomial p, ring R);
coeff poly_leading_coeff(polynomial p, ring R);

*/

cterm poly2cterm(polynomial p,ring R);
int poly_deg(polynomial p, ring R);
int poly_len(polynomial p, ring R);
int poly_size(polynomial p, ring R);

term poly_this_leading_term(polynomial p, ring R);

#define poly_leading_coeff(p,R) eee_leading_coeff(p,R)
#define poly_optimize_this(p,R) eee_optimize_this(p,ring_indets_num(R),R)
#define poly_get_leading_monomial(p,R) eee_get_first(p,R)

/*
{ *//* TODO: WARNING NON UNIQUE REPRESENTATION */ /* first optimize *//*
#define poly_eq(p1,p2,R) eee_eq(p1,p2,ring_indets_num(R),R)
*/

coc_bool poly_eq(polynomial p1, polynomial p2, ring R);
/* TODO: OPT */


#define poly_coeff2poly(c,R) poly_this_coeff2poly(coeff_dup(c,R),R)
#define poly_this_x_opp_term(p,t,R) \
  poly_this_x_monomial(p,opp_this_term2monomial(t,R),R)


#define poly_x_opp_term(p,t,R) poly_this_x_opp_term(poly_dup(p,R),t,R)

#define polynomials_init(R) eee_init(R)

/* this ... should be better */
#define poly2monopoli(p,R) eee2monopoli(p,ring_indets_num(R),R)

polynomial poly_sum_these(polynomial p1, polynomial p2, ring R);
polynomial poly_mult(polynomial p1, polynomial p2, ring R);
polynomial poly_this_monomial2poly(monomial m, ring R);
coc_bool poly_is_nonzero_const(polynomial p, ring R);
polynomial poly_this_coeff2poly(coeff c, ring R);
polynomial poly_this_x_coeff(polynomial p, coeff c, ring R);
polynomial poly_dup(polynomial p, ring R);


/* --------------------- *\
          MONOPOLI
\* --------------------- */

eee monopoli_mult(eee p1, eee p2, ring R);
eee monopoli_mon_x_monopoli(eee_mon m, eee p, ring R);
eee_mon monopoli_mon_mult(eee_mon m1, eee_mon m2, ring R);
eee monopoli_sum_these(eee p1, eee p2, ring R);
eee_mon monopoli_mon_sum_these(eee_mon m1, eee_mon m2, ring R);
eee monopoli_this_monopoli2eee(monomial m, ring R);


/* --------------------- *\
            EEE
\* --------------------- */


void eee_optimize_this(eee p, int l, ring R);
void eee_init(ring R);
int eee_num_leaves(eee p, int l, ring R);
eee eee_sum_these(eee p1, eee p2, int l, ring R);
eee eee_mult(eee p1, eee p2, int l, ring R);
void eee_free(eee p, int l, ring R);
int eee_first_which_gt(eee p1, eee p2, int l, ring R);
coc_bool eee_eq(eee p1, eee p2, int l, ring R);
monomial eee2monopoli(eee p, int l, ring R);
coeff eee_leading_coeff(eee p, ring R);
coeff eee_this_leading_coeff(eee p, ring R);

eee eee_this_monopoli2eee(monomial m, int l, ring R);

/* --------------------- *\
         EEE MON
\* --------------------- */

eee_mon eee_mon_mk_NONEXT(expType hd, eee_lbl tl, eee p);
eee_mon eee_mon_free(eee_mon m, int l, ring R);

#endif /* TODO_PUBLIC */

#endif /* EEE */

#endif

