/* engine.h : 0.1 : 1 Ago 95 : cocoa3 engine */

#ifndef ENGINE_H
#define ENGINE_H

#include "auxtypes.h"
#include "coctypes.h"

#define malloc_string_list(size) \
  (charstars)mymalloc((size)*sizeof(char *),"string_list")
#define free_string_list(size,p) myfree((size)*sizeof(char *),p,"string_list")

/*
[ auxiliary ]
*/

extern ring current_ring;
extern coc_bool engine_made_output;

void engine_init(void);
object engine(cterm t);
object engine_and_time(cterm t);

/* engine HANDLERS */

object engine_alias(cterm t, ring R);
object engine_alias_in(cterm t, ring R);
object engine_assign(cterm t, ring R);
object engine_break(cterm t, ring R);
object engine_catch(cterm t, ring R);
object engine_clear_rings(cterm t,ring R);
object engine_close(cterm t, ring R);
object engine_closelog(cterm t, ring R);
object engine_commands(cterm t, ring R);
object engine_define_func(cterm t, ring R);
object engine_define_ring(cterm t, ring R);
object engine_delete_rings(cterm t,ring R);
object engine_delete_vars(cterm t,ring R);
object engine_describe(cterm t, ring R);
object engine_eval(cterm t, ring R);
object engine_for(cterm t, ring R);
object engine_flush(cterm t, ring R);
object engine_foreach(cterm t, ring R);
object engine_if(cterm t, ring R);
object engine_need(cterm t, ring R);
object engine_openlog(cterm t, ring R);
object engine_option(cterm t, ring R);
object engine_package(cterm t, ring R);
object engine_panel(cterm t, ring R);
object engine_print(cterm t, ring R);
object engine_quit(cterm t, ring R);
object engine_repeat(cterm t, ring R);
object engine_return(cterm t, ring R);
object engine_set_curr_ring(cterm t, ring R);
object engine_using(cterm t, ring R);
object engine_set_option(cterm t, ring R);
object engine_skip(cterm t, ring R);
object engine_source(cterm t, ring R);
object engine_terror(cterm t, ring R);
object engine_time(cterm t, ring R);
object engine_unset_option(cterm t, ring R);
object engine_while(cterm t, ring R);

object engine_print_object(object o, cdev D, ring R);
object engine_describe_object(object o, cdev D, ring R);
object engine_assign_ideal_field(module M, cterm t, object o, char * l, ring R);
object engine_assign_module_field(module M, cterm t, object o, char *l, ring R);
int module_update_field(module * M, char * id, object o, ring R);
object engine_in_ring(cterm t, ring R);
object engine_assign_this(cterm t, object o, ring R);

object engine_delete_ring(cterm t);
object engine_delete_var(cterm t,ring R);

cterm cocoa_panels(void);

/* environments */

void ring_env_assign(ring R);
ring ring_env_get(char * id);
object ring_env_delete(ring R);
void panels_env_assign(char * id, opt_panel p,ring R);
opt_panel panels_env_get(char * id);

/* ---[ auxiliary ]-------------------------------------------- */

char * cterm_expand_aliases(cterm t, map al_map, charstars al_pkgs);
/* if the alias X is unknown then it is returned */
void engine_package_expand_aliases(int pkg_n, map al_map, charstars al_pkgs);
object engine_define_pkg_func(int pkg_n, cterm t, ring R);
void cocoa_declare_var(cterm t,env * e,ring R);
void cterm_subst_vars(cterm * t, char * v1, char * v2);
/* substitute in t all occurrences of var(v1) with var(v2) */

void cterm_expand_dollar(cterm t, char * p_id);
object cocoa_error(char * id);
object cocoa_error_not_impl(char * s);
object cocoa_internal_error(char * msg);
object error_expected_found(objtype t1, objtype t2);
object error_cannot_apply(char * op, objtype t);
cterm err2cterm(char * s);

#endif
