/* $Id: evector.h,v 4.4.1.1 2004/06/18 14:24:25 cocoa Exp $
  [ mvector ] [ evector ] */

#ifndef EVECTOR_H
#define EVECTOR_H

#ifndef AUXTYPES_H
# include "auxtypes.h"
#endif

#ifndef COCTYPES_H
# include "coctypes.h"
#endif

#define ev_NULL NULL
#define ev_NOLABEL -1

#define ev_irr(E) ((E)->irr)
#define ev_irr_last(E) ((E)->irr_last)
#define ev_red(E) ((E)->red)
#define ev_tail(E) ((E)->tail)
#define ev_wd(E) ((E)->wD)
#define ev_td(E) ((E)->tD)
#define ev_lm(E) ((E)->lm)
#define ev_lmpos(E) ((E)->lmpos)
#define ev_lt(E) monomial_term((E)->lm)
#define ev_lc(E) monomial_coeff((E)->lm)
#define ev_rel(E) ((E)->rel)
#define ev_rc(E) ((E)->rc)
#define ev_Is_SPoly(E) ((E)->Is_SPoly) 
#define ev_label(E) ((E)->label)
#define ev_eterm(E) ((E)->et)
#define ev_is_zero_ck(ev) ((ev == ev_NULL) || ev_is_zero(ev))
#define ev_is_zero(ev) (ev_red_is_zero(ev) && ev_irr_is_zero(ev))
#define ev_is_irreducible(ev) (ev_red_is_zero(ev))

#define ev_nth(E,N) pv_nth(ev_vector(E),N) 
#define ev_set_wd(E,WD) (E)->wD=WD
#define ev_set_td(E,TD) (E)->tD=TD
#define ev_set_lm(E,M) (E)->lm=M
#define ev_set_lmpos(E,P) (E)->lmpos=P
#define ev_set_rel(E,R) (E)->rel=R
#define ev_set_tail(E,P) (E)->tail=P
#define ev_set_rc(E,R) (E)->rc=R
#define ev_set_label(E,L) (E)->label=L
#define ev_set_Is_SPoly(E,B) (E)->Is_SPoly=B 
#define ev_set_red(E,R) (E)->red=R
#define ev_set_irr(E,I) (E)->irr=I
#define ev_set_irr_last(E,I) (E)->irr_last=I
#define ev_set_eterm(E,T) (E)->et=T

#define ev_deg_lt(E) ((ev_lm(E) == NULL) ? 0 : term_degree(ev_lt(E)))
#define ev_is_split(E) (ev_irr(E) != mv_NULL || ev_tail(E) != pv_NULL)
#define ev_is_labelled(E) (ev_label(E)!=ev_NOLABEL)
#define ev_red_is_zero(ev) (pv_is_NULL_or_zero(ev_red(ev)))
#define ev_irr_is_zero(ev) (ev_irr(ev) == mv_NULL)
#define ev_rank(ev) \
  ((ev_red(ev) != pv_NULL) ? pv_rank(ev_red(ev)) : pv_rank(ev_tail(ev)))
#define ev_shifts(ev) \
  ((ev_red(ev) != pv_NULL) ? pv_shifts(ev_red(ev)) : pv_shifts(ev_tail(ev)))

#define ev_incr_rc(ev) ((ev)->rc++)
#define ev_decr_rc(ev) ((ev)->rc--)

#define ev_link(ev) (ev_incr_rc(ev),ev)

#define ev_unlink(ev,R) \
  if (ev != ev_NULL) { \
    ev_decr_rc(ev); \
    if (ev_rc(ev)==0) ev_free(&ev,R);} 

#define malloc_ev() \
  (evector)mymalloc(sizeof(ev_info),"ev")
#define free_ev(p) myfree(sizeof(ev_info),p,"ev")

/* -------[ mvector ]-------- */

#define malloc_mv() (mvector)mymalloc(sizeof(mv_aux),"mvector")
#define free_mv(p) myfree(sizeof(mv_aux),p,"mvector")

#define realloc_mv_comp(p,r1,r2) \
  (monomial *) \
    myrealloc(p,sizeof(monomial)*(r1),sizeof(monomial)*(r2),"mvcomps")
#define malloc_mv_comp(r) \
  (monomial *)mymalloc(sizeof(monomial)*(r),"mvcomps")
#define free_mv_comp(r,p) myfree(sizeof(monomial)*(r),p,"mvcomps")

#define mv_nth(v,n) (v)->compo[n]
#define mv_comp(v) ((v)->compo)
#define mv_rank(v) ((v)->r)
#define mv_set_rank(v,R) (v)->r=R
#define mv_set_nth(v,n,p) (v)->compo[n]=(p)
#define mv_set_comp(v,C) ((v)->compo=C)

#define this_pv_plus_mxmv(pv,m,mv,R) \
  this_pv_plus_this_mv(pv, mv_x_monomial(mv,m,R),R)

pvector this_pv_plus_tail_of_this_mv(pvector pv, mvector mv, int lpos, ring R);
pvector this_pv_plus_this_mv(pvector pv, mvector mv, ring R);
mvector mv_dup(mvector mv, ring R);
void mv_free(mvector mv, ring R);
mvector mv_x_monomial(mvector mv, monomial m, ring R);
cterm mv2cterm(mvector mv, shifts ss, ring R);
void mv_Apply_Anti_Shifts(mvector v,shifts ss,ring R);
void mv_Apply_Shifts(mvector v,shifts ss,ring R);
mvector mv_init(int r);
void mv_force_rank(mvector * mv, int rank);

void ev_reinit(evector V, ring R);
void ev_to_rule(evector V, ring R);
void ev_irr_plus_red_to_tail(evector V, ring R);

/* -------[ evector ]-------- */

#define ev_homog(v,x,R) ev_init(pv_homog(ev_vector(v),x,R),R)

void ev_extract_lmred(evector V, monomial * lmred, int * lmpos, ring R);
pvector ev_vector(evector E);
pvector ev_whole_vector(evector E, ring R);
pvector ev_irr2pv(mvector irr, ring R);
evector ev_dup(evector ev,ring R);
evector ev_init(pvector p,ring R);
evector ev_init2(monomial lm, int lmpos, pvector tail);
void ev_update_lm(evector v, monomial lm, int lmpos, ring R);
void ev_update(evector ev,ring R);
void ev_free(evector * ev, ring R);
void ev_make_monic(evector ev, ring R);
void ev_add_monomial_to_irr(evector ev, monomial m, int pos, ring R);
void ev_force_rc1(evector * ev, ring R);
void printf_ev(evector ev, ring R);
cterm ev2cterm_normal(evector ev, ring R);
cterm ev2cterm(evector ev, ring R);
void ev_apply_shifts(evector ev, shifts ss, ring R);

#endif
