/* $Id: hilop.h,v 4.4.1.1 2004/06/18 14:24:25 cocoa Exp $ 

	module HILOP

	"This module contains algorithm based on Grobner Computation,
	like Intersection of Ideals or Modules, Elimination of variables,
	Comparizon (?) between Ideals or Modules, etc."

--------------------------------------------------------- */
 
#ifndef HILOP_H
#define HILOP_H

#ifndef MODULE_H
# include "module.h"
#endif

#ifndef VLIST_H
# include "vlist.h"
#endif

#ifndef POINCARE_H
# include "poincare.h"
#endif

/* ---[ Polynomials ]----------------------------------------------- */

arpoly arpoly_lcm(arpoly p, arpoly q, ring R);
arpoly arpoly_gcd(arpoly p, arpoly q, ring R);

/* ---[ Ideals ]----------------------------------------------- */


/* ---[ Modules ]----------------------------------------------- */

#define gb_LTNF(V,M) gb_NF_aux(V,M,gb_kf_Reduce_LT)
#define gb_FullNF(V,M) gb_NF_aux(V,M,gb_kf_Reduce_Full)
#define ModuleIsContained(M,N) gb_NFsAreZero(module_gens(M),N)
#define EqModules(M,N) (ModuleIsContained(M,N) && ModuleIsContained(N,M))

evector gb_NF_aux(evector V, module M, int kf_Reduce);
coc_bool gb_NFsAreZero(vlist vl, module M);

void GBasisOfModule(module M);

void Interreduce_this_vlist(vlist * vl, ring R );
void SyzygyModule( module M, int comps_num );

module module_leading_terms( module M, ring R );
module module_intersection(module M, module N, ring R);

#endif
