/* indet.h : $Id: indet.h,v 4.4.1.1 2004/06/18 14:24:25 cocoa Exp $ */

#ifndef INDET_H
#define INDET_H

/* ------------------------------------------------------- *\

  ADT indet_info: informations about indeterminates

\* ------------------------------------------------------- */

#ifndef AUXTYPES_H
# include "auxtypes.h"
#endif

#ifndef COCTYPES_H
# include "coctypes.h"
#endif

#define malloc_indet_info() (indet_info)mymalloc(sizeof(indet_info_aux),\
"indet_info")
#define free_indet_info(p) myfree(sizeof(indet_info_aux),p,"indet_info")

#define malloc_indet_entry() (indet_entry)mymalloc(sizeof(indet_entry_aux),\
"indet_info")
#define free_indet_entry(p) myfree(sizeof(indet_entry_aux),p,"indet_info")

indet_entry indet_entry_mk(char * ident,ivector arrinfo,ivector from);
void indet_entry_free(indet_entry e);

indet_info indet_info_init(void);
/* return an empty indet_info */

void indet_info_free(indet_info ii);
indet_info indet_info_dup(indet_info ii);
indet_entry indet_entry_dup(indet_entry e);

void indet_info_add(indet_info ii, indet_entry e);
/* add the indet_entry e to the indet_info ii */

#define indet_info_set_entry(ii,i,e) (ii)->indets[i]=(e)

unknown count_indets(indet_info ii);
/* count the indeterminates examining ii */


unknown indet_info_index2rel_unknown(indet_entry e,ivector index);

ivector indet_info_rel_unknown2index(indet_entry e,unknown u);

int indet_info_search_entry_index(indet_info ii,char * ident);

unknown indet_info_get_unknown(indet_info ii,char * ident,ivector index);
/* return the index corresponding to the indeterminate named e */

ivector indet_indices(indet_info ii, unknown u);
char * indet_name(indet_info ii, unknown u);
cterm indet_info_get_cterm(indet_info ii,unknown u);
/* return the name of the indeterminate indexed by u */

void indet_info_first_and_last(indet_info ii,char * ident,
                               unknown *first,unknown *last);

cterm indet_info2cterm(indet_info ii);

ctbuf ctbuf_indets2indetinfo(char * indets);

#endif
