%option noyywrap
%option  never-interactive

%{ /* $Id: lexical.l,v 4.4.1.1 2004/06/18 14:24:25 cocoa Exp $ */

#include "cocdefs.h"

#ifdef CA_MAC
#include "ca_mac.h"
#endif

#include <string.h>   

/* the following lines make flex scan from string instr */
extern char *yy_instr;
extern int yy_pos;

extern FILE * ii_source;

#undef YY_INPUT
#define YY_INPUT(buf, result, maxsize) \
        { int c = cdev_getc(cdev_parser); \
          buf[0]=(c == EOF ? '\001' : (char)c); \
          result =1; }

/*
CAST	Vector[ ]*\[|Mat[ ]*\[|PList[ ]*\[|VList[ ]*\[|Module[ ]*\[|Ideal[ ]*\[
*/

%}

LOWER		[a-z]
LOWERDIGIT	[a-z_0-9]
DIGIT		[0-9]
UPPER		[A-Z_]
UPPERDIGIT	[A-Z_0-9]
LETTERDIG	[0-9a-zA-Z_]
PATHCHARS	[0-9a-zA-Z_/]
ASCII		.
NONTOKEN	[\000\002-\010\012\013\014\016-\037!#()*+,-./:;<=>@\[\\\]^`{|}~\177-\377]
CAST		Mat[ ]*\[
UPPERIDENT	{UPPER}{LETTERDIG}*
PKGIDENT	${PATHCHARS}*
PKGFUNCAL	{UPPERIDENT}\.{UPPERIDENT}\(|{PKGIDENT}\.{UPPERIDENT}\(
ENDOFILE	\001

/*
This stuff was for the Macintosh interface, to handle the superscript
characters, but the rule definition is wrong for non-Macintosh machines
so I have commented it all out (anyway the Mac interface cannot be built
now that Niesi has left).
EXPDIGIT [\301\252\243\242\260\244\246\245\273\274]
EXPMINUS \320
<OK>{EXPDIGIT}{EXPDIGIT}* { Number = 
#ifdef CA_MAC
expnum(yytext); return EXPDIGITS;
#else
0; return EXPDIGITS;
#endif
 }
*/

%START COMMENT STRG OK COMMENT2 COCSTRG QLINE

%%

<QLINE>{ENDOFILE}	{ unput(';'); BEGIN OK; unput (yytext[0]); return HELPQUERY; }
<QLINE>\n	   { LineNo ++; unput(';'); BEGIN OK; unput (yytext[0]); return HELPQUERY; }
<QLINE>{ASCII}      { charbuf_putc(StringConst,yytext[0]); }

<COCSTRG>{ENDOFILE}	{ unput('\001'); BEGIN OK; return COCSTR; }
<COCSTRG>\'\'      { charbuf_putc(StringConst,'\''); }
<COCSTRG>\'        { BEGIN OK; return COCSTR; }
<COCSTRG>\n      { LineNo ++; charbuf_putc(StringConst,'\n'); }
<COCSTRG>[^']      { charbuf_putc(StringConst,yytext[0]); }

<STRG>{ENDOFILE}	{ unput('\001'); BEGIN OK; return COCSTR; }
<STRG>\"\"      { charbuf_putc(StringConst,'\"'); }
<STRG>\"        { BEGIN OK; return COCSTR; }
<STRG>\n      { LineNo ++; charbuf_putc(StringConst,'\n'); }
<STRG>[^"]      { charbuf_putc(StringConst,yytext[0]); }

<COMMENT>"*/"	{ CommentLevel --; if ( CommentLevel == 0 ) BEGIN OK; }
<COMMENT>{ENDOFILE}	{ CommentLevel = 0; unput('\001'); BEGIN OK; }
<COMMENT>"/*"	{ CommentLevel ++; }
<COMMENT>\n	{ LineNo ++; }
<COMMENT>{ASCII}	{}

<COMMENT2>{ENDOFILE}	{ unput('\001'); BEGIN OK; }
<COMMENT2>\n	{ LineNo ++; BEGIN OK; }
<COMMENT2>{ASCII}	{}

<OK>"\?"		{ StringConst=charbuf_init(50,50); BEGIN QLINE; }
<OK>{ENDOFILE}	{ return EoF; }
<OK>\'		{ StringConst=charbuf_init(50,50); BEGIN COCSTRG; }
<OK>\"		{ StringConst=charbuf_init(50,50); BEGIN STRG; }
<OK>"/*"	{ CommentLevel = 1; BEGIN COMMENT; }
<OK>"//"	{ BEGIN COMMENT2; }
<OK>"--"	{ BEGIN COMMENT2; }

<OK>\n	{ LineNo ++; }

<OK>"::"	{ return COCOLON; }
<OK>"<<"	{ return SOURCE; }

<OK>"::="	{ return RINGASSIGN; }

<OK>"..."	{ return DOTS; }

<OK>".."	{ return DOTDOT; }

<OK>":="	{ return ASSIGN; }

<OK>":"		{ return COLON; }

<OK>\&		{ return AMPERSAND; }

<OK>"."		{ return DOT; }

<OK>N[Oo][Tt]	{ return NOT; }
<OK>N[Oo][Tt]"("	{ unput('(');return NOT; }

<OK>"OR"	{ return OR; }
<OK>"Or"	{ return OR; }

<OK>"AND"	{ return AND; }
<OK>"And"	{ return AND; }

<OK>"<="	{ return LESSOREQUAL;}
<OK>">="	{ return GREATEROREQUAL; }

<OK>"="		{ return EQUAL; }
<OK>"<>"	{ return DIFFERENT; }
<OK>"><"	{ return CARTESIAN; }

<OK>"%"		{ return ZP; }

<OK>"/"		{ return FRAC; }

<OK>Xel	{ Ident = my_strdup(yytext); Operator=op_XEL; return RESERVED; }
<OK>Lex	{ Ident = my_strdup(yytext); Operator=op_LEX; return RESERVED; }
<OK>DegLex	{ Ident = my_strdup(yytext); Operator=op_DEGLEX; return RESERVED; }
<OK>DegRevLex	{ Ident = my_strdup(yytext); Operator=op_DEGREVLEX; return RESERVED; }
<OK>ToPos	{ Ident = my_strdup(yytext); Operator=op_TO_POS; return RESERVED; }
<OK>PosTo	{ Ident = my_strdup(yytext); Operator=op_POS_TO; return RESERVED; }

<OK>BOOL	{ Ident = my_strdup(yytext); Operator=op_objtype_bool; return RESERVED; }
<OK>DEVICE	{ Ident = my_strdup(yytext); Operator=op_objtype_cdev; return RESERVED; }
<OK>ERROR	{ Ident = my_strdup(yytext); Operator=op_objtype_err; return RESERVED; }
<OK>FUNCTION	{ Ident = my_strdup(yytext); Operator=op_objtype_cocfun; return RESERVED; }
<OK>IDEAL	{ Ident = my_strdup(yytext); Operator=op_objtype_ideal; return RESERVED; }
<OK>INT		{ Ident = my_strdup(yytext); Operator=op_objtype_arbint; return RESERVED; }
<OK>LIST	{ Ident = my_strdup(yytext); Operator=op_objtype_olist; return RESERVED; }
<OK>MAT		{ Ident = my_strdup(yytext); Operator=op_objtype_omat; return RESERVED; }
<OK>MODULE	{ Ident = my_strdup(yytext); Operator=op_objtype_module; return RESERVED; }
<OK>NULL	{ Ident = my_strdup(yytext); Operator=op_objtype_NULL; return RESERVED; }
<OK>POLY	{ Ident = my_strdup(yytext); Operator=op_objtype_poly; return RESERVED; }
<OK>RAT		{ Ident = my_strdup(yytext); Operator=op_objtype_arbrat; return RESERVED; }
<OK>RATFUN	{ Ident = my_strdup(yytext); Operator=op_objtype_ratfun; return RESERVED; }
<OK>RECORD	{ Ident = my_strdup(yytext); Operator=op_objtype_record; return RESERVED; }
<OK>RING	{ Ident = my_strdup(yytext); Operator=op_objtype_ring; return RESERVED; }
<OK>STRING	{ Ident = my_strdup(yytext); Operator=op_objtype_string; return RESERVED; }
<OK>TAGGED	{ Ident = my_strdup(yytext); Operator=op_objtype_tagged; return RESERVED; }
<OK>TYPE	{ Ident = my_strdup(yytext); Operator=op_objtype_objtype; return RESERVED; }
<OK>VECTOR	{ Ident = my_strdup(yytext); Operator=op_objtype_pvector; return RESERVED; }
<OK>ZMOD	{ Ident = my_strdup(yytext); Operator=op_objtype_zp; return RESERVED; }

<OK>Null	{ Ident = my_strdup(yytext); Operator=op_NULL_VALUE; return RESERVED; }
<OK>NewLine	{ Ident = my_strdup(yytext); Operator=op_NEWLINE; return RESERVED; }

<OK>A[Ll][Ii][Aa][Ss]		{ return ALIAS; }
<OK>B[Ll][Oo][Cc][Kk]		{ return BLOCK; }
<OK>B[Rr][Ee][Aa][Kk]		{ return BREAK; }
<OK>C[Aa][Tt][Cc][Hh] 		{ return CATCH; }
<OK>C[Ll][Ee][Aa][Rr]		{ return CLEAR; }
<OK>C[Oo][Nn][Dd]		{ return COND; }
<OK>D[Ee][Ff][Ii][Nn][Ee] 	{ return DEFINE; }
<OK>D[Ee][Ll][Ee][Tt][Ee]	{ return DELETA; }
<OK>D[Ee][Ss][Tt][Rr][Oo][Yy]		{ return DESTROY; }
<OK>D[Ee][Ss][Cc][Rr][Ii][Bb][Ee]	{ return DESCRIBE; }
<OK>D[Ee][Ss][Cc][Rr][Ii][Bb][Ee]"("	{ unput('('); return DESCRIBE; }
<OK>D[Oo]			{ return DO; }
<OK>E[Ll][Ss][Ee]	{ return ELSE; }
<OK>E[Ll][Ss][Ii][Ff]	{ return ELIF; }
<OK>E[Oo][Ff]	{ return EoF; }
<OK>E[Nn][Dd]		{ return END; }
<OK>E[Nn][Dd][Aa][Ll][Ii][Aa][Ss]		{ return ENDALIAS; }
<OK>E[Nn][Dd][Bb][Ll][Oo][Cc][Kk]		{ return ENDBLOCK; }
<OK>E[Nn][Dd][Cc][Aa][Tt][Cc][Hh]		{ return ENDCATCH; }
<OK>E[Nn][Dd][Cc][Oo][Nn][Dd]   		{ return ENDCOND; }
<OK>E[Nn][Dd][Dd][Ee][Ff][Ii][Nn][Ee]		{ return ENDDEFINE; }
<OK>E[Nn][Dd][Ff][Oo][Rr]       		{ return ENDFOR; }
<OK>E[Nn][Dd][Ff][Oo][Rr][Ee][Aa][Cc][Hh]	{ return ENDFOREACH; }
<OK>E[Nn][Dd][Ii][Ff]           		{ return ENDIF; }
<OK>E[Nn][Dd][Pp][Aa][Cc][Kk][Aa][Gg][Ee]	{ return ENDPACKAGE; }
<OK>E[Nn][Dd][Rr][Ee][Pp][Ee][Aa][Tt]		{ return ENDREPEAT; }
<OK>E[Nn][Dd][Uu][Ss][Ii][Nn][Gg]		{ return ENDUSING; }
<OK>E[Nn][Dd][Ww][Hh][Ii][Ll][Ee]		{ return ENDWHILE; }
<OK>F[Aa][Ll][Ss][Ee]	        { return FALSe; }
<OK>F[Oo][Rr]			{ return FOR; }
<OK>F[Oo][Rr][Ee][Aa][Cc][Hh]  	{ return FOREACH; }
<OK>I[Ff]			{ return IF; }
<OK>I[Nn]			{ return In; }
<OK>I[Ss][Ii][Nn]		{ return ISIN; }
<OK>H[Ee][Ll][Pp]		{ return HELP; }
<OK>O[Nn]			{ return ON; }
<OK>P[Aa][Nn][Ee][Ll]	        { return PANEL; }
<OK>P[Aa][Nn][Ee][Ll]"("	{ unput('(');return PANEL; }
<OK>P[Aa][Cc][Kk][Aa][Gg][Ee]	{ return PACKAGE; }
<OK>P[Rr][Ii][Nn][Tt]		{ return PRINT; }
<OK>P[Rr][Ii][Nn][Tt][Ll][Nn]	{ return PRINTLN; }
<OK>C[Ii][Aa][Oo]		{ return QUIT; }
<OK>Q[Uu][Ii][Tt]		{ return QUIT; }
<OK>R[Ee][Cc][Oo][Rr][Dd]	{ return RECORD; }
<OK>R[Ee][Tt][Uu][Rr][Nn]	{ return RETURn; }
<OK>R[Ee][Tt][Uu][Rr][Nn]"("	{ unput('('); return RETURn; }
<OK>R[Ee][Pp][Ee][Aa][Tt]	{ return REPEAT; }
<OK>S[Ee][Tt]			{ return SET; }
<OK>S[Kk][Ii][Pp]		{ return SKIP; }
<OK>S[Oo][Uu][Rr][Cc][Ee]	{ return SOURCE; }
<OK>S[Tt][Ee][Pp]		{ return STEP; }
<OK>T[Hh][Ee][Nn]	{ return THEN; }
<OK>T[Ii][Mm][Ee]	{ return TIMe; }
<OK>T[Oo]		{ return TO; }
<OK>T[Rr][Uu][Ee]	{ return TRUe; }
<OK>U[Nn][Ss][Ee][Tt]	{ return UNSET; }
<OK>U[Nn][Tt][Ii][Ll]	{ return UNTIL; }
<OK>U[Ss][Ee]		{ return USE; }
<OK>U[Ss][Ii][Nn][Gg]	{ return USING; }
<OK>V[Aa][Rr]		{ return VAR; }
<OK>V[Aa][Rr]"("	{ unput('(');return VAR; }
<OK>"."V[Aa][Rr]"("	{ unput('(');return DOTVAR; }
<OK>W[Hh][Ii][Ll][Ee]	{ return WHILE; }
<OK>"Z/"	{ return ZMOD; }

<OK><<EOF>>	{ return EoF; }

<OK>{NONTOKEN}	{ return yytext[0]; }

<OK>{DIGIT}{DIGIT}* { Number = my_strdup(yytext); return DIGITS; }

<OK>{PKGFUNCAL} { 
    int n;
    char * Ident_pkg;
    char * Ident_op;
    unput('(');
    yytext[strlen(yytext)-1]='\0'; /* TODO: PORCATA */
    Ident = my_strdup(yytext);
    n=strlen(Ident);
    Ident_pkg = my_strtok(Ident,".");
    Ident_op = my_strtok(NULL,"");
    if (my_strcasecmp(Ident_op,"Var") == 0) {
      unput('r'); unput('a'); unput('V'); unput('.'); return UPPER_IDENT;
    }
    free_str(n,Ident);
    Ident = my_strdup(yytext);
    return PACKAGE_OPERATOR_IDENT;
    }

<OK>{UPPERIDENT}"(" { unput('(');
    yytext[strlen(yytext)-1]='\0'; /* TODO: PORCATA */
    Ident = my_strdup(yytext);
    return FUN_IDENT;
    }

<OK>{UPPERIDENT} { 
    Ident = my_strdup(yytext);
    return UPPER_IDENT;
    }

<OK>{PKGIDENT} { 
    Ident = my_strdup(yytext);
    return PKG_ID; }

<OK>{CAST} { unput('[');
    yytext[strlen(yytext)-1]='\0'; /* TODO: PORCATA */
    Ident = my_strdup_nospaces(yytext);
    Operator=(coop)op_map_coop(pkg_builtin_n,(nome)Ident);
    free_str(strlen(Ident),Ident);
    return OPERATOR_CAST; }

<OK>{LOWER} { Ident=my_strdup(yytext); return INDET; }

<OK>[\t \015]*		;

<OK>{ASCII}	{ yyerror( "Unrecognized character" ); }

{ASCII}		{ BEGIN OK; unput ( yytext [ 0 ] ); }

\n		{ BEGIN OK; unput ( yytext [ 0 ] ); }

%%
