/* $Id: machine.h,v 4.4.1.1 2004/06/18 14:24:25 cocoa Exp $ */
/* cocoa machine-dependent functions */

#ifndef MACHINE_H
#define MACHINE_H

#include <stdio.h>
#include <time.h>

#ifdef SIS_MAC

#  include "coc_mac.h"

#elif defined(SIS_DOS)

#  include "coc_dos.h"
 
#elif defined(SIS_WIN32)

#  include "coc_w32.h"

#elif defined(SIS_UNIX)

#  include "coc_unix.h"

#else

#  error "Undefined Operative System"

#endif

void get_time(clock_t * t); /* returns elapsed time */
void get_cputime(clock_t * t);
clock_t cputime_diff(clock_t t1, clock_t t2);
char * get_date(char * fmt);
char * build_path(char * p /* slash separated path */);
/* converts p to the pathname for the local platform */

void my_fputs(char *s, FILE * f);
void my_fflush(FILE * f);

#endif
