/* map.h : 0.5 : 21 Dec 94 : map library header */

/*------------------------------------------------------------------------------

	Part of project "map".

	Revision history

	0.3	modifications for portable version map/sequential2
	0.4	modified MAX_NUM_NAMES_FOR_MAP and MAX_NUM_MAPS

------------------------------------------------------------------------------*/

#ifndef MAP_H
#define MAP_H

#include <stdio.h>

#ifndef UTILS_H
# include "utils.h"
#endif

#define malloc_name(size) (char *)mymalloc((size+1)*sizeof(char),"name")
#define free_name(p) myfree((strlen(p)+1)*sizeof(char),p,"name")

#define realloc_map(m,n) \
  (map)myrealloc(m,(map_len(m))*sizeof(nome),\
  (map_len(m)+n*SIZE_OF_MAP_BLOCK)*sizeof(nome),"map")
#define malloc_map(n) (map)mymalloc(n*(SIZE_OF_MAP_BLOCK+2)*sizeof(nome),"map")
#define free_map(p) myfree((map_len(p))*sizeof(nome),p,"map")

#define map_last_id(m) ((name_id)(m)[0])
#define map_len(m) ((int)(m)[1])
#define map_is_full(m) (map_last_id(m)==map_len(m)-1)
#define map_get_name(m,n) ((m)[n])

#define map_set_last_id(m,id) (m)[0]=(nome)(id)
#define map_set_len(m,n) (m)[1]=(nome)(n)
#define map_set_name(m,n,e) (m)[n]=e

extern map map_empty;

/* CONSTRUCTORS of map */

void map_init_maps(void);

map map_new(void);
/* creates a new map and returns its id (identifier).
   if there are no more maps it returns map_NULL */

name_id map_add(map * m,nome n);
/* add the name n to the map m and returns the id for n */

name_id map_append(map m,nome n);
/* appends the name n to the end of map m and returns the name identifier */
/* if map is full the behaviour is unpredictable */

void map_free(map * m);

/* FUNCTIONS on map */

name_id map_get_name_id(map m, nome n);
/* returns the id of name n in the map m */
/* if not exists it returns name_id_NULL */

int map_num_starting(map m, nome n);
/* returns the number of the names starting with n */

name_id map_next_starting(map m, nome n, name_id from);
/* returns the id of the first name of m starting with n, greater than from */


/* I/O MANIPULATION a sample */

#if 0

void fprintf_map(FILE * f,map m);
/* prints the whole map m */

void fprintf_name(FILE * f,nome n);
/* prints out the name n */

#endif

#endif
