/* $Id: math_lib.h,v 4.4.1.1 2004/06/18 14:24:25 cocoa Exp $ */

#ifndef MATH_LIB_H
#define MATH_LIB_H

#ifndef OBJECT_H
# include "object.h"
#endif

object do_lin_ker(object o);
object do_lin_sol(object o1, object o2);

object do_map(object o1, ring R2, object o2);

object do_zpmk(object o1, object o2, ring R);
object do_log(object o,ring R);
object do_bin_toric(object o1, object o2, ring R);
object do_mat_toric(object o, ring R);
object do_fact(object o);
object do_factor(object o);
object do_gcd(object f, object g);
object do_isqrt(object o);
object do_iroot(object o1, object o2);
object do_QZP(object o, ring R);
object do_ZPQ(object o, ring R);
object do_subst(object o, subst s);
object do_IsPPrime(object o);
object do_NextPPrime(object o);
object do_PowerMod(object o1, object o2, object o3);

object do_res(object o);

coc_bool object_is_zero(object o);
object do_is_homog(object o);
coc_bool do_is_in(object o1,object o2);
coc_bool do_is_eq(object o1,object o2);
coc_bool do_is_lt(object o1,object o2);
object object_zero(objtype t,ring R);

object do_homog(object o, unknown x, ring R);
object do_der(object o, int * der_list);

object do_dense_poly(int deg,ring R);

object do_gbasis(object o,object o1,object o2,int n);
/* return a new object containing the basis of the ideal/module o */

object do_syz(object o, ring R);
/* return a new object containing the syzygy module of the ideal/module o */

object do_randomized(object o);

object do_mvpoincare_quotient(object o, object o1, ring MVP);

object do_poincare_quotient(object o);
object do_ispurelt(arpoly f);
int do_deg(object o);
object do_mdeg(object o);
int do_size(object o);
int do_len(object o);

object do_component(object o,int index);
object do_head(object o);
object do_tail(object o);
object do_gens(object o);

object do_det(object o);
object do_adj(object o);
object do_minors(object o,int p);

object do_power(object o,int exponent);
/* return the power of the object o */

void do_inv(object * o);
/* return the inverse of the object o */

object do_subtract(object o1,object o2);
/* returns v1-v2 in the ring R */

object do_sum(object o1,object o2);
/* returns v1+v2 in the ring R */

object do_concat(object o1,object o2);
object do_append(object o1,object o2);
object do_remove(object o1, int n);

object do_lcm(object o1,object o2);
/* object do_gcd(object o1,object o2); */ /* TODO: DELETE */

object do_intersection(object o1,object o2);


object do_div(object o1,object o2);
/* returns v1/v2 in the ring R */

object do_frac(object o1,object o2);

object do_mod(object o1,object o2);

object do_mult(object o1,object o2);
/* returns v1*v2 in the ring R */

object do_eval_nf(object o1, object o2, ring R);

object do_eval_leading_term(object o, ring R);
object do_eval_leading_coeff(object o, ring R);

object do_eval_elim(unknown u1,unknown u2,object o,object o1,object o2,int n);

object do_change_sign(object o);

#endif
