/* $Id: mathcoc.h,v 4.4.1.1 2004/06/18 14:24:25 cocoa Exp $

[ auxiliary ]

------------------------------------------------------------------------------*/

#ifndef MATH_H
#define MATH_H

#define malloc_MP_INT(X) X=(MP_INT)MPmalloc(sizeof(MP_INT))
#define mpz_fprintf(F,X) mpz_out_str(F,10,X);

#ifndef CTERM_H
# include "cterm.h"
#endif

#ifndef OBJECT_H
# include "object.h"
#endif

#define eval_left_expr_not_declare(t,R) eval_left_expr(t,FALSE,R)
#define eval_left_expr_declare(t,R) eval_left_expr(t,TRUE,R)

extern object math_error;
int funcall_level;

/* general MATH functions */

void mi_init(void);

object eval_caller(cterm t,ring R);
object eval_ringenv(cterm t_ring,cterm t_mod,ring R);

object eval(cterm t,ring R);
/* returns the result of the evaluation of the (expression) term t in the
   environment for the ring R */

ring eval_ring(cterm t,ring R);
/* evaluation of a ring expression */



/* ------------------------------------------------- *\
   math HANDLERS
\* ------------------------------------------------- */

object mi_adjoint(cterm t, ring R);
object mi_aliases(cterm t, ring R);
object mi_ascii(cterm t, ring R);
object mi_all(cterm t, ring R);
object mi_append(cterm t, ring R);
object mi_add_device(cterm t, ring R);
object mi_base_ring(cterm t, ring R);
object mi_bin_toric(cterm t, ring R);
object mi_bin_seqtoric(cterm t, ring R);
object mi_bin_partoric(cterm t, ring R);
object mi_bool(cterm t, ring R);
object mi_bm(cterm t, ring R);
object mi_call(cterm t, ring R);
object mi_cartesian(cterm t, ring R);
object mi_cast(cterm t, ring R);
object mi_change_sign(cterm t,ring R);
object mi_cip(cterm t, ring R);
object mi_characteristic(cterm t,ring R);
object mi_cocoa_packages(cterm t, ring R);
object mi_component(cterm t, ring R);
object mi_concat(cterm t, ring R);
object mi_cocolon(cterm t, ring R);
object mi_cond(cterm t, ring R);
object mi_curr_ring(cterm t, ring R);
object mi_debug_version(cterm t, ring R);
object mi_date(cterm t, ring R);
object mi_deg(cterm t,ring R);
object mi_dense_poly(cterm t, ring R);
object mi_der(cterm t, ring R);
object mi_det(cterm t, ring R);
object mi_div(cterm t,ring R);
object mi_eod(cterm t,ring R);
object mi_elim(cterm t,ring R);
object mi_env(cterm t, ring R);
object mi_error(cterm t, ring R);
object mi_fact(cterm t, ring R);
object mi_factor(cterm t, ring R);
object mi_gbm(cterm t, ring R);
object mi_gcd(cterm t, ring R);
object mi_frac(cterm t,ring R);
object mi_fun_appl(cterm t,ring R);
cterm mi_expand_fun_appl(cterm t,ring R);
object mi_fields(cterm t,ring R);
object mi_function(cterm t,ring R);
object mi_gb_all(cterm t, ring R);
object mi_gb_init(cterm t, ring R);
object mi_gb_one_move(cterm t, ring R);
object mi_gb_stat(cterm t, ring R);
object mi_gbasis(cterm t, ring R);
object mi_gens(cterm t, ring R);
object mi_get(cterm t, ring R);
object mi_getenv(cterm t, ring R);
object mi_geterrmesg(cterm t, ring R);
object mi_head(cterm t, ring R);
object mi_help(cterm t, ring R);
#ifdef COCOA_HOOK
object mi_hook(cterm t, ring R);
#endif
object mi_homog(cterm t,ring R);
object mi_infos(cterm t, ring R);
object mi_ideal(cterm t,ring R);
object mi_imm(cterm t,ring R);
object mi_init_cdev(cterm t, ring R);
object mi_indet(cterm t,ring R);
object mi_in_elim(cterm t,ring R);
object mi_indet_ind(cterm t, ring R);
object mi_indet_index(cterm t, ring R);
object mi_indet_name(cterm t, ring R);
object mi_indet_nth(cterm t, ring R);
object mi_intersection(cterm t,ring R);
object mi_ispurelt(cterm t, ring R);
object mi_is_ring_indep(cterm t, ring R);
object mi_is_ring_hom(cterm t, ring R);
object mi_is_homog(cterm t,ring R);
object mi_is_zero(cterm t,ring R);
object mi_isqrt(cterm t, ring R);
object mi_iroot(cterm t, ring R);
object mi_lin_sol(cterm t, ring R);
object mi_lin_ker(cterm t, ring R);
object mi_label(cterm t, ring R);
object mi_lcm(cterm t, ring R);
object mi_leading_coeff(cterm t, ring R);
object mi_leading_term(cterm t, ring R);
object mi_len(cterm t,ring R);
object mi_list(cterm t,ring R);
object mi_log(cterm t, ring R);
object mi_map(cterm t, ring R);
object mi_mat(cterm t, ring R);
object mi_mat_toric(cterm t, ring R);
object mi_mat_seqtoric(cterm t, ring R);
object mi_mat_partoric(cterm t, ring R);
object mi_mdeg(cterm t,ring R);
object mi_memory(cterm t,ring R);
object mi_minors(cterm t,ring R);
object mi_mod(cterm t,ring R);
object mi_module(cterm t,ring R);
object mi_mult(cterm t, ring R);
object mi_mvpoincare(cterm t, ring R);
object mi_new_list(cterm t, ring R);
object mi_new_mat(cterm t, ring R);
object mi_new_id(cterm t, ring R);
object mi_new_vector(cterm t, ring R);
object mi_NewPPStream(cterm t, ring R);
object mi_NextPP(cterm t, ring R);
object mi_AvoidLastPP(cterm t, ring R);
object mi_NextPrime(cterm t, ring R);
object mi_NextPPrime(cterm t, ring R);
object mi_Mod2Rat(cterm t, ring R);
object mi_null(cterm t, ring R);
object mi_num_indets(cterm t,ring R);
object mi_objtype(cterm t, ring R);
object mi_olistcast(cterm t, ring R);
object mi_ord(cterm t, ring R);
object mi_packages(cterm t, ring R);
object mi_path(cterm t, ring R);
object mi_panels(cterm t, ring R);
object mi_parenthesis(cterm t, ring R);
object mi_poincare_quotient(cterm t,ring R);
object mi_poly(cterm t,ring R);
object mi_power(cterm t, ring R);
object mi_PowerMod(cterm t, ring R);
object mi_IsPPrime(cterm t, ring R);
object mi_put(cterm t, ring R);
object mi_QZP(cterm t, ring R);
object mi_ZPQ(cterm t, ring R);
object mi_randomized(cterm t, ring R);
object mi_range(cterm t, ring R);
object mi_record(cterm t, ring R);
object mi_remove(cterm t, ring R);
object mi_remove_device(cterm t, ring R);
object mi_record_sel(cterm t, ring R);
object mi_res(cterm t, ring R);
object mi_ring(cterm t, ring R);
#ifdef DEBUG
object mi_rum_stat(cterm r, ring R);
#endif
object mi_seed(cterm t, ring R);
object mi_size(cterm t,ring R);
object mi_starting(cterm t,ring R);
object mi_string(cterm t, ring R);
object mi_helpquery(cterm t, ring R);
object mi_subst(cterm t, ring R);
object mi_subtract(cterm t, ring R);
object mi_sum(cterm t, ring R);
object mi_system(cterm t, ring R);
object mi_syz(cterm t,ring R);
object mi_tag(cterm t, ring R);
object mi_tail(cterm t, ring R);
object mi_tao(cterm t, ring R);
object mi_time(cterm t, ring R);
object mi_typeof(cterm t, ring R);
object mi_unlabel(cterm t, ring R);
object mi_user_function_aux(cterm vars, cterm body, olist args,
                            cterm actual_par, ring R);
object mi_user_function(cterm t,ring R);
object mi_var(cterm t,ring R);
object mi_vector(cterm t, ring R);
object mi_zpmk(cterm t, ring R);

object mi_anna_BuiltinTestSet(cterm t, ring R);
object mi_anna_BuiltinTestSetLex(cterm t, ring R);
object mi_anna_BuiltinTestSetXel(cterm t, ring R);
object mi_anna_BuiltinNonNegSol(cterm t, ring R);

object mi_jaa_eval(cterm t, ring R);

object mi_support(cterm t, ring R);
object mi_monomials(cterm t, ring R);
object mi_coeffs(cterm t, ring R);

object mi_isposto(cterm t, ring R);
object mi_istopos(cterm t, ring R);
object mi_firstnonzero(cterm t, ring R);
object mi_firstnonzeropos(cterm t, ring R);

object mi_isterm(cterm t, ring R);
object mi_lpos(cterm t, ring R);
object mi_lpp(cterm t, ring R);
object mi_lm(cterm t, ring R);
object mi_coeffofterm(cterm t, ring R);
object mi_nr(cterm t, ring R);

object mi_limits(cterm t, ring R);
object mi_time_aux(cterm t, ring R);

ring eval_ring_var(cterm t,ring R);
void mi_whereis_var(coop op, char * id, env * e, loc * l, ring R);

coc_bool eval_bool(cterm t,ring R);
/* evaluate a boolean expression */

unknown mi_cterm2unknown(cterm t, ring R);
unknown mi_cterm2unknown_bis(cterm t, ring R);

coc_bool mi_and(cterm t1, cterm t2, ring R);
coc_bool mi_not(cterm t, ring R);
coc_bool mi_or(cterm t1, cterm t2, ring R);

/*
#define eval_int(t,R) object_cast_int(eval(t,R))
*/

int eval_int_var(cterm t,ring R);
/* used by eval_int: return the integer value referenced by the var t */

unknown eval_indet_var(cterm t,ring R);

coc_bool eval_bool_var(cterm t,ring R);
unknown eval_indet(cterm t,ring R);

olist eval_params(cterm t, cterm vars, ring R);

void update_out_variables(cterm vars, cterm args, olist ivalues, env proc_env, ring R);

coc_bool assign_parameter_variables(cterm vars,olist ol,env new_env,ring R);

/* bool assign_parameter_variables(cterm vars,cterm args,ring R); */
/* evaluates the argument args and assign to the variables vars of R */

unknown eval_indet_nth(cterm t, ring R);

object mi_olistcast(cterm t, ring R);
object mi_plistcast(cterm t, ring R);
object mi_vlistcast(cterm t, ring R);

object mi_gauss(cterm t, ring R);
object mi_nres(cterm t,ring R);
object mi_vlist(cterm t,ring R);
object mi_float(cterm t,ring R);

ring eval_ring_zp(cterm t,ring R);
/* evaluate a ring module p */

ring eval_coeff_ring(short int c);
/* evaluate a ring of coefficients */

indet_info eval_indet_info(cterm t, ring R);
void eval_range(cterm t,int *x,int *y,ring R);

indet_entry eval_indet_entry(cterm t,ring R);
ring eval_ring_constr(cterm t, ring R);
short int eval_characteristic(cterm t,ring R);
void set_ordering(cterm t, ring poly_R, ring R);

void set_weights(cterm t, ring poly_R, ring R);

ring eval_poly_ring(cterm t,ring R);
/* evaluate a ring of polynomials */
void apply_ring_modifiers(cterm t, ring New_R, ring R);
void apply_ring_modifier(cterm t, ring New_R, ring R);


loc eval_left_expr(cterm t,coc_bool declare_if_not,ring R);
/* returns the location pointed by the left expression t */

char * eval_var_name(cterm t, ring R);
char * eval_param_name(cterm t, ring R);

object eval_pseries(cterm t1, cterm t2, ring R);

object eval_unipoly(cterm t, ring R);

/* mi (math interface) for math-functions */

int cterm2int(cterm t);
/* return the an int starting from a cterm of type number */

void mi_indets_range(cterm t,unknown * u1,unknown * u2,ring R);

/* boolean evaluations */

coc_bool mi_is_eq(cterm t1,cterm t2,ring R);
coc_bool mi_is_lt(cterm t1,cterm t2,ring R);
coc_bool mi_is_in(cterm t1,cterm t2,ring R);
coc_bool mi_is_le(cterm t1,cterm t2,ring R);
coc_bool mi_is_defined(cterm t,ring R);

#endif
