/* $Id: matrix.h,v 4.4.1.1 2004/06/18 14:24:25 cocoa Exp $ */

#ifndef MATRIX_H
#define MATRIX_H

#ifndef UTILS_H
# include "utils.h"
#endif

#define matrix_row(M,i) ((M)[i])
#define matrix_set_row(M,i,r) (M)[i]=(r)

#define matrix_elem(M,i,j)  ((M)[i][j])
#define matrix_set_elem(M,i,j,e)  (M)[i][j]=(e)

#define submat_elems(M) ((M)->elems)
#define submat_row(M,i) iv_get_nth(M->rr,i+1)
#define submat_col(M,j) iv_get_nth(M->cc,j+1)
#define submat_elem(M,i,j) \
  matrix_elem(submat_elems(M),submat_row(M,i),submat_col(M,j))
#define submat_num_rows(M) ((M)->m)
#define submat_num_cols(M) ((M)->n)
#define submat_rows(M) ((M)->rr)
#define submat_cols(M) ((M)->cc)

#define submat_set_elems(M,E) (M)->elems=(E)
#define submat_set_row(M,i,r) iv_set_nth(M->rr,i+1,r)
#define submat_set_col(M,j,c) iv_set_nth(M->cc,j+1,c)
#define submat_set_num_rows(M,x) (M)->m=(x)
#define submat_set_num_cols(M,x) (M)->n=(x)
#define submat_set_rows(M,RR) (M)->rr=(RR)
#define submat_set_cols(M,CC) (M)->cc=(CC)

#define malloc_matrix(m) (matrix)mymalloc(sizeof(matrix_row)*(m),"matrix")
#define free_matrix(m,p) myfree(sizeof(matrix_row)*(m),p,"matrix")

#define malloc_matrix_row(n) \
  (matrix_row)mymalloc(sizeof(matrix_el)*(n),"matrix_row")
#define free_matrix_row(n,p) myfree(sizeof(matrix_el)*(n),p,"matrix_row")

#define malloc_submat() (submat)mymalloc(sizeof(submat_info),"submat")
#define free_submat(p) myfree(sizeof(submat_info),p,"submat")


/* matrix */

matrix matrix_init(int m, int n);
void matrix_free(matrix M,int m, int n);
matrix submat2matrix(submat S);
matrix_el matrix_det(matrix M,int n);
matrix matrix_adjoint(matrix M,int n);

/* submat */

submat matrix2submat(matrix M,int m,int n);
submat submat_mk(matrix M, int m, int n, ivector rr, ivector cc);
void submat_free(submat S);
submat submat_elim_row(submat S, int row);
submat submat_elim_col(submat S, int col);
submat submat_elim_rc(submat S,int row,int col);

matrix_el submat_det(submat S);

#endif
