/* $Id: module.h,v 4.4.1.1 2004/06/18 14:24:25 cocoa Exp $ */

#ifndef MODULE_H
#define MODULE_H

#ifndef AUXTYPES_H
# include "auxtypes.h"
#endif

#ifndef COCTYPES_H
# include "coctypes.h"
#endif

#define module_wip(M) gb_Something_Incoming(M)

#define module_set_flags(M,F) (M)->module_flags=(F)
#define module_flags(M) ((M)->module_flags)
#define module_flag_is_freemod 128

#define module_flag_set(M,n) do{(M)->module_flags |= 1<<(n-1);}while (FALSE)
#define module_flag_get(M,n) (((M)->module_flags & (1<<(n-1))) != 0)
#define module_flag_reset(M,n) \
  do{(M)->module_flags &= ~(1<<(n-1));}while (FALSE)

#define module_set_flag_is_homog(M) \
  module_flag_set(M, module_FLAG_IS_HOMOG)
#define module_set_flag_syz_of_mingens(M) \
  module_flag_set(M, module_FLAG_SYZ_OF_MINGENS)

#define module_reset_flag_is_homog(M) \
  module_flag_reset(M, module_FLAG_IS_HOMOG)
#define module_reset_flag_syz_of_mingens(M) \
  module_flag_reset(M, module_FLAG_SYZ_OF_MINGENS)

#define module_flag_is_homog(M) \
  module_flag_get(M, module_FLAG_IS_HOMOG)
#define module_flag_syz_of_mingens(M) \
  module_flag_get(M, module_FLAG_SYZ_OF_MINGENS)

#define malloc_module() (module)mymalloc(sizeof(module_info),"module")
#define free_module(p) myfree(sizeof(module_info),p,"module")

#define module_gb_initialized(M) ((M)->gb.initialized)
#define module_gb_set_initialized(M,B) (M)->gb.initialized=(B)

#define module_discrepancy(M) ((M)->gb.discrepancy)
#define module_set_discrepancy(M,D) (M)->gb.discrepancy=(D)

#define module_stat(M,i) ((M)->gb.stats[i])
#define module_stat_incr(M,i) (M)->gb.stats[i]++
#define module_stat_add(M,i,n) (M)->gb.stats[i]+=(n)
#define module_set_stat(M,i,S) (M)->gb.stats[i]=S

#define module_generated_by_pvcomp(p,R) \
  module_generated_by_this_pv(pv_pvcomp2pv(p,0,1,R),R)

#define module_generated_by_arpoly(p,R) \
  module_generated_by_this_pv(pv_arpoly2pv(p,0,1,R),R)

#define module_decrement_discrepancy(M) (M)->gb.discrepancy--

#define module_gens_ck(M) \
  (((M)->gens == vlist_NULL) || (vlist_len((M)->gens)==0) ? \
   (((M)->mingens != vlist_NULL) ? (M)->mingens : (M)->gens) : (M)->gens)

#define module_gens(M) ((M)->gens)

#define module_mingens(M) ((M)->mingens)
#define module_gbasis(M) ((M)->gbasis)
#define module_pseries(M) ((M)->pser)
#define module_mvpseries(M) ((M)->mvpser)
#define module_rank(M) ((M)->r)
#define module_shifts(M) ((M)->ss)
#define module_shift_nth(M,I) (shifts_nth(M->ss,I))
#define module_DegTrunc(M) ((M)->gb.deg_trunc)
#define module_ResTrunc(M) ((M)->gb.res_trunc)
#define module_RegTrunc(M) ((M)->gb.reg_trunc)
#define module_NumNew(M) ((M)->gb.num_new)
#define module_ElimIndets(M) ((M)->gb.elim_indets)
#define module_syz(M) ((M)->syz)
#define module_zys(M) ((M)->zys)
#define module_SyzCompsNum(M) ((M)->gb.syz_trunc)
#define module_ring(M) ((M)->R)
#define module_rc(E) ((E)->rc)

#define module_has_mingens(M) ((M)->mingens != vlist_NULL)

#define module_set_ring(M,newR) (M)->R=newR
#define module_set_gens(M,G) (M)->gens=G
#define module_set_mingens(M,G) (M)->mingens=G
#define module_set_gbasis(M,B) (M)->gbasis=B
#define module_set_pseries(M,PS) (M)->pser=(PS)
#define module_set_mvpseries(M,PS) (M)->mvpser=(PS)
#define module_set_rank(M,R) (M)->r=R
#define module_set_shifts(M,S) (M)->ss=S
#define module_set_DegTrunc(M,T) (M)->gb.deg_trunc=(T)
#define module_set_syz(M,S) (M)->syz=S
#define module_set_zys(M,S) (M)->zys=S
#define module_set_SyzCompsNum(M,T) (M)->gb.syz_trunc=(T)
#define module_set_ResTrunc(M,T) (M)->gb.res_trunc=(T)
#define module_set_RegTrunc(M,T) (M)->gb.reg_trunc=(T)
#define module_set_ElimIndets(M,E) (M)->gb.elim_indets=(E)
#define module_set_rc(E,R) (E)->rc=(R)

#define module_incr_rc(ev) ((ev)->rc++)
#define module_decr_rc(ev) ((ev)->rc--)

#define module_link(ev) \
  (ev != module_NULL ? (module_incr_rc(ev),ev) : module_NULL)

#define module_unlink_do(M,R) \
  do { module_decr_rc(M); \
       if (module_rc(M)==0) module_free(M,R);} while(FALSE)

#define module_unlink(M,R) if ((M)!=module_NULL) module_unlink_do(M,R)

#define md_gbasis_is_uptodate(M,T) \
  ((module_gbasis(M) != vlist_NULL) && \
   (module_DegTrunc(M) >= T))

#define module_not_compatible(M,N) \
  ((module_rank(M) != module_rank(N)) || \
   ! shifts_eq(module_shifts(M),module_shifts(N)))
/* false iff M,N are submodules of the same free module */
/* TODO: treat module_shifts */

#define module_is_zero(M) ((M==module_NULL) || (vlist_len(module_gens(M))==0))

module ideal_pow( module J, int theExp, ring R);

object module_link_kf(module M, olist ol, ring R);
module module_Clone(module M);

void module_compute_shifts_of_syz(module M,ring R);

module module_init(int r, ring R);
void module_free( module M, ring R);

module module_dup(module M, ring R);

module module_generated_by_this_pv(pvector P,ring R);
module module_generated_by_pv(pvector P,ring R);

module this_vlist2module( vlist vl, int r, ring R);
module vlist2module( vlist vl, int r, ring R);

module module_sum(module M1, module M2, ring R);

void module_mult_this_by_pvcomp(module * M, pvcomp P, ring R);
module module_mult_by_arpoly(module M, arpoly P, ring R);
module module_mult_by_pvcomp(module M, pvcomp P, ring R);
module module_mult_by_ideal(module M, module J, ring R);

module module_zero(int r, ring R);
module module_freemod(int r, ring R);
coc_bool module_is_freemod(module M);

cterm ideal2cterm(module M, ring R);
cterm module2cterm(module M, ring R);
void printf_module(module M, ring R);

ctbuf module_description(module M, ring R);
ctbuf ideal_description(module M, ring R);

#endif
