/* $Id: monomial.h,v 4.4.1.1 2004/06/18 14:24:25 cocoa Exp $ */

#ifndef MONOMIAL_H
#define MONOMIAL_H

#ifndef AUXTYPES_H
# include "auxtypes.h"
#endif

#ifndef COCTYPES_H
# include "coctypes.h"
#endif

extern monomial monomial_dummy;

#define malloc_monomial() (monomial)mymalloc(sizeof(monomial_info),"monomial")
#define free_monomial(p) myfree(sizeof(monomial_info),p,"monomial")

#define monomial_coeff(m) ((m)->c)
#define monomial_term(m) ((m)->t)
#define monomial_next(m) ((m)->next)
#define monomial_set_coeff(m,C) (m)->c=C
#define monomial_set_term(m,T) (m)->t=T
#define monomial_set_next(m,M) (m)->next=M

/* ENTRY CALLS */

#define monomial_list monomial

#define monomial_size(m,R) \
  ((ring_indets_num(R)+4)*sizeof(expType)+coeff_size(monomial_coeff(m),R))

#define monomial_deg(m) term_degree(monomial_term(m))
#define monomial_mdeg(m,R) term_mdegree(monomial_term(m), R)

#define monomial_this_x_unknown_pow(m,x,n) \
  term_this_x_unknown_pow(monomial_term(m),x,n)

monomial monomial_der(monomial p, unknown x, ring R);

monomial monomial_square(monomial m, ring R);

#define monomial_eq(m1,m2,R) \
  (term_eq(monomial_term(m1),monomial_term(m2)) &&\
  R->AreEqualsCoeff(monomial_coeff(m1),monomial_coeff(m2)))

#define monomial_is_zero(m,R) coeff_is_zero(monomial_coeff(m),R)
#define monomial_divide_this(m,m1,R) \
  do { \
    term_take_div(monomial_term(m), monomial_term(m), monomial_term(m1));\
    R->DivCoeff(& monomial_coeff(m),monomial_coeff(m),monomial_coeff(m1),R);}\
  while(FALSE)

#define monomial_change_sign(m,R) R->ChangeSignToCoeff(& monomial_coeff(m),R)
#define monomial_dup(m,R) (m == NULL ? NULL : \
  monomial_mk(coeff_dup(monomial_coeff(m),R),term_dup(monomial_term(m))))

#define monomial_true_exp(m,x,R) \
  (term_get_nth(monomial_term(m),x+1)/weight_nth(ring_weights(R),x+1))

monomial monomial_opposite(monomial M, ring R);
monomial monomial_map(monomial M, ring R1, ring R2, ivector m);

void monomial_mult_and_assign(monomial res_m, monomial m, ring R);

monomial monomial_list_dup(monomial p,ring R);

void monomial_adt_init(void);

void monomial_free(monomial m,ring R);
cterm monomial2cterm(monomial m,ring R);
monomial cterm2monomial(cterm t, ring R);
monomial monomial_mk(coeff c, term t);
void printf_monomial(monomial m, ring R);

monomial_list monomial_list_x_monomial(monomial_list p, monomial m, ring R);

#define monomial_set_mk(res_m,c,t) do {\
  res_m=malloc_monomial();\
  monomial_set_coeff(res_m,c);\
  monomial_set_term(res_m,t);\
  monomial_set_next(res_m,NULL); } while (FALSE)

#define monomial_which_gt(m1,m2,R) \
  ((R)->term_which_gt(monomial_term(m1),monomial_term(m2),(R)->to,R))

#define monomial_zero(R) monomial_mk(coeff_zero(R),term_one(R))

#define this_term2monomial(t,R) monomial_mk(coeff_one(R),t)
#define term2monomial(t,R) monomial_mk(coeff_one(R),term_dup(t))
#define opp_this_term2monomial(t,R) monomial_mk(coeff_minus_one(R),t)
#define this_coeff2monomial(c,R) monomial_mk(c,term_one(R))

monomial monomial_revert_this(monomial m);

#endif /* MONOMIAL_H */
