/* $Id: monopoli.h,v 4.4.1.1 2004/06/18 14:24:25 cocoa Exp $ */

#ifndef MONOPOLI_H
#define MONOPOLI_H

#ifndef AUXTYPES_H
# include "auxtypes.h"
#endif

#ifndef COCTYPES_H
# include "coctypes.h"
#endif

#ifdef MONOPOLI

/* -----[ MACRO ]---------------------------- */

#define monopoli_deg(p) 	monopoli_max_deg(p)
#define monopoli_mdeg(p,R) 	monopoli_max_mdeg(p,R)
#define monopoli_this_leading_term(p,R) 	monomial_term(p)
#define monopoli_leading_term(p) 		term_dup(monomial_term(p))
#define monopoli_this_term2monopoli(t,R) 	monomial_mk(coeff_one(R),t)
#define this_monomial2monopoli(m,R) 	(monomial_set_next(m,NULL),m)

#define monopoli_sum_this_monomial_list(m,R)	monopoli_sum_this_monomial_list_to_this_monopoli(m,NULL,R)

#define monopoli_is_nonzero_const(p,R) \
  ((p != NULL) && term_degree(monomial_term(p))==0)

#define monopoli_leading_coeff(p,R) \
  (((p) == NULL) ? coeff_zero(R) : coeff_dup(monomial_coeff(p),R))

#define monopoli_leading_monomial(p,R) \
  (((p) == NULL) ? NULL : monomial_dup(p,R))

#define monopoli_only_leading_term(p,R) \
  (((p) == NULL) ? monomial_mk(coeff_one(R),term_init(R->indetsNo)) \
                 : monomial_mk(coeff_one(R),term_dup(monomial_term(p))))

#define monopoli_is_homog(p,R) (monopoli_is_homog_return_deg(p,R) != -2)

#define monopoli_dup(p,R) monomial_list_dup(p,R)

#define monopoli_x_monomial(p,m,R) monomial_list_x_monomial(p,m,R)

/* -----[ HEADERS ]-------------------------- */
coc_bool monopoli_ispurelt(monopoli m);

monopoli monopoli_remove_lm	(monopoli p, ring R);
monopoli monopoli_map	(monopoli p, ring R1, ring R2, ivector m);
monopoli monopoli_mult 	(monopoli p1, monopoli p2, ring R );
monopoli monopoli_der	(monopoli p, unknown x, ring R);
monopoli unknown_pow2monopoli	(unknown u,expType exponent,ring R);
monopoli monopoli_randomize	(monopoli p, ring R);
monopoli monopoli_this_x_term	(monopoli p, term t, ring R);
monopoli monopoli_this_x_coeff	(monopoli p, coeff c, ring R);
monopoli monopoli_sum_these	(monopoli p1, monopoli p2, ring R);
monopoli monopoli_sum		(monopoli p1, monopoli p2, ring R);
monopoli monopoli_square	(monopoli p, ring R);
monopoli monopoli_this_x_term	(monopoli p, term t, ring R);
monopoli monopoli_this_x_monomial	(monopoli p, monomial m, ring R);
monopoli monopoli_this_coeff2poly	(coeff c, ring R);
monopoli this_coeff2monopoli	(coeff c, ring R);
monopoli monopoli_sum_this_monomial_list_to_this_monopoli	(monomial m, monopoli p, ring R);
monopoli monopoli_add_this_monomial	(monopoli p, monomial m, ring R);

int 	monopoli_is_homog_return_deg	(monomial m, ring R);
ivector monopoli_max_mdeg	(monomial m, ring R);
void	monopoli_change_order	(monopoli * p, ring R1, ring R2);
int 	monopoli_max_deg	(monopoli m);
void	monopoli_change_sign	(monomial m, ring R);
coc_bool 	monopoli_eq	(monopoli p1, monopoli p2, ring R);
void 	monopoli_free	(monomial m, ring R);
int 	monopoli_size	(monomial m, ring R);
int 	monopoli_len	(monomial m);
cterm 	monopoli2cterm	(monomial m, ring R);
olist 	monopoli2sppnum	(monopoli p, ring R);
monomial monopoli_last	(monomial m);
ctbuf 	monopoli2ctbuf(monomial m, ring R);

monopoli monopoli_this_minus_term_x_monopoli_truncated 	(monopoli p1, term ME, monopoli p2, iv_elem Trunc, ring R);
monopoli monopoli_this_plus_term_x_monopoli_truncated 	(monopoli p1, term ME, monopoli p2, iv_elem Trunc, ring R);
monopoli monopoli_this_plus_term_x_monopoli 	(monopoli p1, term ME, monopoli p2, ring R);
monopoli monopoli_this_minus_term_x_monopoli 	(monopoli p1, term ME,monopoli p2, ring R);

/* -----[ TODO_PUBLIC ]---------------------- */

#if 0 /* TODO_PUBLIC */

#define polynomials_init() monopoli_init()
/* #define polynomials_init(R) monopoli_init(R) */


#define poly2monopoli(p,R) poly_dup(p,R)
#define poly_free(p,R) monopoli_free(p,R)
#define poly_is_homog(p,R) (monopoli_is_homog(p,R) != -2)
#define poly_is_homog_deg(p,d,R) monopoli_is_homog_deg(p,d,R)
#define poly_is_homog_return_deg(p,R) monopoli_is_homog(p,R)
#define poly_deg(p,R) monopoli_max_deg(p)
#define poly_mdeg(p,R) monopoli_max_mdeg(p,R)
#define poly_change_sign(p,R) monopoli_change_sign(p,R)
#define poly_len(p,R) monopoli_len(p)
#define poly_size(p,R) monopoli_size(p,R)
#define poly2cterm(p,R) ctbuf_mk_cterm(monopoli2ctbuf(p,R),op_POLYNOMIAL)


/* ENTRY FUNCTIONS */

#define poly_coeff2poly(c,R) monomial_mk(coeff_dup(c,R),term_init(R->indetsNo))

#define poly_leading_term(p,R) term_dup(monomial_term(p))
/* NOTE: p MUST be non-zero */

#define poly_leading_coeff(p,R) \
  (((p) == NULL) ? coeff_zero(R) : coeff_dup(monomial_coeff(p),R))
#define poly_this_monomial2poly(m,R) (monomial_set_next(m,NULL),m)

#define poly_this_leading_monomial(p,R) (p)
/* NOTE: p MUST be non-zero */

/* void monopoli_init(ring R); */
void monopoli_init(void);

polynomial poly_map(polynomial p, ring R1, ring R2, ivector m);
polynomial poly_dup(polynomial p, ring R);
polynomial poly_mult(polynomial p1, polynomial p2, ring R);
polynomial poly_sum(polynomial p1,polynomial p2,ring R);
polynomial poly_sum_these(polynomial p1,polynomial p2,ring R);
polynomial poly_unknown_pow2poly(unknown u,expType exponent,ring R);
coc_bool poly_eq(polynomial p1, polynomial p2, ring R);
polynomial poly_x_monomial(polynomial p, monomial m, ring R);
polynomial poly_this_x_coeff(polynomial p, coeff c, ring R);
/* NOTE: c must be non zero */
/* furthermore we assume R integral domain */
void poly_change_sign(polynomial p, ring R);
polynomial poly_x_opp_term(polynomial p, term t, ring R);
polynomial poly_this_x_opp_term(polynomial p, term t, ring R);
polynomial poly_this_x_term(polynomial p, term t, ring R);

#endif /* TODO_PUBLIC */

#endif /* MONOPOLI */

#endif
