/* $Id: olist.h,v 4.4.1.1 2004/06/18 14:24:25 cocoa Exp $ */

#ifndef OLIST_H
#define OLIST_H

#ifndef AUXTYPES_H
# include "auxtypes.h"
#endif

#ifndef COCTYPES_H
# include "coctypes.h"
#endif

/* The first element of the list is the length of the list */
/* The second element of the list is the size of the list (efficiency) */

#define olist_len(ol) ((int)(ol[0]))
#define olist_size(ol) ((int)(ol[1]))
#define olist_set_len(ol,l) (ol)[0]=(void *)(l)
#define olist_set_size(ol,s) (ol)[1]=(void *)(s)
#define olist_set_nth(ol,n,o) (ol)[(n)+1]=o
#define olist_nth(ol,n) (ol[(n)+1])
#define olist_head(ol) (ol[2])


#define malloc_olist(size) \
  (olist)mymalloc(sizeof(object)*(size+2),"olist")
#define realloc_olist(l,n) \
  (olist)myrealloc(l,(olist_size(l)+2)*sizeof(object),\
  (olist_size(l)+2+n)*sizeof(object),"olist")

#define free_olist(size,p) myfree((size+2)*sizeof(object),p,"olist")


/* TODO (implement the following) */
#define olist_is_mat(l) TRUE


olist olist_init(int n);
/* return a list of n null objects */

void olist_remove(olist ol, int j);
/* remove the element i from the list ol */

olist olist_new(int n, object o);
/* return a list of n objects o */

olist olist_expand(olist l, int n);
/* makes the list bigger (n more elements) */

void olist_free(olist ol);
olist olist_dup(olist ol);
olist olist2olist_of_olists(olist ol);
coc_bool olist_is_omat(olist ol);
coc_bool olist_extract_ring_ck(olist ol, ring * res_R);
ring olist_extract_ring(olist ol);
olist olist_change_sign(olist ol);
olist olist_extprod(olist ol,object o);
cterm this_olist2cterm(olist ol);
cterm olist2cterm(olist ol);
int olist_do_size(olist ol);
olist olist_concat_these(olist ol1, olist ol2);
olist olist_append_this(olist ol, object o);
coc_bool olist_isin(olist ol, object o);
olist olist_tail(olist ol);
olist olist_cartesian(olist ol);
olist olist_sum(olist ol1, olist ol2);
olist olist_sub(olist ol1, olist ol2);
coc_bool olist_eq(olist ol1,olist ol2);

/* CONVERSIONS FUNCTIONS */

pvector this_olist2pv(olist ol, ring R);
module this_olist2module(olist ol, ring R);
module this_olist2ideal(olist ol, ring R);
vlist this_olist2vlist(olist ol,ring R);
vlist this_olist2vlist_bis(olist ol,ring R);

shifts this_olist2shifts(olist ol, ring R);

weilist olist2weilist(olist ol, ring R);
weight olist2weight(olist ol, ring R);

olist this_vlist2olist(vlist vl,ring R);
olist vlist2olist(vlist vl,ring R);
olist this_vlist2olist_bis(vlist vl,ring R);
olist this_vlist2olist_ter(vlist vl,ring R);
olist this_pv2olist(pvector v, ring R);
olist shifts2olist(shifts ss, ring R);
olist this_ev2olist(evector ev, ring R);
olist ev2olist(evector ev, ring R);
olist this_iv2olist(ivector v);

olist this_ctbuf2olist(ctbuf b);
olist indet_ident2olist(char * ident,ring R);

#endif
