/* $Id: omat.h,v 4.4.1.1 2004/06/18 14:24:25 cocoa Exp $ */

#ifndef OMAT_H
#define OMAT_H

#ifndef AUXTYPES_H
# include "auxtypes.h"
#endif

#ifndef COCTYPES_H
# include "coctypes.h"
#endif

#define omat_extprod(om,o) olist_extprod(om,o)

#define omat_row(om,n) (olist_nth(om,n))->v.olist_value
#define omat_nrow(om) olist_len(om)
#define omat_ncol(om) olist_len(omat_row(om,1))
#define omat_ij(om,i,j) olist_nth(omat_row(om,i),j)
#define omat_set_ij(om,i,j,o) olist_set_nth(omat_row(om,i),j,o)

#define omat_dup(m) olist_dup(m)
#define omat_sum(m,n) olist_sum(m,n)
#define omat_sub(m,n) olist_sub(m,n)
#define omat_free(m) olist_free(m)
#define this_omat2olist(m) (olist)(m)
#define this_omat2module(m,R) this_olist2module(m,R)
#define omat_is_square(m) (omat_nrow(m)==omat_ncol(m))
#define omat_extract_ring(m) olist_extract_ring(m)
#define omat_extract_ring_ck(m,R) olist_extract_ring_ck(m,R)

#define omat_eq(m,n) olist_eq(m,n)

#define omat_change_sign(m) olist_change_sign(m)

omat omat_init(int m, int n);
omat omat_new(int m, int n, object o);
coc_bool omat_is_rational(omat M);
coc_bool omat_is_zero(omat M);
omat ord2omat(ordering ord, ring R);
void omat2ord(ordering * to, omat M);
omat omat_sum(omat m1,omat m2);
omat omat_subtract(omat m1,omat m2);
omat omat_mult(omat o1, omat o2);
omat omat_id(int n);
omat omat_pow(omat M, int n);
cterm omat2cterm(omat m);
omat omat_inv(omat M);
object omat_det(omat M);
omat omat_adjoint(omat M);
void printf_omat(omat M,ring R);
olist omat_minors(omat M, int p /* order */ );
omat this_olist2omat(olist ol);
#define this_vlist2omat(VL,R) this_olist2omat(this_vlist2olist(VL,R))
#define vlist2omat(VL,R) this_olist2omat(vlist2olist(VL,R))

omat this_olist_of_olists2omat(olist ol);

#endif
