/* $Id: operator.h,v 4.5 2004/07/27 10:57:58 cocoa Exp $ */

#ifndef OPERATOR_H
#define OPERATOR_H

# include "auxtypes.h"
# include "coctypes.h"

#define malloc_op_info() (op_info)mymalloc(sizeof(op_info_aux),"op_info")
#define free_op_info(p) myfree(sizeof(op_info_aux),p,"op_info")
#define malloc_pkg() (package)mymalloc(sizeof(pkg_info),"pkg")

#define is_user_defined_coop(op) (op_package(op)>2)

extern package packages[MAX_NUM_PACKAGES];

extern op_info op_infos[MAX_NUM_OPERATORS];

#define NO_ARITY -1

extern coop op_NULL;

extern map pkg_map;
extern int pkg_std_n, pkg_builtin_n, pkg_user_n;

/* PACKAGES */

int pkg_init(pkg_id id);
int pkg_index(pkg_id id);
void pkg_clear(int pkg_n);

/* OPERATIONS on coops' map */

int coop_pkg_std_op(char * op_id, int * pkg_n, coop * op);

void op_map_init(void);
/* initialize the coops map */

coop op_map_add_if_not_exists(int pkg_n, nome n);
cocfun op_map_cocfun(char * p_id, char * fun_id);

coop op_map_add(int pkg_n, nome n,int arity);
/* adds to op_map the coop with the name n and arity arity 
  and returns its id */

coop op_map_add_handler(int pkg_n, nome n,int arity,cterm handler);

#if 0

#define op_map_add_handler2(pkg_n,n,arity,handler) \
  op_map_add_handler(pkg_n,n,arity,(cterm)handler)

#else

#define op_map_add_handler2(pkg_n,n,arity,handler) \
  op_map_add(pkg_n,n,arity)

#endif

coop op_map_add_user_function(int pkg_n, nome n,int arity,cterm handler,
  char * help);
/* adds to op_map the (user defined) coop with the name n and arity arity 
  and handler handler returns its id */

coop op_map_mod_user_function(int pkg_n, coop op,int arity,
  cterm handler, char * help);
/* modify an already existent (user defined) coop */

coop op_map_coop(int pkg_n, nome n);
/* returns the coop whose name is n */
/* returns op_NULL if not exists */

/* nome op_map_op_name(coop op); */
/* returns the name of the coop op */

/* int op_map_op_arity(coop op); */
/* returns the arity of the coop op */

/* cterm op_map_op_handler(coop op); */
/* returns the handler for the (user defined) function named op */

#define DOLLAR_BUILTIN "$builtin"

#define op_package(op) ((op)>>10)
#define op_index(op) ((op)&1023)
#define op_mk(pkg_n,op) ((pkg_n << 10)|(op))

#define op_map_num_starting(p,n) map_num_starting(pkg_op_map(p),n)
#define op_map_next_starting(p,n,op) map_next_starting(pkg_op_map(p),n,op)
#define op_map_op_name(p,op) map_get_name(pkg_op_map(p),op)

#define op_info_set_handler(o,h) o->handler=h
#define op_info_set_arity(o,n) o->arity=n
#define op_info_set_help(o,h) o->help=h

#define op_info_handler(o) (o->handler)
#define op_info_arity(o) (o->arity)
#define op_info_help(o) (o->help)

#define op_map_op_handler(p,op) (op_info_handler(pkg_op_infos(p)[op]))
#define op_map_op_arity(p,op) (op_info_arity(pkg_op_infos(p)[op]))
#define op_map_op_help(p,op) (op_info_help(pkg_op_infos(p)[op]))

#define op_map_set_op_handler(p,op,h) op_info_set_handler(pkg_op_infos(p)[op],h)
#define op_map_set_op_arity(p,op,n) op_info_set_arity(pkg_op_infos(p)[op],n)
#define op_map_set_op_help(p,op,h) op_info_set_help(pkg_op_infos(p)[op],h)

#define pkg_op_map(p) ((pkg_nth(p))->op_map)
#define pkg_op_infos(p) ((pkg_nth(p))->op_infos)

#define pkg_set_op_map(p,m) (p)->op_map=m
#define pkg_set_op_info(p,op,i) ((p)->op_infos)[op]=i

#define pkg_is_def(id) (pkg_index(id)!=name_id_NULL)
#define pkg_nth(n) (packages[n])
#define pkg_set_nth(n,p) packages[n]=p
#define pkg_num_ops(p) map_last_id(pkg_op_map(p))
#define pkg_name(id) (id == 0 ? DOLLAR_BUILTIN : map_get_name(pkg_map,id))

#endif
