/* options.h : 0.1 : 15 May 93 : adt flags */

/*------------------------------------------------------------------------------

	revision history
		
------------------------------------------------------------------------------*/

#ifndef OPTIONS_H
#define OPTIONS_H

#ifndef AUXTYPES_H
# include "auxtypes.h"
#endif

/* ---[ options OPERATORS ]----------------------------------------------- */

extern coop op_OPTION, op_NUM, op_ENUM, op_FLAG, op_PANEL;

#define opt_MAX_NUM 20
#define opt_MAX_NUM_VALUES 10
#define optv_NULL ZERO

#define malloc_panel() \
  (opt_panel)mymalloc(sizeof(opt_entry)*opt_MAX_NUM,"panel")
#define free_panel(p) myfree(sizeof(opt_entry)*opt_MAX_NUM,p,"panel")

#define malloc_optv_descr() \
  (charstars)mymalloc(sizeof(charstars)*opt_MAX_NUM_VALUES,"optv_descr")
#define free_optv_descr(p) \
  myfree(sizeof(charstars)*opt_MAX_NUM_VALUES,p,"optv_descr")

#define opt_new_flag(P,D) opt_new(opt_type_FLAG, P, D)
#define opt_new_num(P,D) opt_new(opt_type_NUM, P, D)
#define opt_new_enum(P,D) opt_new(opt_type_ENUM, P, D)

#define opt_panel_set_descr(p,d) opt_set_descr(p,0,d)
#define opt_panel_set_dim(p,n) opt_set_value(p,0,n)
#define opt_panel_descr(p) opt_descr(p,0)
#define opt_panel_dim(p) opt_get_value(p,0)

#define opt_set_descr(p,o,D) p[o].d=my_strdup(D)
#define opt_set_value(p,o,V) p[o].v=V
#define opt_set_type(p,o,T) p[o].t=T
#define opt_get_value(p,o) (p[o].v)
#define opt_get_type(p,o) (p[o].t)
#define opt_descr(p,o) (p[o].d)

#define flag_set(p,o) (p)[o].v=flag_ON
#define flag_unset(p,o) (p)[o].v=flag_OFF

#define optv_set_descrs(p,o,ds) p[o].vd=ds;
#define optv_set_descr(p,o,v,d) p[o].vd[v]=my_strdup(d);
#define optv_get_descr(p,o,v) (p[o].vd[v])

#define flag_is_on(p,o) (p[o].v==flag_ON)

opt_panel opt_panel_new(char * descr);

opt_id panels_env_get_oid(opt_panel pan, char * descr);

opt_id opt_new(opt_type t, opt_panel p, char * descr);
/* add an option to the panel id */

optv_id optv_new(opt_panel p, opt_id o, char * descr);
/* only for enumerative types */

void opt_set_value_check(opt_panel p, opt_id o, opt_value v);

void printf_opt_panel(opt_panel p);

cterm opt_panel2cterm(opt_panel p);
cterm opt2cterm(opt_panel p, opt_id o);
cterm opt_type2cterm(opt_type t);
cterm optv_descr2cterm(opt_panel p, opt_id o);

void options_init(void);

#endif
