/* $Id: ordering.h,v 4.4.1.1 2004/06/18 14:24:25 cocoa Exp $ */

#ifndef ORDERING_H
#define ORDERING_H

#ifndef AUXTYPES_H
# include "auxtypes.h"
#endif

#ifndef COCTYPES_H
# include "coctypes.h"
#endif

/* -----------[ cord ]-------------- */

#define malloc_cord() (cord)mymalloc(sizeof(cord_info),"cord")
#define free_cord(D) myfree(sizeof(cord_info),D,"cord")

#define cord_type(c) ((c)->t)
#define cord_x(c) ((c)->x)
#define cord_y(c) ((c)->y)
#define cord_ordering(c) ((c)->o)

#define cord_set_type(c,T) (c)->t=T
#define cord_set_ordering(c,O) (c)->o=O
#define cord_set_x(c,X) (c)->x=X
#define cord_set_y(c,Y) (c)->y=Y

cord cord_init(int t, ordering o, unknown x, unknown y);

/* -----------[ ordering ]-------------- */

#define malloc_ordering(n) (ordering)mymalloc((n)*sizeof(ord_row),"ordering")
#define free_ordering(n,p) myfree((n)*sizeof(ord_row),p,"ordering")

#define malloc_ord_row(n) (ord_row)mymalloc((n+1)*sizeof(toElem),"ord_row")
#define free_ord_row(n,p) myfree((n+1)*sizeof(toElem),p,"ord_row")

#define ordering_elem(o,i,j) o[(i)-1][(j)-1]

ordering ord_dup(ordering ord,ring R);

void InitZeroOrder ( ordering * myOrd, ring R);
void ClearOrder ( ordering * myOrd, ring R);

void SetZeroOrder ( ordering myOrd, ring R);
void SetLexOrder ( ordering myOrd, ring R);
void SetXelOrder ( ordering myOrd, ring R);
void SetDegLexOrder ( ordering myOrd, weight weights, ring R);
void SetDegRevLexOrder ( ordering myOrd, weight weights, ring R);
void SetElimOrder ( unknown firstVar, unknown lastVar, 
  ordering myOrd, weight weis, ring R);

void SetAntiDegLexOrder ( ordering myOrd, weight weights, ring R);
void SetAntiDegRevLexOrder ( ordering myOrd, weight weights, ring R);

void PrintOrder( ordering myOrd, ring R);

int iv_which_gt_other(ivector v1, ivector v2, ordering ord);

ordering ord_adjoint(ordering ord,ring R);
int ord_det(ordering ord,ring R);

/* AUXILIARY FUNCTIONS */
matrix ord2matrix(ordering ord,ring R);
ordering matrix2ord(matrix M,ring R);

ordering weights2ord(weilist w,ring R);
/* build a term (total) ordering compatible with the system of weights w */

coc_bool ord_is_deg_compatible(ordering ord, ring R);

coc_bool is_term_ordering(ordering to, int n);

#endif
