/* $Id: pair.h,v 4.4.1.1 2004/06/18 14:24:25 cocoa Exp $ */

#ifndef PAIR_H
#define PAIR_H

#ifndef AUXTYPES_H
# include "auxtypes.h"
#endif

#ifndef COCTYPES_H
# include "coctypes.h"
#endif

/* labels: VPAIR */

#if 0 /* BOSSI */

extern weilist mdeg_pair_weights;
extern ordering mdeg_pair_ord;

#define malloc_pair() (pair)mymalloc(sizeof(pairEl),"pair")
#define free_pair(p) myfree(sizeof(pairEl),p,"pair")

#define pair_first(PAIR) ((PAIR)->PL1)
#define pair_second(PAIR) ((PAIR)->PL2)
#define pair_set_first(PAIR,E) (PAIR)->PL1=E
#define pair_set_second(PAIR,E) (PAIR)->PL2=E
#define pair_set_lcm(PAIR,T) (PAIR)->lcm=T
#define pair_set_td(PAIR,D) (PAIR)->tD=D
#define pair_set_wd(PAIR,D) (PAIR)->wD=D

#define pair_first_lm(PAIR) plist_elem_lm((PAIR)->PL1)
#define pair_second_lm(PAIR) plist_elem_lm((PAIR)->PL2)
#define pair_first_lt(PAIR) monomial_term(plist_elem_lm((PAIR)->PL1))
#define pair_second_lt(PAIR) monomial_term(plist_elem_lm((PAIR)->PL2))
#define pair_first_lc(PAIR) monomial_coeff(plist_elem_lm((PAIR)->PL1))
#define pair_second_lc(PAIR) monomial_coeff(plist_elem_lm((PAIR)->PL2))

#define pair_set_coprimes(PAIR,C) (PAIR)->coprimes=C

#define pair_wd(PAIR) ((PAIR)->wD)
#define pair_td(PAIR) ((PAIR)->tD)
#define pair_are_coprimes(PAIR) ((PAIR)->coprimes)
#define pair_lcm(PAIR) ((PAIR)->lcm)

#define pair_next(PAIR) ((PAIR)->next)
#define pair_set_next(PAIR,P) ((PAIR)->next=(P))

#define pair_is_not_empty(P) ((P)!=pair_NULL)

pair NewPair( ring R );
void FreePair( pair * myPair, ring R );

pair pair_mk( plist_elem E1, plist_elem E2, opt_panel opts, ring R);

void printf_pairs(pair pr,ring R);
cterm pair2cterm(pair p, ring R);
cterm pairs2cterm(pair pr, ring R);

int BCriterion( pair * D, term LF, ring R );

int (* ComparePairs)(  pair P1, pair P2, opt_panel options, ring R );
int ComparePairsNormal(  pair P1, pair P2, opt_panel options, ring R );
int ComparePairsMulti(  pair P1, pair P2, opt_panel options, ring R );

void AddFirstPairFrom( pair * source,  pair * dest, pair * last, 
  opt_panel opts, ring R );
void AddFirstPair( pair * source,  pair * dest, opt_panel opts, ring R );
void MergePairLists (pair * source,  pair * dest, int * pairsNo, 
  opt_panel opts, ring R );
int BuildNewPairs( pair *newPairs, plist theBasis,  plist_elem newEl, 
  opt_panel opts, ring R );
/* return the number of new pairs */

#endif /* BOSSI */

/* ---------------[ VPAIR ]---------------- */

#define malloc_vpair() (vpair)mymalloc(sizeof(vpairEl),"vpair")
#define free_vpair(p) myfree(sizeof(vpairEl),p,"vpair")

#define vpairs_is_empty(PAIRS) (PAIRS == vpairs_NULL)
#define vpairs_first(PAIRS) (PAIRS)

#define vpair_next(PAIR) ((PAIR)->next)

#define vpair_first(PAIR) ((PAIR)->VL1)
#define vpair_second(PAIR) ((PAIR)->VL2)

#define vpair_whole_first_vector(PAIR,R) ev_whole_vector((PAIR)->VL1,R)
#define vpair_whole_second_vector(PAIR,R) ev_whole_vector((PAIR)->VL2,R)
#define vpair_first_lm(PAIR) ev_lm((PAIR)->VL1)
#define vpair_second_lm(PAIR) ev_lm((PAIR)->VL2)
#define vpair_lmpos(PAIR) ev_lmpos((PAIR)->VL1)
#define vpair_first_lt(PAIR) monomial_term(ev_lm((PAIR)->VL1))
#define vpair_second_lt(PAIR) monomial_term(ev_lm((PAIR)->VL2))
#define vpair_first_lc(PAIR) monomial_coeff(ev_lm((PAIR)->VL1))
#define vpair_second_lc(PAIR) monomial_coeff(ev_lm((PAIR)->VL2))
#define vpair_first_rel(PAIR) ev_rel((PAIR)->VL1)
#define vpair_second_rel(PAIR) ev_rel((PAIR)->VL2)

#define vpair_set_next(PAIR,N) (PAIR)->next=N

#define vpair_set_first(PAIR,E) (PAIR)->VL1=E
#define vpair_set_second(PAIR,E) (PAIR)->VL2=E
/*
#define vpair_set_first_index(PAIR,I) (PAIR)->idx1=I
#define vpair_set_second_index(PAIR,I) (PAIR)->idx2=I
*/
#define vpair_set_lcm(PAIR,T) (PAIR)->lcm=T
#define vpair_set_A(PAIR,T) (PAIR)->A=T
#define vpair_set_B(PAIR,T) (PAIR)->B=T
#define vpair_set_td(PAIR,D) (PAIR)->tD=D
#define vpair_set_wd(PAIR,D) (PAIR)->wD=D

#define vpair_set_coprimes(PAIR,C) (PAIR)->coprimes=C

#define vpair_wd(PAIR) ((PAIR)->wD)
#define vpair_td(PAIR) ((PAIR)->tD)
#define vpair_are_coprimes(PAIR) ((PAIR)->coprimes)
#define vpair_lcm(PAIR) ((PAIR)->lcm)
#define vpair_A(PAIR) ((PAIR)->A)
#define vpair_B(PAIR) ((PAIR)->B)
#define vpair_deg(PAIR) (term_degree(vpair_lcm(PAIR)))

cterm vpair2cterm(vpair ps, ring R);
cterm vpairs2cterm(vpair ps, ring R);
vpair vpairs_get_first( vpair * ps );

vpair NewVPair( ring R );
void FreeVPair( vpair * myPair, ring R );
void FreeVPairs( vpair * myPair, ring R );

vpair vpair_mk( evector E1, evector E2, opt_panel opts, ring R);

vpair vpair_dup(vpair P, ring R);
vpair vpairs_dup(vpair Ps, ring R);
int vpairs_len(vpair ps);

#endif
