/* $Id: pipe.h,v 4.4.1.1 2004/06/18 14:24:25 cocoa Exp $ */

#ifndef PIPE_H
#define PIPE_H

#include <stdio.h>

#ifndef UTILS_H
# include "utils.h"
#endif


#define malloc_pipe() (coc_pipe)mymalloc(sizeof(pipe_info),"pipe")
#define free_pipe(p) myfree(sizeof(pipe_info),p,"pipe")

#define malloc_pipe_atom() (pipe_atom)mymalloc(sizeof(pipe_atom_info),\
  "pipe_atom")
#define free_pipe_atom(p) myfree(sizeof(pipe_atom_info),p,"pipe_atom")

#define pipe_len(p) ((p)->len)
#define pipe_first(p) ((p)->lm)
#define pipe_next(a) ((a)->r)
#define pipe_ltop(p) (((p)->len)?p->lm->e:pipe_elem_NULL)
#define pipe_rtop(p) (((p)->len)?p->rm->e:pipe_elem_NULL)



/* PRIMITIVES OF ADT coc_pipe */

coc_pipe pipe_new(void);
/* creates a new coc_pipe and returns its id (identifier) */

coc_pipe pipe_free(coc_pipe p);
/* clear coc_pipe p and free its memory (return NULL) */

coc_pipe pipe_lpush(coc_pipe p,pipe_elem e);
/* push the pipe_element e to the left side of the coc_pipe and return the new coc_pipe */

coc_pipe pipe_rpush(coc_pipe p,pipe_elem e);
/* push the pipe_element e to the right side of the coc_pipe and return the new coc_pipe */

pipe_elem pipe_lpop(coc_pipe p);
/* pop an pipe_element e from the left side of the coc_pipe and return e */

pipe_elem pipe_rpop(coc_pipe p);
/* pop an pipe_element e from the right side of the coc_pipe and return e */

coc_pipe pipe_concat_these(coc_pipe p1, coc_pipe p2);


/* PREDICATES */

/* I/O FUNCTIONS */

#if 0

void pipe_fprintf(FILE * f,coc_pipe p);
/* print the coc_pipe p */

#endif

#endif
