/* $Id: polys.h,v 4.4.1.1 2004/06/18 14:24:25 cocoa Exp $ */

#ifndef POLYS_H
#define POLYS_H

#ifndef AUXTYPES_H
# include "auxtypes.h"
#endif

#ifndef COCTYPES_H
# include "coctypes.h"
#endif

#ifdef TRIPOLI
# include "tripoli.h"
#endif

#ifdef EEE
# include "eee.h"
#endif

#ifdef MONOPOLI
# include "monopoli.h"
#endif

#include "pvcomp.h"
#include "arpoly.h"

void polynomials_init();
unknown arpoly2indet(arpoly p, ring R);
arpoly cterm2arpoly(cterm t, ring R);
int this_arpoly2int(arpoly p, ring R);
arbint this_arpoly2arbint(arpoly p, ring R);
arpoly arpoly_sub_these(arpoly p1, arpoly p2, ring R);
pvcomp pvcomp_sub_these(pvcomp p1, pvcomp p2, ring R);
arpoly arpoly_full_aux(int deg, term aux_t, unknown u, ring R);
arpoly arpoly_full_support_of_degree(int deg, ring R);
arpoly arpoly_power(arpoly p, expType exp, ring R);
coc_bool arpoly_div(arpoly f, arpoly g, arpoly * q, arpoly * r, ring R);
arpoly arpoly_homog(arpoly p, unknown x, ring R);
pvcomp pvcomp_homog(pvcomp p, unknown x, ring R);
coc_bool arpoly_is_zero(arpoly p, ring R);
coc_bool arpoly_is_one(arpoly p, ring R);
arpoly arpoly_der_n(arpoly p, unknown x, int n, ring R);
arpoly arpoly_der_nn(arpoly p, int * der_list, ring R);
void printf_arpoly(arpoly p,ring R);
void printf_pvcomp(pvcomp p,ring R);

#if 0 /* TODO PUBLIC */

/* MACROS */

#define poly_sub(p1,p2,R) poly_sub_these(poly_dup(p1,R),poly_dup(p2,R),R)

#define int2poly(n,R) poly_this_coeff2poly(int2coeff(n,R),R)
#define this_arbint2poly(n,R) poly_this_coeff2poly(this_arbint2coeff(n,R),R)
#define arbint2poly(n,R) poly_this_coeff2poly(arbint2coeff(n,R),R)

#define poly_unknown2poly(u,R) poly_unknown_pow2poly(u,(expType)1,R)
#define poly_one(R) poly_this_coeff2poly(coeff_one(R),R)
#define poly_addthis2this(p,p1,R) *(p)=poly_sum_these(*(p),p1,R)
#define poly_plus_mxp(p,m,p1,R) poly_sum_these(p, poly_x_monomial(p1,m,R),R)
/* return p+m*p1 and destroy p */

#define poly_x_coeff(p,c,R) poly_this_x_coeff(poly_dup(p,R),c,R)

/* HEADERS */

polynomial DUPFF2poly(DUPFF p, ring R);

polynomial this_arbrat2poly(arbrat r, ring R);
int this_poly2int(polynomial p, ring R);
arbint this_poly2arbint(polynomial p, ring R);
coc_bool poly_is_one(polynomial p, ring R);
polynomial poly_homog(polynomial p, unknown x, ring R);

coc_bool poly_div(polynomial f, polynomial g, polynomial * q, polynomial * r, 
  ring R);
/* iff g = 0 return FALSE */

polynomial poly_der(polynomial p, unknown x, ring R);

polynomial poly_full_support_of_degree(int deg, ring R);
polynomial poly_this_x_monomial(polynomial p, monomial m, ring R);

polynomial poly_sub_these(polynomial p1, polynomial p2, ring R);

olist poly2sppnum(polynomial p, ring R);

polynomial poly_randomize(polynomial p, ring R);

/* implemented in polys.c */

polynomial cterm2poly(cterm t, ring R);
unknown poly_the_unknown(polynomial p, ring R);
polynomial poly_power(polynomial p, expType exp, ring R);
polynomial poly_square(polynomial p, ring R);
void printf_poly(polynomial p,ring R);
polynomial poly_sum_this_monopoli(monomial m, ring R);
polynomial poly_add_this_monomial(polynomial p, monomial m, ring R);

void poly_make_monic(polynomial * p, ring R);
void poly_change_order(polynomial * p, ring R1, ring R2);

/* Start CDDGM + Big (monopoli) */

/* TODO: tripoli? (occhio ai nomi diversi) */

polynomial poly_this_minus_term_x_poly (polynomial p1, term ME, polynomial p2, 
  ring R);

polynomial poly_this_plus_term_x_poly (polynomial p1, term ME, polynomial p2, 
  ring R);

polynomial poly_this_minus_term_x_poly_truncated (polynomial p1, term ME, 
  polynomial p2, iv_elem Trunc, ring R);

polynomial poly_this_plus_term_x_poly_truncated (polynomial p1, term ME,
  polynomial p2, iv_elem Trunc, ring R);

/* End CDDGM + Big */

#endif /* TODO: PUBLIC */

#endif
