/* $Id: pp.h,v 4.4.1.1 2004/06/18 14:24:25 cocoa Exp $ */

#ifndef PP_H
#define PP_H

#include <stdio.h>

#ifndef CTERM_H
# include "cterm.h"
#endif

#ifndef OPTIONS_H
# include "options.h"
#endif

typedef int pp_directive;

#define ppd_NONE 0
#define ppd_WITH_PLUS 1
#define ppd_IF_NOT_ONE 2
#define ppd_IF_NOT_ONE_AND_WITH_PLUS 3

#define ppd_is_IF_NOT_ONE(x) \
((x==ppd_IF_NOT_ONE)||(x==ppd_IF_NOT_ONE_AND_WITH_PLUS))

#define ppd_is_WITH_PLUS(x) \
((x==ppd_WITH_PLUS)||(x==ppd_IF_NOT_ONE_AND_WITH_PLUS))

#define pp_NOERR 0
#define pp_ERROR 1

int pp_nl_indent(cdev d);
int pp_cdev_fputs_spaces(cdev d, int n);

int pp_cterm_noindent(cdev d, cterm t);
int pp_cterm_main(cdev d, cterm t, int indent);
int pp_cterm(cdev d, cterm t);

/* ---[ HANDLERS ]--------------------------------------------- */

int pp_eee(cdev d, cterm t);
int pp_eee_prefix(cdev d, char * prefix, cterm t);
int pp_eee_mon_noprefix(cdev d, char * prefix, char c, cterm t);
int pp_eee_mon(cdev d, char * prefix, char c, cterm t);
int pp_eee_lbl(cdev d, cterm t);

int pp_and(cdev d, cterm t);
int pp_all(cdev d, cterm t);
int pp_at(cdev d, cterm t);
int pp_asis_param0(cdev d, cterm t);
int pp_assignment(cdev d, cterm t);
int pp_define(cdev d, cterm t);
int pp_define2(cdev d, cterm t);
int pp_bind(cdev d, cterm t);
int pp_cocolon(cdev d, cterm t);
int pp_comp(cdev d, cterm t);
int pp_cond(cdev d, cterm t);
int pp_change_sign(cdev d, cterm t);
int pp_catch(cdev d, cterm t);
int pp_commands(cdev d, cterm t);
int pp_colon(cdev d, cterm t);
int pp_coeff_ppd_NONE(cdev d, cterm t);
int pp_dashes(cdev d, cterm t);
int pp_dots(cdev d, cterm t);
int pp_define_ring(cdev d, cterm t);
int pp_define_and_use_ring(cdev d, cterm t);
int pp_error(cdev d, cterm t);
int pp_eval(cdev d, cterm t);
int pp_fun_appl(cdev d, cterm t);
int pp_for(cdev d, cterm t);
int pp_foreach(cdev d, cterm t);
int pp_frac(cdev d, cterm t);
int pp_indet(cdev d, cterm t);
int pp_ideal(cdev d, cterm t);
int pp_indet_info(cdev d, cterm t);
int pp_indet_decl(cdev d, cterm t);
int pp_if(cdev d, cterm t);
int pp_is_eq(cdev d, cterm t);
int pp_is_le(cdev d, cterm t);
int pp_is_lt(cdev d, cterm t);
int pp_is_ge(cdev d, cterm t);
int pp_is_gt(cdev d, cterm t);
int pp_list(cdev d, cterm t);
int pp_mat(cdev d, cterm t);
int pp_module(cdev d, cterm t);
int pp_mem_stat(cdev d, cterm t);
int pp_monomial_call(cdev d, cterm t);
int pp_mult(cdev d, cterm t);
int pp_NBS(cdev d, cterm t);
int pp_newline(cdev d, cterm t);
int pp_noindent(cdev d, cterm t);
int pp_or(cdev d, cterm t);
int pp_panel(cdev d, cterm t);
int pp_par(cdev d, cterm t);
int pp_pow(cdev d, cterm t);
int pp_pow1(cdev d, cterm t);
int pp_poly_ring(cdev d, cterm t);
int pp_polynomial_par(cdev d, coc_bool is_num, cterm t);
int pp_polynomial(cdev d, cterm t);
int pp_record(cdev d, cterm t);
int pp_ratfun(cdev d, cterm t);
int pp_ring_zp(cdev d, cterm t);
int pp_record_sel(cdev d, cterm t);
int pp_range(cdev d, cterm t);
int pp_repeat(cdev d, cterm t);
int pp_sum(cdev d, cterm t);
int pp_source(cdev d, cterm t);
int pp_string(cdev d, cterm t);
int pp_subtract(cdev d, cterm t);
int pp_term(cdev d, cterm t);
int pp_terror(cdev d, cterm t);
int pp_using(cdev d, cterm t);
int pp_while(cdev d, cterm t);
int pp_var(cdev d, cterm t);
int pp_zpvalue(cdev d, cterm t);

/* ---[ HANDLERS auxiliary functions ]------------------------- */

int pp_cterm_indent(cdev d, cterm t, int n);
int pp_cterms_sep(cdev d, cterm t, char * sep);
int pp_coeff(cdev d, cterm t, pp_directive ppd);
int pp_uop(cdev d, cterm t, char * sep);
int pp_bop(cdev d, cterm t, char * sep);
int pp_bop_plus(cdev d, cterm t, char * before, char * sep, char * after);
int pp_monomial(cdev d, cterm t, pp_directive ppd);
int pp_number(cdev d, char * s, pp_directive ppd);
coc_bool pp_is_positive_coeff(cterm t);
coc_bool pp_is_one_abs_coeff(cterm t);
coc_bool pp_is_one_abs_zp(char * p,char * s);
coc_bool pp_is_positive_zp(char * p, char * s);
coc_bool pp_is_positive_number(char * s);
coc_bool pp_is_one_abs_number(char * s);
int pp_option_aux(cdev d, char * descr, int idx, int value);
int pp_option(cdev d, cterm t, int o, int maxldescr);

#endif
