/* pseries.h : 0.2 : 1 Feb 94 : ADT poincare series */

/*------------------------------------------------------------------------------

	part of project cocoa

	revision history
 ------------------------------------------------------------------------------*/
 
#ifndef PSERIES_H
#define PSERIES_H

#ifndef AUXTYPES_H
# include "auxtypes.h"
#endif

#ifndef COCTYPES_H
# include "coctypes.h"
#endif

#define malloc_pseries() (PSeries)mymalloc(sizeof(PSeries_info),"pseries")
#define free_pseries(p) myfree(sizeof(PSeries_info),p,"pseries")

#define malloc_MVPSeries() \
  (MVPSeries)mymalloc(sizeof(MVPSeries_info),"MVPSeries")
#define free_MVPSeries(p) myfree(sizeof(MVPSeries_info),p,"MVPSeries")

#define pseries_num(PS) (PS)->PolyNum
#define pseries_den_factors(PS) ((PS)->denom_factors)
#define pseries_set_num(PS,PN) (PS)->PolyNum=PN
#define pseries_set_den_factors(PS,Fs) (PS)->denom_factors=Fs

#define MVPSeries_num(PS) (PS)->PolyNum
#define MVPSeries_ring(PS) (PS)->MVPRing
#define MVPSeries_den_factors(PS) (PS)->denom_factors
#define MVPSeries_set_num(PS,PN) (PS)->PolyNum=PN
#define MVPSeries_set_ring(PS,R) (PS)->MVPRing=R
#define MVPSeries_set_den_factors(PS,Fs) (PS)->denom_factors=Fs

PSeries pseries_init ();
void pseries_free (PSeries PS);
PSeries pseries_dup (PSeries PS);

MVPSeries MVPSeries_init (ring R);
void MVPSeries_free (MVPSeries PS);
MVPSeries MVPSeries_dup (MVPSeries PS);

cterm pseries2cterm (PSeries PS);
olist pseries2olist (PSeries PS);
olist MVPSeries2olist (MVPSeries PS);
PSeries olist2pseries (olist ol);

#endif
