/* $Id: pvcomp.h,v 4.4.1.1 2004/06/18 14:24:25 cocoa Exp $ */
/* [ MONOPOLI ] [ TRIPOLI ] [ EEE ] */

#ifndef PVCOMP_H

pvcomp pvcomp_homog(pvcomp p, unknown x, ring R);
pvcomp pvcomp_sub_these(pvcomp p1, pvcomp p2, ring R);

#define pvcomp_zero(R)   this_coeff2pvcomp(coeff_zero(R),R)
#define pvcomp_one(R) 	this_coeff2pvcomp(coeff_one(R),R)

#define pvcomp_sub(p1,p2,R) \
  pvcomp_sub_these(pvcomp_dup(p1,R),pvcomp_dup(p2,R),R)

#define term2pvcomp(t,R) this_term2pvcomp(term_dup(t),R)

/* -------[ MONOPOLI ]--------------------*/

#ifdef PVCOMP_MONOPOLI

#define arpoly2pvcomp(p,R) 	arpoly2monopoli(p,R)
#define this_arpoly2pvcomp(p,R) this_arpoly2monopoli(p,R)
#define pvcomp2monopoli(p,R) 	monopoli_dup(p,R)
#define this_pvcomp2monopoli(p,R) 	(p)
#define pvcomp2eee(p,R) 	monopoli2eee(p,R)
#define this_pvcomp2eee(p,R) 	this_monopoli2eee(p,R)
#define pvcomp2tripoli(p,R) 	monopoli2tripoli(p,R)
#define this_pvcomp2tripoli(p,R) 	this_monopoli2tripoli(p,R)

#define pvcomp_deg(p,R) 	monopoli_deg(p)
#define pvcomp_dup(p,R) 	monopoli_dup(p,R)
#define pvcomp_change_sign(p,R)	monopoli_change_sign(p,R)
#define pvcomp_size(p,R)	monopoli_size(p,R)
#define pvcomp_sum_these(p,q,R)	monopoli_sum_these(p,q,R)
#define pvcomp_eq(p,q,R)	monopoli_eq(p,q,R)
#define pvcomp_sum(p,q,R)	monopoli_sum(p,q,R)
#define pvcomp_mult(p,q,R)	monopoli_mult(p,q,R)
#define pvcomp_mdeg(p,R)	monopoli_mdeg(p,R)
#define pvcomp2cterm(p,R)	monopoli2cterm(p,R)
#define pvcomp_free(p,R)	monopoli_free(p,R)
#define pvcomp_leading_term(p,R) 	monopoli_leading_term(p)
#define pvcomp_is_homog_deg(p,d,R) 	monopoli_is_homog_deg(p,d,R)
#define pvcomp_is_nonzero_const(p,R) 	monopoli_is_nonzero_const(p,R)
#define pvcomp_this_leading_term(p,R) 	monopoli_this_leading_term(p,R)
#define pvcomp_this_x_monomial(p,m,R) 	monopoli_this_x_monomial(p,m,R)
#define pvcomp_this_x_term(p,t,R) 	monopoli_this_x_term(p,t,R)
#define pvcomp_this_x_coeff(p,c,R) 	monopoli_this_x_coeff(p,c,R)
#define pvcomp_add_this_monomial(p,m,R)         monopoli_add_this_monomial(p,m,R)
#define pvcomp_x_monomial(p,m,R)	monopoli_x_monomial(p,m,R)
#define pvcomp_leading_coeff(p,R)	monopoli_leading_coeff(p,R)
#define this_term2pvcomp(t,R)	monopoli_this_term2monopoli(t,R)
#define pvcomp_is_homog_return_deg(p,R)	monopoli_is_homog_return_deg(p,R)
#define pvcomp_change_order(p,R,S) 	monopoli_change_order(p,R,S)
#define this_coeff2pvcomp(c,R)		this_coeff2monopoli(c,R)
#define this_monomial2pvcomp(m,R) 	this_monomial2monopoli(m,R)
#define pvcomp_this_leading_monomial(p,R)	(p)
#define pvcomp_this_leading_coeff(p,R)	monomial_coeff(p) /*MAX*/
#define pvcomp_sum_this_monomial_list(m,R)	monopoli_sum_this_monomial_list(m,R)
#define pvcomp_sum_this_monomial_list_to_this_pvcomp(m,p,R)	monopoli_sum_this_monomial_list_to_this_monopoli(m,p,R)
#define pvcomp_remove_lm(p,R)		monopoli_remove_lm(p,R)
#define pvcomp_extract_lm(p,R)		monopoli_extract_lm(p,R)
#define pvcomp_len(p,R)		monopoli_len(p) /*MAX*/

/* -------[ TRIPOLI ]---------------------*/

#elif defined(PVCOMP_TRIPOLI)

#define arpoly2pvcomp(p,R) 	arpoly2tripoli(p,R)
#define this_arpoly2pvcomp(p,R) this_arpoly2tripoli(p,R)

#define pvcomp2eee(p,R) 	tripoli2eee(p,R)
#define this_pvcomp2eee(p,R) 	this_tripoli2eee(p)
#define pvcomp2tripoli(p,R) 	tripoli_dup(p,R)
#define this_pvcomp2tripoli(p,R) 	(p)
#define pvcomp2monopoli(p,R)	tripoli2monopoli(p,R)
#define this_pvcomp2monopoli(p,R)	this_tripoli2monopoli(p,R)
#define pvcomp_add_this_monomial(p,m,R)         tripoli_add_this_monomial(p,m,R)
#define pvcomp_sum_this_monomial_list(m,R)	tripoli_sum_this_monomial_list(m,R)
#define pvcomp_sum_this_monomial_list_to_this_pvcomp(m,p,R)	tripoli_sum_this_monomial_list_to_this_tripoli(m,p,R)
#define pvcomp_remove_lm(p,R)	tripoli_remove_lm(p,R)
#define pvcomp_extract_lm(p,R)	tripoli_extract_lm(p,R)
#define pvcomp_deg(p,R)         tripoli_deg(p,R)
#define pvcomp_dup(p,R)         tripoli_dup(p,R)
#define pvcomp_change_sign(p,R) tripoli_change_sign(p,R)
#define pvcomp_size(p,R)        tripoli_size(p,R)
#define pvcomp_sum_these(p,q,R) tripoli_sum_these(p,q,R)
#define pvcomp_eq(p,q,R)        tripoli_eq(p,q,R)
#define pvcomp_sum(p,q,R)       tripoli_sum(p,q,R)
#define pvcomp_mult(p,q,R)      tripoli_mult(p,q,R)
#define pvcomp_mdeg(p,R)        tripoli_mdeg(p,R)
#define pvcomp2cterm(p,R)       tripoli2cterm(p,R)
#define pvcomp_free(p,R)        tripoli_free(p,R)
#define pvcomp_is_homog_deg(p,d,R)      tripoli_is_homog_deg(p,d,R)
#define pvcomp_is_nonzero_const(p,R)    tripoli_is_nonzero_const(p,R)
#define pvcomp_this_leading_term(p,R)   tripoli_this_leading_term(p,R)
#define pvcomp_this_x_monomial(p,m,R)   tripoli_this_x_monomial(p,m,R)
#define pvcomp_this_x_term(p,t,R)       tripoli_this_x_term(p,t,R)
#define pvcomp_this_x_coeff(p,c,R)      tripoli_this_x_coeff(p,c,R)
#define pvcomp_x_monomial(p,m,R)        tripoli_x_monomial(p,m,R)
#define pvcomp_leading_coeff(p,R)       tripoli_leading_coeff(p,R)
#define pvcomp_leading_term(p,R) 	tripoli_leading_term(p,R)
#define this_term2pvcomp(t,R)    this_term2tripoli(t,R)
#define pvcomp_is_homog_return_deg(p,R) tripoli_is_homog_return_deg(p,R)
#define pvcomp_change_order(p,R,S)      tripoli_change_order(p,R,S)
#define this_coeff2pvcomp(c,R)          this_coeff2tripoli(c,R)
#define this_monomial2pvcomp(m,R)       this_monomial2tripoli(m,R)
#define pvcomp_this_leading_monomial(p,R)       (p)
#define pvcomp_this_leading_coeff(p,R)	tripoli_this_leading_coeff(p) /*MAX*/

#define pvcomp_leading_monomial(p,R)    tripoli_leading_monomial(p,R)
#define pvcomp_only_leading_term(p,R)   tripoli_only_leading_term(p,R)
#define pvcomp_lm_which_gt(p,q,R)       tripoli_lm_which_gt(p,q,R)
#define pvcomp_sum_this_monomial_list(m,R)      tripoli_sum_this_monomial_list(m,R)
#define pvcomp_sum_this_monomial_list_to_this_pvcomp(m,p,R)     tripoli_sum_this_monomial_list_to_this_tripoli(m,p,R)
#define pvcomp_len(p,R)		tripoli_len(p,R) /*MAX*/

/* -------[ EEE ]-------------------------*/

#elif defined(PVCOMP_EEE)

#define arpoly2pvcomp(p,R) 	arpoly2eee(p,R)
#define this_arpoly2pvcomp(p,R) this_arpoly2eee(p,R)
#define pvcomp2eee(p,R) 	eee_dup(p,R)
#define this_pvcomp2eee(p,R) 	(p)
#define pvcomp2monopoli(p,R)	eee2monopoli(p,R)
#define this_pvcomp2monopoli(p,R)	this_eee2monopoli(p,R)

#define pvcomp_deg(p,R) 	eee_deg(p,R)
#define pvcomp_dup(p,R) 	eee_dup(p,R)
#define pvcomp_change_sign(p,R)	eee_change_sign(p,R)
#define pvcomp_size(p,R)	eee_size(p,R)
#define pvcomp_sum_these(p,q,R)	eee_sum_these(p,q,R)
#define pvcomp_eq(p,q,R)	eee_eq(p,q,R)
#define pvcomp_sum(p,q,R)	eee_sum(p,q,R)
#define pvcomp_mult(p,q,R)	eee_mult(p,q,R)
#define pvcomp_mdeg(p,R)	eee_mdeg(p,R)
#define pvcomp2cterm(p,R)	eee2cterm(p,R)
#define pvcomp_free(p,R)	eee_free(p,R)
#define pvcomp_add_this_monomial(p,m,R)         eee_add_this_monomial(p,m,R)
#define pvcomp_is_homog_deg(p,d,R) 	eee_is_homog_deg(p,d,R)
#define pvcomp_is_nonzero_const(p,R) 	eee_is_nonzero_const(p,R)
#define pvcomp_this_leading_term(p,R) 	eee_this_leading_term(p,R)
#define pvcomp_this_x_monomial(p,m,R) 	eee_this_x_monomial(p,m,R)
#define pvcomp_this_x_term(p,t,R) 	eee_this_x_term(p,t,R)
#define pvcomp_this_x_coeff(p,c,R) 	eee_this_x_coeff(p,c,R)
#define pvcomp_x_monomial(p,m,R)	eee_x_monomial(p,m,R)
#define pvcomp_leading_coeff(p,R)	eee_leading_coeff(p,R)
#define this_term2pvcomp(t,R)		this_term2eee(t,R)
#define pvcomp_is_homog_return_deg(p,R)	eee_is_homog_return_deg(p,R)
#define pvcomp_change_order(p,R,S) 	eee_change_order(p,R,S)
#define this_coeff2pvcomp(c,R)		this_coeff2eee(c,R)
#define this_monomial2pvcomp(m,R) 	this_monomial2eee(m,R)
#define pvcomp_this_leading_monomial(p,R)	(p)
#define pvcomp_leading_term(p,R) 	eee_leading_term(p,R)
#define pvcomp_leading_monomial(p,R)	eee_leading_monomial(p,R)
#define	pvcomp_only_leading_term(p,R)	eee_only_leading_term(p,R)
#define pvcomp_lm_which_gt(p,q,R)	eee_lm_which_gt(p,q,R)
#define pvcomp_sum_this_monomial_list(m,R)	eee_sum_this_monomial_list(m,R)
#define pvcomp_sum_this_monomial_list_to_this_pvcomp(m,p,R)	eee_sum_this_monomial_list_to_this_eee(m,p,R)
#define pvcomp_remove_lm(p,R)	eee_remove_lm(p,R)
#define pvcomp_extract_lm(p,R)  eee_extract_lm(p,R)
#define pvcomp_len(p,R)		eee_len(p,R) /*MAX*/
#define pvcomp_this_leading_coeff(p,R)	eee_this_leading_coeff(p) /*MAX*/

#else

# error "Undefined PVCOMP macro"

#endif

#endif /* PVCOMP_H */
