/* $Id: pvector.h,v 4.4.1.1 2004/06/18 14:24:25 cocoa Exp $ */

#ifndef PVECTOR_H
#define PVECTOR_H

#ifndef AUXTYPES_H
# include "auxtypes.h"
#endif

#ifndef COCTYPES_H
# include "coctypes.h"
#endif

/* ---[ shifts ]--------------------------------------- */

#define malloc_shifts(rk) (shifts)mymalloc(sizeof(shifts_aux),"shifts")
#define free_shifts(rk,p) myfree(sizeof(shifts_aux),p,"shifts")

#define malloc_term_list(size) \
  (term *)mymalloc(sizeof(term)*(size),"term_list")
#define free_term_list(size,p) myfree((size)*sizeof(term),p,"term_list")

#define shifts_ss(SS) ((SS)->ss)
#define shifts_set_ss(SS,X) (SS)->ss=X

#define shifts_rank(SS) (ABS((SS)->r))
#define shifts_set_rank(SS,R) ((SS)->r=R)
#define shifts_set_rc(SS,RC) ((SS)->rc=RC)
#define shifts_incr_rank(SS) ((SS)->r < 0 ? (SS)->r-- : (SS)->r++)

#define shifts_nth(SS,n) (SS==shifts_NULL ? term_NULL : ((SS)->ss[(n)-1]))
#define shifts_deg_nth(SS,n) \
  (SS==shifts_NULL ? 0 : term_degree((SS)->ss[(n)-1]))
#define shifts_set_nth(SS,n,s) (SS)->ss[(n)-1]=s

cterm shifts2cterm(shifts ss, ring R);
shifts shifts_dup(shifts ss);
coc_bool shifts_eq(shifts ss1, shifts ss2);
void shifts_free(shifts ss);
void shifts_expand(shifts ss);
void shifts_append(shifts * ss, term t);
shifts shifts_init(int r);

#define shifts_are_int(ss) (((ss)->r)<0)
#define shift_get_int(s) (-term_degree(s))

#define shifts_incr_rc(ss) ((ss)->rc++)
#define shifts_decr_rc(ss) ((ss)->rc--)

#define shifts_rc_is_zero(ss) ((ss)->rc==ZERO)

#ifdef DEBUG_SHIFTS_RC

shifts shifts_link(shifts ss);
void shifts_unlink(shifts ss);

#else

#define shifts_link(ss) ((ss) == shifts_NULL ? NULL : (shifts_incr_rc(ss),ss))
#define shifts_unlink(ss) \
    if ((ss)!=shifts_NULL) {\
      shifts_decr_rc(ss); \
      if (shifts_rc_is_zero(ss)) shifts_free(ss);}

#endif

/* ---[ pvector ]--------------------------------------- */

#define malloc_pv() (pvector)mymalloc(sizeof(pv_aux),"pvector")
#define free_pv(p) myfree(sizeof(pv_aux),p,"pvector")

#define realloc_pv_comp(p,r1,r2) \
  (pvcomp *) \
    myrealloc(p,sizeof(pvcomp)*(r1),sizeof(pvcomp)*(r2),"pvcomps")
#define malloc_pv_comp(r) \
  (pvcomp *)mymalloc(sizeof(pvcomp)*(r),"pvcomp")
#define free_pv_comp(r,p) myfree(sizeof(pvcomp)*(r),p,"pvcomps")

#define this_term2pv(t,n,r,R) pv_this_pvcomp2pv(this_term2pvcomp(t,R),n,r,R)
#define term2pv(t,n,r,R) pv_this_pvcomp2pv(term2pvcomp(t,R),n,r,R)

/*MAX*/
#define this_monomial2pv(t,n,r,R) pv_this_pvcomp2pv(this_monomial2pvcomp(t,R),n,r,R)
#define monomial2pv(t,n,r,R) pv_this_pvcomp2pv(monomial2pvcomp(t,R),n,r,R)
/*MAX*/

#define pv_this_arpoly2pv(p,n,r,R) pv_this_pvcomp2pv(this_arpoly2pvcomp(p,R),n,r,R)
#define pv_arpoly2pv(p,n,r,R) pv_this_pvcomp2pv(arpoly2pvcomp(p,R),n,r,R)

#define pv_shifts(v) ((v)->ss)
#define pv_nth(v,n) (((n)<pv_rank(v)) ? (v)->compo[n] : NULL)
#define pv_rank(v) ((v)->r)
#define pv_comp(v) ((v)->compo)

#define pv_set_rank(v,R) (v)->r=R
#define pv_set_shifts(v,SS) (v)->ss=SS
#define pv_set_nth(v,n,p) (v)->compo[n]=(p)
#define pv_set_comp(v,C) ((v)->compo=C)

#define this_pv_plus_mxpv(v,m,v1,R) pv_sum_these(v, pv_x_monomial(v1,m,R),R)

/* TODO:OPTIMIZE */
#define pv_force_rank(v,r,R) (*(v))=pv_sum_these((*(v)), pv_init(r),R)


coc_bool pv_is_homog(pvector v, ring R);

void pv_Apply_Shifts(pvector v, shifts ss, ring R);

void pv_Apply_Anti_Shifts(pvector v, ring R);

void pvcomp_Apply_Anti_Shift(pvcomp * p, pvector v, int i, ring R);

int pv_size(pvector v, ring R);

pvector pv_init(int r);
void pv_free(pvector v,ring R);

coc_bool pv_is_zero(pvector v);

pvector pv_sum(pvector v1, pvector v2, ring R);
/* NOTE: v1 and v2 MUST have the same rank */

pvector pv_subtract(pvector v1, pvector v2, ring R);
void pv_enlarge(pvector v, int r, shifts ss);

pvector pv_sum_these(pvector v1, pvector v2, ring R);
/* NOTE: v1 and v2 MUST have the same rank */

void pv_this_x_coeff(pvector v, coeff c, ring R);
void pv_change_sign(pvector v, ring R);

pvector pv_mult(pvcomp p, pvector v, ring R);
pvector pv_dup(pvector v, ring R);
pvector pv_fill(pvcomp p, int r, ring R);

cterm pv2cterm(pvector v, ring R);
cterm pv2cterm2(pvector v, ring R);
void printf_pv(pvector v, ring R);

void pv_extract_lm(pvector v, monomial * m, int * pos, ring R);

void pv_leading_monomial(pvector v, monomial * m, int * pos, ring R);
/* return a duplicate of the leading monomial of v, and its position */

#ifdef MONOPOLI
void pv_this_leading_term(pvector v, term * t, int * pos, ring R);
#endif

coeff pv_leading_coeff(pvector v, ring R);

void pv_leading_pos(pvector v, int * pos, ring R);
/* return the position of the leading monomial of v */

coc_bool pv_eq(pvector v1, pvector v2, ring R);

void pv_make_monic(pvector v, ring R);

pvector this_pv_plus_this_monomial(pvector v, monomial m, int pos, ring R);

pvector pv_pvcomp2pv(pvcomp p, int pos, int r, ring R);
pvector pv_this_pvcomp2pv(pvcomp p, int pos, int r, ring R);

pvector pv_only_leading_term(pvector v, ring R);

pvector pv_zero(int r, ring R);
pvector pv_gen(int r, int pos, ring R);
/* if pos>=r return the zero vector */

pvector pv_x_monomial(pvector v, monomial m, ring R);
pvector pv_this_x_monomial(pvector v, monomial m, ring R);
pvector pv_this_x_term(pvector v, term t, ring R);

int pv_deg(pvector v, ring R);
ivector pv_mdeg(pvector v, ring R);

void pv_change_order(pvector v, ring from_R, ring to_R);
void pv_zero2pv_NULL(pvector *v, ring R);

pvector pv_homog(pvector v, unknown x, ring R);

#define pv_is_NULL_or_zero(v) (((v)==pv_NULL) || pv_is_zero(v))

#endif


