/* $Id: record.c,v 4.4.1.1 2004/06/18 14:24:25 cocoa Exp $ */

#include <string.h>

#include "ck.h"
#include "ctbuf.h"
#include "cterm.h"
#include "math_lib.h"
#include "memoryco.h"
#include "object.h"
#include "operator.h"
#include "record.h"

cterm bind2cterm(env_slot slot);

ring record_extract_ring(env e)
{
  ring res_R;
  env_slot aux_slot;
  aux_slot=(env_slot)e;
  aux_slot=aux_slot->next; /* skip dummy var "#" */
  while (aux_slot!=NULL) {
    if ((res_R=object_extract_ring(mem_value(aux_slot->address))) != ring_NULL) 
      return res_R;
    aux_slot=aux_slot->next; }
  return ring_NULL;
}

coc_bool record_extract_ring_ck(env e, ring * res_R)
{
  ring aux_R;
  env_slot aux_slot;
  aux_slot=(env_slot)e;
  aux_slot=aux_slot->next; /* skip dummy var "#" */
  while (aux_slot!=NULL) {
    if (!object_extract_ring_ck(mem_value(aux_slot->address),res_R)) return FALSE;
    if (*res_R != ring_NULL) break;
    aux_slot=aux_slot->next; }
  while (aux_slot!=NULL) {
    if (!object_extract_ring_ck(mem_value(aux_slot->address),&aux_R)) return FALSE;
    if ((aux_R != ring_NULL) && (*res_R != aux_R)) return FALSE;
    aux_slot=aux_slot->next; }
  return TRUE;
}

void record_update_field2(record *r, char * id, object o)
{
  env_declare_and_assign(r,id,o);
  object_unlink(o);
}

cterm record2cterm(env e)
{
  env_slot aux_slot;
  ctbuf aux_b;
  aux_slot=(env_slot)e;
  aux_slot=aux_slot->next; /* skip dummy var "#" */
  aux_b=ctbuf_empty();
  while (aux_slot!=NULL) {
    ctbuf_append(aux_b,bind2cterm(aux_slot));
    aux_slot=aux_slot->next; }
  return ctbuf_mk_cterm(aux_b,op_RECORD);
}

cterm bind2cterm(env_slot slot)
{
  cterm params[2];
  object aux_o;

  aux_o=mem_value(slot->address);
  params[0]=cterm_mk_NBS(slot->id);
  params[1]=object2cterm(aux_o);
  object_unlink(aux_o);
  return cterm_mk_classic(op_BIND,2,params);
}


int record_do_size(env e)
{
  env_slot aux_slot;
  int sz = 0;
  aux_slot = (env_slot)e;
  aux_slot = aux_slot->next; /* skip dummy var "#" */
  while (aux_slot!=NULL)
  {
    object aux_o = mem_value(aux_slot->address);
    sz += do_size(aux_o);
/*    sz += strlen(slot->id); *//* ignore size of field names */
    aux_slot = aux_slot->next;
  }
  return sz;
}

/* Compare two RECORDs for equality; assumes names are ordered compatibly */
coc_bool record_eq(env e1, env e2)
{
  env_slot entry1, entry2;
  entry1 = (env_slot)e1;
  entry2 = (env_slot)e2;
  entry1 = entry1->next; /* skip dummy var "#" */
  entry2 = entry2->next; /* skip dummy var "#" */
  while (entry1 != NULL && entry2 != NULL)
  {
    if (strcmp(entry1->id, entry2->id) != 0) return FALSE;
    {
      object val1 = mem_value(entry1->address);
      object val2 = mem_value(entry2->address);
      coc_bool res = do_is_eq(val1, val2);
      object_unlink(val1);
      object_unlink(val2);
      if (res == FALSE) return FALSE;
      entry1 = entry1->next;
      entry2 = entry2->next;
    }
  }
  if (entry1 != entry2) return FALSE;
  return TRUE;
}
