/* $Id: ring.h,v 4.4.1.1 2004/06/18 14:24:25 cocoa Exp $ */

#ifndef RING_H
#define RING_H

#ifndef AUXTYPES_H
# include "auxtypes.h"
#endif

#ifndef COCTYPES_H
# include "coctypes.h"
#endif

#define malloc_ring() (ring)mymalloc(sizeof(ring_el),"ring")
#define free_ring(p) myfree(sizeof(ring_el),p,"ring")

#define ring_locked(R) ((R)->locked)
#define ring_set_locked(R,b) (R)->locked=b

#define ring_set_rc(R,n) (R)->rc=(n)
#define ring_rc(R) ((R)->rc)
#define ring_incr_rc(R) ((R)->rc++)
#define ring_decr_rc(R) ((R)->rc--)

#define ring_unlink_do(R) \
  do { ring_decr_rc(R); \
       if (ring_rc(R)==0) {env_delete_var(&ring_env,(R)->ring_name); ring_free(R);}} while(FALSE)
       
#ifdef DEBUG_RING_RC

ring ring_link(ring R);
void ring_unlink(ring R);

#else

#define ring_link(R) \
  (R != ring_NULL ? (ring_incr_rc(R),R) : ring_NULL)


#define ring_unlink(R) if ((R)!=ring_NULL) ring_unlink_do(R)

#endif

#define ring_coeffs(R) ((R)->coeffs)
#define ring_level(R) ((R)->level)
#define ring_ordering(R) ((R)->to)
#define ring_indets_num(R) ((R)->indetsNo)
#define ring_characteristic(R) ((R)->characteristic)

#define rings_compatible(R,S) ((R)==(S) || (R)==ring_NULL || (S)==ring_NULL)

#define ring_set_level(R,L) (R)->level=L;

#define ring_of_coeff(N,C) ring_init(N,ringtype_coeff,C,\
                            ring_NULL,indet_info_NULL,to_NULL,ZERO,ZERO)

#define ring_type(R) ((R)->rtype)

#define ring_id2cterm(R) (cterm_mk_NBS((R)->ring_name))
#define ring_id(R) ((R)->ring_name)
#define ring_set_id(R,N) (R)->ring_name=(N)

/* MEGATAPPULLO (TODO) */
#define is_polynomial_ring(R) \
  (R->rtype==ringtype_poly || R->rtype==ringtype_quotient)
/* FINE MEGATAPPULLO */


#define ring_local_env(R) ((R)->local_env)
#define ring_weights(R) ((R)->weights)
#define ring_weilist(R) ((R)->weightlist)
#define ring_set_local_env(R,E) (R)->local_env=(E)
#define ring_set_mordering(R,M) (R)->mord=(M)
#define ring_mordering(R) (R)->mord  /*MAX*/
#define ring_set_weights(R,W) (R)->weights=(W)
#define ring_set_weilist(R,W) (R)->weightlist=(W)

extern ring ring_Q, ring_Z, ring_ShZ;

void ring_clear(ring R);
void ring_set_ordering(ring R,ordering to,short whatTO,
  unknown first_unknown, unknown last_unknown);

ring ring_init(char * ring_name,ringtype rt,int characteristic,ring coeffs,
         indet_info indets,ordering to,short whatTO,short mord);
/* initilize the ring R and assign to the ring R the informations for it */

coc_bool ring_coeff_in_field(ring R);
void ring_free_ordering(ring R);
void ring_free(ring R);

cterm ring2cterm(ring R);
cterm ring_env2cterm(ring R);
ordering ring_build_ordering(ring R);

#endif
