/* rum.h : 0.1 : 8 Oct 93 : RUM memory management */

/*------------------------------------------------------------------------------

	revision history
		
------------------------------------------------------------------------------*/

#ifndef RUM_H
#define RUM_H

#define RUM_MAX_ALLOCATION 10000
#define RUM_N_STACKS 801

#ifndef UTILS_H
# include "utils.h"
#endif

/* when stack is empty reload with RUM_RELOAD pieces */
#define RUM_RELOAD 1000
/* when stack is empty charge RUM_INIT_LOAD pieces */
#define RUM_INIT_LOAD 1000

#define RUM_MAX_SIZE 10000
#define RUM_STD_SIZE 2000

/* every RUM_STAT_FREQ rum-operations, statistics are automatically displayed */
/* if RUM_STAT_FREQ = -1 then statistics are displayed only manually  */
#define RUM_STAT_FREQ -1

void rum_init_all(void);
/* initialize all the rum-stacks 0 slots */

void rum_init(int rum, int size);
/* initialize the rum-stack rum for size slots */

void * rum_malloc(int size);

void rum_free(int size, void * p);

void rum_show_statistics( int n );

#endif
