#ifndef BITSET_H
#define BITSET_H

#ifdef ANNA

# include "AnnaUtils.h"

#else

#ifndef AUXTYPES_H
# include "auxtypes.h"
#endif

#endif


/* ------------------------------------------------------------------------- */

#define bs_put_n(s,n) \
      do{if (n<=(8*sizeof(shortbitset))) s |= 1<<(n-1);}while (FALSE)
#define bs_del_n(s,n) \
      do{if (n<=(8*sizeof(shortbitset))) s &= ~(1<<(n-1));}while (FALSE)

/* ------------------------------------------------------------------------- */

#define bs_free(s) s=0

/* EVERYWHERE assumed s1 initialized, with the same length of s2 */

#define bs_init(n) 0

#define bs_dup(s) s

#define bs_eq(s1,s2) (s1==s2)
/* TRUE iff s1==s2 */

#define bs_union_and_assign(s1,s2)  (s1 = ((s1)|(s2)))
/* s1 = s1 U s2 */

#define bs_union(s1,s2)  ((s1)|(s2))
/* returns s1 U s2 */

#define bs_intersection(s1,s2)  ((s1)&(s2))
/* returns s1 inters s2 */


#define bs_contained(s1,s2)   (((s1)&(s2))==(s1))
/* TRUE iff s1 contained in s2 */
 
#define bs_disjoint(s1,s2)   (((s1)&(s2))==0)
/* TRUE iff s1, s2 disjoint */


#endif  /* BITSETS_H */


