/* $Id: scalars.c,v 4.4.1.1 2004/06/18 14:24:25 cocoa Exp $ */

#include "cocdefs.h"

int scalars_c_dummy;

#ifdef SCALARS

#include "ivectors.h"
#include "scalars.h"
#include "terms.h"

void scalars_set_sum(scalars *ss,scalars ss1,scalars ss2)
{
  register int i;
  *ss=malloc_iv(scalars_len(ss1));
  for (i=scalars_len(ss1);i>0;i--)
    scalars_set_nth(*ss,i,scalars_nth(ss1,i)+scalars_nth(ss2,i));
  scalars_set_len(*ss,scalars_len(ss1));
}

int scalars_which_gt_lex(scalars ss1, scalars ss2)
{
  register int i;
  register int l=scalars_len(ss1);
  for (i=1;i<=l;i++) {
    if (scalars_nth(ss1,i) > scalars_nth(ss2,i)) return ANSWER_FIRST;
    if (scalars_nth(ss1,i) < scalars_nth(ss2,i)) return ANSWER_SECOND; }
  return ANSWER_BOTH;
}

term scalars2term_lex(scalars ss,ring R)
{
  term res_t;
  int i,sum;
  res_t=term_init(scalars_len(ss));
  for (i=1;i<=scalars_len(ss);i++) {
    term_put_nth(res_t,i,scalars_nth(ss,i)); }
  return res_t;
}

term scalars2term_xel(scalars ss,ring R)
{
  term res_t;
  int i,sum;
  res_t=term_init(scalars_len(ss));
  for (i=1;i<=scalars_len(ss);i++) {
    term_put_nth(res_t,i,scalars_nth(ss,scalars_len(ss)-i+1)); }
  return res_t;
}

term scalars2term_gen(scalars ss,ring R)
{
  term res_t;
  register int i;
  int n;
  res_t=term_init(R->indetsNo);
  for (i=1;i<=R->indetsNo;i++) {
    n = term_scalar(i-1,ss,R->ot)/R->det;
    term_put_nth(res_t,i,n); }
  return res_t;
}

term scalars2term_degrevlex(scalars ss,ring R)
{
  term res_t;
  register int i,t;
  int s;
  res_t=term_init(R->indetsNo);
  term_set_degree(res_t,scalars_nth(ss,1));
  t=scalars_nth(ss,1);
  for (i=2;i<=R->indetsNo;i++) {
    t+= (s= scalars_nth(ss,R->indetsNo-i+2));
    term_set_nth(res_t,i,-s); }
  term_set_nth(res_t,1,t);
  return res_t;
}

scalars term2scalars_lex(term t,ring R)
{
  return (scalars)term_dup(t);
}

scalars term2scalars_xel(term t,ring R)
{
  scalars res_ss;
  int i;
  res_ss=scalars_init(R->indetsNo);
  for (i=1;i<=R->indetsNo;i++) {
    scalars_set_nth(res_ss,i,term_get_nth(t,R->indetsNo-i+1)); }
  return res_ss;
}

scalars term2scalars_gen(term t,ring R)
{
  scalars res_ss;
  register int i;
  res_ss=scalars_init(R->indetsNo);
  for (i=1;i<=R->indetsNo;i++)
    scalars_set_nth(res_ss,i,term_scalar(i-1,t,R->to));
  return res_ss;
}

scalars term2scalars_degrevlex(term t,ring R)
{
  scalars res_ss;
  register int i;
  res_ss=scalars_init(R->indetsNo);
  scalars_set_nth(res_ss,1,term_degree(t));
  for (i=2; i<=R->indetsNo; i++)
    scalars_set_nth(res_ss,i,-term_get_nth(t,R->indetsNo-i+2));
  return res_ss;
}

/* --------------------- *\
           IVEC
\* --------------------- */

term ivec_scalars2term_lex(ivec ss,ring R)
{
  term res_t;
  int i,sum;
  res_t=term_init(ivec_len(ss));
  for (i=1;i<=ivec_len(ss);i++) {
    term_put_nth(res_t,i,ivec_nth(ss,i)); }
  return res_t;
}

term ivec_scalars2term_xel(ivec ss,ring R)
{
  term res_t;
  int i,sum,l;
  l=ivec_len(ss);
  res_t=term_init(l);
  for (i=1;i<=l;i++) {
    term_put_nth(res_t,i,ivec_nth(ss,l-i+1)); }
  return res_t;
}

term ivec_scalars2term_gen(ivec ss,ring R)
{
  term res_t;
  register int i;
  int n;
  res_t=term_init(R->indetsNo);
  for (i=1;i<=R->indetsNo;i++) {
    n = ivec_term_scalar(i-1,ss,R->ot)/R->det;
    term_put_nth(res_t,i,n); }
  return res_t;
}

term ivec_scalars2term_degrevlex(ivec ss,ring R)
{
  term res_t;
  register int i,t;
  int s;
  res_t=term_init(R->indetsNo);
  term_set_degree(res_t,ivec_nth(ss,1));
  t=ivec_nth(ss,1);
  for (i=2;i<=R->indetsNo;i++) {
    t+= (s= ivec_nth(ss,R->indetsNo-i+2));
    term_set_nth(res_t,i,-s); }
  term_set_nth(res_t,1,t);
  return res_t;
}

ivec ivec_term2scalars_lex(term t,ring R)
{
  ivec res_ss;
  register int i;
  res_ss=ivec_init(R->indetsNo);
  for (i=1;i<=R->indetsNo;i++) {
    ivec_set_nth(res_ss,i,term_get_nth(t,i)); }
  return res_ss;
}

ivec ivec_term2scalars_xel(term t,ring R)
{
  ivec res_ss;
  int i;
  res_ss=ivec_init(R->indetsNo);
  for (i=1;i<=R->indetsNo;i++) {
    ivec_set_nth(res_ss,i,term_get_nth(t,R->indetsNo-i+1)); }
  return res_ss;
}

ivec ivec_term2scalars_gen(term t,ring R)
{
  ivec res_ss;
  register int i;
  res_ss=ivec_init(R->indetsNo);
  for (i=1;i<=R->indetsNo;i++)
    ivec_set_nth(res_ss,i,term_scalar(i-1,t,R->to));
  return res_ss;
}

ivec ivec_term2scalars_degrevlex(term t,ring R)
{
  ivec res_ss;
  register int i;
  res_ss=ivec_init(R->indetsNo);
  ivec_set_nth(res_ss,1,term_degree(t));
  for (i=2; i<=R->indetsNo; i++)
    ivec_set_nth(res_ss,i,-term_get_nth(t,R->indetsNo-i+2));
  return res_ss;
}


#endif
