/* $Id: scalars.h,v 4.4.1.1 2004/06/18 14:24:25 cocoa Exp $ */

#ifndef SCALARS_H
#define SCALARS_H

#ifndef AUXTYPES_H
# include "auxtypes.h"
#endif

#ifndef COCTYPES_H
# include "coctypes.h"
#endif

#define scalars_init(n) iv_init(n)
#define scalars_free(ss) iv_free(ss)
#define scalars_dup(ss) iv_dup_no_sum(ss)
#define scalars_nth(ss,n) iv_get_nth(ss,n)
#define scalars_set_nth(ss,n,s) iv_set_nth(ss,n,s)

void scalars_set_sum(scalars *ss,scalars ss1,scalars ss2);

#define scalars_sum(ss1,ss2) iv_sum(ss1,ss2)
#define scalars_len(ss) iv_get_len(ss)
#define scalars_set_len(ss,l) iv_set_len(ss,l)
#define scalars_eq(ss1,ss2) iv_eq(ss1,ss2)
#define scalars_add_to_this(ss,ss1) iv_sum_and_assign(ss,ss1)

#define scalars2term(ss,R) R->scalars2term(ss,R)
#define term2scalars(t,R) R->term2scalars(t,R)

#define ivec_scalars2term(ss,R) R->ivec_scalars2term(ss,R)
#define ivec_term2scalars(t,R) R->ivec_term2scalars(t,R)

/* return ANSWER_BOTH iff ss1==ss2 */
/* return ANSWER_FIRST iff ss1>ss2 */
/* return ANSWER_SECOND iff ss2>ss1 */
int scalars_which_gt_lex(scalars ss1, scalars ss2);

term scalars2term_lex(scalars s,ring R);
term scalars2term_xel(scalars ss,ring R);
term scalars2term_gen(scalars s,ring R);
term scalars2term_degrevlex(scalars s,ring R);

scalars term2scalars_lex(term t,ring R);
scalars term2scalars_xel(term t,ring R);
scalars term2scalars_gen(term t,ring R);
scalars term2scalars_degrevlex(term t,ring R);

/* --------------------- *\
           IVEC
\* --------------------- */

term ivec_scalars2term_lex(ivec ss,ring R);
term ivec_scalars2term_xel(ivec ss,ring R);
term ivec_scalars2term_gen(ivec ss,ring R);
term ivec_scalars2term_degrevlex(ivec ss,ring R);

ivec ivec_term2scalars_lex(term t,ring R);
ivec ivec_term2scalars_xel(term t,ring R);
ivec ivec_term2scalars_gen(term t,ring R);
ivec ivec_term2scalars_degrevlex(term t,ring R);

#endif
