/* $Id: tripoli.h,v 4.4.1.1 2004/06/18 14:24:25 cocoa Exp $ */

#ifndef TRIPOLI_H
#define TRIPOLI_H

#ifndef AUXTYPES_H
# include "auxtypes.h"
#endif

#ifndef COCTYPES_H
# include "coctypes.h"
#endif

extern mon mon_dummy,mon_dummy1;

/* POLYNOMIALS */

#define tripoli_monomials(p)       ((mon)p)
#define tripoli_monomials_star(p)       ((mon *)&p)
#define tripoli_trnode(p)          ((trnode)p)
#define tripoli_set_monomials(p,M) p=((mon)(M))
#define tripoli_set_trnode(p,TP)  p=((trnode)(TP))

/* TRIPOLI */

#define malloc_trnode() (tripoli)mymalloc(sizeof(trnode_aux),"tripoli")
#define free_trnode(p) myfree(sizeof(trnode_aux),p,"tripoli")

#define trnode_homo_comp(tp)        ((tp)->p)
#define trnode_next_comp(tp)        ((tp)->next)
#define trnode_scalar(tp)           ((tp)->sp)
#define trnode_set_scalar(tp,S)     (tp)->sp=S
#define trnode_set_homo_comp(tp,P)  (tp)->p=P
#define trnode_set_next_comp(tp,TP) (tp)->next=TP

/* TRIPOLI_ARRAY */

#define malloc_trnode_array(n) \
  (trnode *)mymalloc((n)*sizeof(trnode),"trnode_array")
#define free_trnode_array(n,p) myfree((n)*sizeof(trnode),p,"trnode_array")

trnode * trnode_array_init(int n, ring R);
void trnode_array_free(int n, trnode * tp_array);
trnode * trnode_array_dup(int n, trnode * tp_array,ring R);

/* MON */

#define malloc_mon() (mon)mymalloc(sizeof(mon_aux),"mon")
#define free_mon(p) myfree(sizeof(mon_aux),p,"mon")

#define mon_coeff(m)         (m)->c
#define mon_next(m)          (m)->next
#define mon_scalars(m)       (m)->ss
#define mon_set_coeff(m,C)   (m)->c=C
#define mon_set_scalars(m,S) (m)->ss=S
#define mon_set_next(m,M)    (m)->next=M

/* --------------------------------- *\
            POLYNOMIAL
\* --------------------------------- */

/* ENTRY FUNCTIONS */

#define tripoli_one(R) this_coeff2tripoli(coeff_one(R),R)

#define tripoli_sum_this_monomial_list(m,R)	tripoli_sum_this_monomial_list_to_this_tripoli(m,NULL,R)

#define tripoli_dup(p,R) tripoli_dup_l(p,0,R)
#define tripoli_mult(p1,p2,R) tripoli_mult_l(p1,p2,0,R)
#define tripoli_sum(p1,p2,R) tripoli_sum_l(p1,p2,0,R)
#define tripoli_sum_these(p1,p2,R) tripoli_merge(p1,p2,R)
#define tripoli_free(p,R) tripoli_free_l(p,0,R)
#define tripoli_leading_coeff(p,R) coeff_dup(tripoli_this_leading_coeff(p,R),R)

tripoli tripoli_remove_lm(tripoli p, ring R);
tripoli tripoli_sum_this_monomial_list_to_this_tripoli(monomial m,
  tripoli p, ring R);

int tripoli_deg(tripoli p, ring R);
int tripoli_len(tripoli p, ring R);
int tripoli_size(tripoli p, ring R);
cterm tripoli2cterm(tripoli p,ring R);

term tripoli_this_leading_term(tripoli p, ring R);

int tripoli_lm_which_gt(tripoli p1, tripoli p2, ring R);
coc_bool tripoli_is_nonzero_const(tripoli p, ring R);
tripoli tripoli_coeff2tripoli(coeff c, ring R);

tripoli this_coeff2tripoli(coeff c, ring R);
tripoli unknown_pow2tripoli(unknown u,expType exponent,ring R);
coc_bool tripoli_eq(tripoli p1, tripoli p2, ring R);
tripoli tripoli_x_monomial(tripoli p, monomial m, ring R);

tripoli tripoli_this_x_monomial(tripoli p, monomial m, ring R);
tripoli tripoli_this_x_coeff(tripoli p, coeff c, ring R);
/* NOTE: c must be non zero */
/* furthermore we assume R integral domain */

void tripoli_change_sign(tripoli p, ring R);
tripoli tripoli_x_opp_term(tripoli p, term t, ring R);
tripoli tripoli_this_x_opp_term(tripoli p, term t, ring R);
tripoli tripoli_this_x_term(tripoli p, term t, ring R);


term tripoli_leading_term(tripoli p, ring R);
tripoli tripoli_only_leading_term(tripoli p, ring R);
monomial tripoli_leading_monomial(tripoli p, ring R);
coeff tripoli_this_leading_coeff(tripoli p, ring R);

tripoli this_term2tripoli(term t, ring R);
tripoli this_monomial2tripoli(monomial m, ring R);

/* AUXILIARY FUNCTIONS */

#define tripoli_merge(p1,p2,R) tripoli_merge_l(p1,p2,0,R)
#define tripoli_addthis2this_l(p,p1,level,R) \
  *(p)=tripoli_merge_l(*(p),p1,level,R)
#define tripoli_monopoli2cterm(p,R) special_monomials2cterm(tripoli_monomials(p),R)

tripoli tripoli_dup_l(tripoli p,int level, ring R);
tripoli tripoli_mult_l(tripoli p1, tripoli p2, int level, ring R);
tripoli tripoli_merge_l(tripoli p1,tripoli p2,int level,ring R);
tripoli tripoli_monopoli_sum(tripoli p1, tripoli p2, ring R);
tripoli tripoli_monopoli_mult(tripoli p1, tripoli p2, ring R);
void tripoli_monopoli_add2this(tripoli * this,tripoli p, ring R);
tripoli tripoli_sum_l(tripoli p1,tripoli p2,int level,ring R);
tripoli tripoli_mult_homo_tripoli(trnode homo,trnode tp,int level,ring R);
cterm tripoli2cterm_l(tripoli p,int level,ring R);
void special_printf_tripoli(tripoli p,ring R);
void special_printf_trnode_l(tripoli p,int level,ring R);
void tripoli_free_l(tripoli tp,int level,ring R);
mon tripoli_leading_mon(tripoli p, ring R);
scalars tripoli_leading_scalars(tripoli p, ring R);
tripoli tripoli_only_leading_mon(tripoli p,ring R);
tripoli mon2tripoli(mon m,ring R);
tripoli tripoli_monopoli_mon2tripoli(mon m, ring R);
coc_bool tripoli_eq_l(tripoli p1,tripoli p2,int level,ring R);
tripoli tripoli_this_x_mon_l(tripoli p,mon m,scalars ss,int level,
  ring R);

tripoli tripoli_x_mon_l(tripoli p,mon m,scalars ss,int level,ring R);

ring tripoli_x_mon_l_ring;
scalars tripoli_x_mon_l_scalars;
mon tripoli_x_mon_l_mon;
int tripoli_x_mon_l_max_l;

tripoli tripoli_x_opp_scalars_l(tripoli p,scalars ss,scalars aux_ss,
  int level,ring R);
tripoli tripoli_this_x_opp_scalars_l(tripoli p,scalars ss,scalars aux_ss,
  int level,ring R);
tripoli tripoli_this_x_scalars_l(tripoli p,scalars ss,scalars aux_ss,
  int level,ring R);
int tripoli_deg_l(tripoli p, scalars ss, int level, ring R);
void tripoli_change_sign_l(tripoli p, int level, ring R);
int tripoli_len_l(tripoli p, int level, ring R);
int tripoli_size_l(tripoli p, int level, ring R);

ctbuf tripoli2ctbuf_l(tripoli p,scalars ss,int level,ring R);

void tripoli_add_this_monomial_unique(monomial m, tripoli *p, ring R);
tripoli tripoli_add_this_monomial(tripoli p, monomial m, ring R);

tripoli scalars2tripoli(scalars ss,ring R);

/* --------------------------------- *\
             TRIPOLI 
\* --------------------------------- */

#define special_tripoli2cterm(p,R) trnode2cterm_l(p,0,R)

#define tripoli_dummy(R,level) ((R)->tripoli_dum[level])

void tripoli_adt_init(void);
/* initialize the tree version of ADT tripoli */

trnode trnode_dup_l(trnode tp,int level,ring R);

#define tripoli_set_mk(res_tp,s,p) do { \
  res_tp=malloc_trnode();\
  trnode_set_scalar(res_tp,s);\
  trnode_set_homo_comp(res_tp,p);\
  trnode_set_next_comp(res_tp,NULL); } while (FALSE)

trnode trnode_mk(scalar s,tripoli p);
cterm trnode2cterm_l(trnode tp,int level,ring R);
void printf_trnode_l(trnode tp,int level,ring R);
void trnode_free_l(trnode tp,int level,ring R);
trnode trnode_rm_zero_comp(trnode tp,int level, ring R);

void tripoli_plus_mxp_l(tripoli * zis,mon m,tripoli p,scalars ss,
  int level,ring R);



/* --------------------------------- *\
            MONOMIALS
\* --------------------------------- */

#define monomials_addthis2this(m,m1,R,first_mon) \
  do{*(m)=monomials_merge(*(m),m1,R,first_mon);} while(FALSE)

mon monomials_dup(mon m,ring R);
mon monomials_merge(mon m1, mon m2, ring R,mon * first_mon);
mon monomials_merge_normal(mon m1, mon m2, ring R);

mon monomials_mult(mon m1, mon m2, ring R);
mon monomials_mult_mon_monomials(mon m,mon mm,ring R);
void monomials_add2these(mon * ziis, mon m, ring R);
mon monomials_sum(mon m1, mon m2, ring R);
cterm special_monomials2cterm(mon mm,ring R);
void monomials_free(mon m,ring R);
coc_bool monomials_eq(mon m1, mon m2, ring R);
mon monomials_these_x_mon(mon ziis_m, mon m, ring R);
mon monomials_x_mon(mon mm, mon m, ring R);
mon monomials_x_opp_scalars(mon mm, scalars ss, ring R);
mon monomials_these_x_opp_scalars(mon mm, scalars ss, ring R);
mon monomials_these_x_scalars(mon mm, scalars ss, ring R);

int monomials_deg(mon m,scalars ss,ring R);
void monomials_change_sign(mon m,ring R);
int monomials_len(mon m);
int monomials_size(mon m, ring R);
ctbuf monomials2ctbuf(mon m,scalars ss,ring R);
void monomials_plus_mxmm(mon * aux_m,mon m,mon mm,ring R);
mlist monomials2mlist(mon m,scalars ss,ring R);

/* --------------------------------- *\
               MON
\* --------------------------------- */

#define mon_dup(m,R) \
  mon_mk(coeff_dup(mon_coeff(m),R),scalars_dup(mon_scalars(m)));
#define mon_is_zero(m,R) coeff_is_zero(mon_coeff(m),R)
#define mon_change_sign(m,R) R->ChangeSignToCoeff(& mon_coeff(m),R)

#define mon_set_mk(res_m,c,ss) do { \
  res_m=malloc_mon();\
  mon_set_coeff(res_m,c);\
  mon_set_scalars(res_m,ss);\
  mon_set_next(res_m,NULL); } while (FALSE);

mon mon_mk(coeff c,scalars ss);
cterm special_monomial2cterm(mon m,ring R);
void printf_mon(mon m,ring R);
void mon_free(mon m,ring R);
coc_bool mon_eq(mon m1, mon m2, ring R);
int mon_deg(mon m,scalars ss,ring R);
cterm mon2cterm(mon m,scalars ss,ring R);
mon mon2longmon(mon m,scalars ss,ring R);
/* if m=(c,ss1) return the mon (c,concat(ss,ss1)) */

monopoli this_mlist2monopoli(mlist ML,ring R);
/* NOTE: ML CANNOT be empty */

mlist tripoli2mlist_l(tripoli p, scalars ss, int level, ring R);
monopoli this_tripoli2monopoli(tripoli p,ring R);
monomial tripoli2monopoli(tripoli p, ring R);

tripoli tripoli_sum_this_monopoli(monopoli m, ring R);
tripoli tripoli_sum_monopoli(monopoli m, ring R);

#define this_monopoli2tripoli(p,R)	tripoli_sum_this_monopoli(p,R)
#define monopoli2tripoli(p,R)	tripoli_sum_monopoli(p,R)

ivector tripoli_max_mdeg(tripoli p, ring R);
coc_bool tripoli_is_homog(tripoli p, ring R);
coc_bool tripoli_is_homog_deg(tripoli p, int hd, ring R);
int tripoli_is_homog_return_deg(tripoli p, ring R);

monomial tripoli_extract_lm(tripoli *p, ring R);

tripoli tripoli_map(tripoli p, ring R, ring S, ivector m);

#define tripoli_mdeg(p,R) 	tripoli_max_mdeg(p,R)

tripoli tripoli_randomize(tripoli p, ring R);
tripoli tripoli_this_plus_term_x_tripoli_truncated(tripoli p, term t, 
  tripoli p2, iv_elem Trunc, ring R);

tripoli tripoli_this_minus_term_x_tripoli_truncated(tripoli p, term t, 
  tripoli p2, iv_elem Trunc, ring R);

tripoli tripoli_this_plus_term_x_tripoli(tripoli p, term t, 
  tripoli p2, ring R);

tripoli tripoli_this_minus_term_x_tripoli(tripoli p, term t, 
  tripoli p2, ring R);

tripoli tripoli_der(tripoli p, unknown x, ring R);
tripoli tripoli_square(tripoli p, ring R);
olist tripoli2sppnum(tripoli p, ring R);



#endif /* TRIPOLI */
