/* 	%W%	 */

#ifndef UNIPOLY_H
#define UNIPOLY_H

#ifndef ANNA

#ifndef AUXTYPES_H
# include "auxtypes.h"
#endif

#ifndef COCTYPES_H
# include "coctypes.h"
#endif

#include <gmp.h>

#else

#include "AnnaUtils.h"

#endif


/**************************  extern  **************************/

#define Unipoly unipoly
#define PoincareMaxPower 100

extern unipoly *PowerList;

/*********  UNIPOLY-RUM  *********/
typedef struct unipoly_rum_aux {
  unipoly * slots;
  int MaxDeg;
  int top;
} unipoly_rum_stack;

extern unipoly_rum_stack UNIPOLY_RUM;

void unipoly_rum_init(int n);
void unipoly_rum_reset(int n);
unipoly unipoly_rum_malloc();
void    unipoly_rum_free(unipoly p);

/*********    ALLOC-FREE   *********/
#define unipoly_malloc(sz) \
   ( ( sz == UNIPOLY_RUM.MaxDeg ) ? \
     (unipoly_rum_malloc(sz)+3) : (unipoly)mymalloc(UPRealSize(sz),"UP")+3 )
#define unipoly_free(p) \
   { if ( UPSize(p) == UNIPOLY_RUM.MaxDeg ) \
     unipoly_rum_free((p)-3); else myfree(UPRealSize(UPSize(p)),(p)-3,"UP");}
#define unipoly_realloc(p,newsz) \
   (unipoly)myrealloc((p)-3, UPRealSize(UPSize(p)), UPRealSize(newsz), "UP")+3

/**************************    **************************/

#define UPRealSize(sz) ((sz+4)*sizeof(UPCoeff))
#define UPFirst  -3
#define UPLast(n) n

#define UPDeg(P)    (P)[-1].i
#define UPMax(P)    (P)[-2].i
#define UPSize(P)   (P)[-3].i
#define UPSetDeg(P,D)  UPDeg(P)  = (D)
#define UPSetMax(P,M)  UPMax(P)  = (M)
#define UPSetSize(P,S) UPSize(P) = (S)

/* TODO remove */
#define UnipolyDegree(P)      UPDeg(P)
/* TODO remove end */

unipoly unipoly_dup(unipoly p);

unipoly NewUnipoly(int size);
unipoly UnipolyOne(int size);
void FreeUnipoly(unipoly p);

unipoly UnipolyChangeSize(unipoly p, int NewSize);

/*  every function frees all the arguments  */
unipoly P1PlusXExpP2  (unipoly P1, int exp, unipoly P2);
unipoly P1MinusXExpP2 (unipoly P1, int exp, unipoly P2);
unipoly P1TimesP2     (unipoly P1, unipoly P2);
void MultByOneMinusXExp (unipoly p, int exp);

unipoly* MakePowerList (int n);
unipoly PowerExtDup (int n, int size);

int UnipolySubCoeffsOfXd(unipoly p1, unipoly p2, int d);
int UnipolyAddCoeffsOfXd(unipoly p1, unipoly p2, int d);

/*********  ifdef ANNA  *********/
#ifdef ANNA
unipoly TruncP1PlusXExpP2  (unipoly p1, int exp, unipoly p2, int Trunc);
unipoly TruncP1MinusXExpP2 (unipoly p1, int exp, unipoly p2, int Trunc);
void TruncMultByOneMinusXExp(unipoly p, int exp, int Trunc);

void unipoly_sum_of_coeffs(UPCoeff *sum, unipoly p);
void unipoly_divide_by1minus_x(unipoly p);
void FreeUnipolyList (unipoly * UL, int n);
#endif

/*********  ifndef ANNA  *********/
#ifndef ANNA  
#define Add1ToCoeffOfXd(p,d) \
  {if (UPMax(p)!=0) ((p)[d].i)++; else mpz_add_ui((p)[d].z, (p)[d].z, 1);}

cterm unipoly2cterm(unipoly p);
olist unipoly2sppnum(unipoly p);
unipoly sppnum2unipoly(olist ol);
void printf_unipoly(unipoly p);
#endif
#endif




