/* weights.c : 0.8 : 11 Jul 94 : weights & weilist */         

/*-----------------------------------------------------------------------------


------------------------------------------------------------------------------*/

#include "cocdefs.h"
#include "ivectors.h"
#include "ring.h"
#include "terms.h"
#include "weights.h"

ivector max_mdeg_lex_these( ivector v1, ivector v2)
{
  int n;
  n=iv_which_gt_lex(v1,v2);
  if (n==ANSWER_FIRST) {
    iv_free(v2);
    return v1;
  } else {
    iv_free(v1);
    return v2;
  }
}

ivector term_mdegree( term u, ring R )
{
  register w_num;
  ivector result;
  term t;
  weilist weights;
  register int j,sp;
  weights = ring_weilist(R);
  w_num = weilist_len(weights) ;
  t = term_true(u,R);
  result=iv_init(w_num);
  for ( j=0; j<w_num; j++ ) {
    sp=iv_scalar(t,weilist_nth(weights,j+1));
    iv_set_nth(result,j+1,sp); }
  term_free(t);
  return result;
}

weilist weilist_init(int n)
{
  int i;
  weilist res_l;
  res_l=malloc_weilist(n);
  weilist_set_len(res_l,n);
  for (i=1;i<=n;i++) weilist_set_nth(res_l,i,weight_NULL);
  return res_l;
}

void weilist_free(weilist l)
{
  int i,n;
  if (l == NULL) return;
  n=weilist_len(l);
  for (i=1;i<=n;i++) weight_free(weilist_nth(l,i));
  free_weilist(n,l);
}
