#ifndef DMPFF_H
#define DMPFF_H

#include "FF.h"

/* Distributed multivariate polynomials over a small prime finite field. */

extern int DMPFF_NVARS; /* Number of variables (see exps member in struct) */

struct DMPFF_struct;
typedef struct DMPFF_struct *DMPFF;

struct DMPFF_struct
{
  int coeff;
  int *exps;      /* space for DMPFF_NVARS machine integer exponents */
  DMPFF next;
};

DMPFF DMPFFctor(int coeff, int *exps);
void DMPFFdtor(DMPFF f);
DMPFF DMPFFprepend(int coeff, int *exps, DMPFF f);
DMPFF DMPFFreverse(DMPFF f);
DMPFF DMPFFcopy(const DMPFF f);
int DMPFF_nterms(const DMPFF f);
DMPFF DMPFFcoeff(const DMPFF f, int var, int deg);
void DMPFFdegs(int *degs, const DMPFF f);
int DMPFFdeg(const DMPFF f, int var);
int DMPFFtotal_deg(const DMPFF f);
void DMPFFmindegs(int *degs, const DMPFF f);
DMPFF DMPFFdiv_exact(DMPFF f, const DMPFF g);
void DMPFFdiv2ff(DMPFF f, int n);

void DMPFFprint(const DMPFF f);

#endif
