#include <stdlib.h>
#include "DMPFFlist.h"
#include "jalloc.h"

/* we give the compiler a hand here with explicit tail recursion */
int DMPFFlist_length1(DMPFFlist l, int n)
{
  if (l == NULL) return n;
  return DMPFFlist_length1(l->next, n+1);
}

int DMPFFlist_length(DMPFFlist l)
{
  return DMPFFlist_length1(l, 0);
}

/***************************************************************************/

DMPFFlist DMPFFlist_append(DMPFFlist front, DMPFFlist back)
{
  DMPFFlist tmp;

  if (front == NULL) return back;
  for(tmp = front; tmp->next; tmp = tmp->next);
  tmp->next = back;
  return front;
}

/***************************************************************************/


DMPFFlist DMPFFlist_ctor(DMPFF f, int n)
{
  DMPFFlist ans;
  
  ans = (DMPFFlist)MALLOC(sizeof(struct DMPFFlist_struct));
  ans->poly = f;
  ans->deg = n;
  ans->next = NULL;
  return ans;
}


void DMPFFlist_elem_dtor(DMPFFlist elem)
{
  DMPFFdtor(elem->poly);
  FREE(elem);
}


void DMPFFlist_dtor(DMPFFlist l)
{
  if (l == NULL) return;
  DMPFFlist_dtor(l->next);
  DMPFFlist_elem_dtor(l);
}
