#include "DMPZ_to_DUPFF.h"
#include "jerror.h"

static FFelem FFpow(FFelem b, int e)
{
  if (e == 0) return 1;
  if (e < 0) return FFpow(FFdiv(1, b), -e);
  if (e == 1) return b;
  if (e&1) return FFmul(b, FFpow(FFmul(b, b), (e-1)/2));
  return FFpow(FFmul(b, b), e/2);
}


DUPFF DMPZ_to_DUPFF(DMPZ f, int var, int *substitution)
{
  FFelem p = CurrentFF.prime;
  int df, d, c, i;
  DUPFF ans;
  DMPZ iter;
  
  df = DMPZdeg(f, var);
  ans = DUPFFnew(df);
  for(i=0; i<df;i++) ans->coeffs[i] = 0;
  for(iter=f;iter;iter = iter->next)
  {
    d = iter->exps[var];
    c = 1;
    for(i=0;i<NVARS;i++)
      c = FFmul(c, FFpow(substitution[i], iter->exps[i]));
    ans->coeffs[i] += c;
    if (ans->coeffs[i] >= p) ans->coeffs[i] -= p;
  }
  for(i=df;i>=0;i--) if (ans->coeffs[i] != 0) break;
  ans->deg = i;
  return ans;
}
