#include "DMPZmap_to_univariate.h"
#include <stddef.h>



DUPZ DMPZmap_to_univariate(const DMPZ f, int var, int *a)
{
  DMPZ iter;
  DUPZ ans;
  int i, deg;
  mpz_t tmp, tmp2;

  deg = DMPZdeg(f, var);
  if (deg < 0) return NULL;
  ans = DUPZnew(deg);
  mpz_init(tmp);
  mpz_init(tmp2);
  for (iter = f; iter; iter=iter->next)
  {
    mpz_set(tmp, iter->coeff);
    for (i=0; i < NVARS; i++)
    {
      if (i == var) continue;
      if (iter->exps[i] == 0) continue;
      if (a[i] == 0) { mpz_set_ui(tmp, 0); break; }
      mpz_ui_pow_ui(tmp2, a[i], iter->exps[i]);
      mpz_mul(tmp, tmp, tmp2);
    }
    mpz_add(ans->coeffs[iter->exps[var]], ans->coeffs[iter->exps[var]], tmp);
  }
  for (i=deg; i >= 0; i--) if (mpz_sgn(ans->coeffs[i])) break;
  ans->deg = i;
  mpz_clear(tmp2);
  mpz_clear(tmp);
  return ans;
}
