#include "DUPFFfactor.h"
#include <stddef.h>
#include <stdlib.h>
#include "DUPFFsqfrd.h"
#include "berlekamp.h"

DUPFFlist DUPFFfactor(const DUPFF f)
{
  DUPFFlist sqfr_cmpts, ans, iter, iter2, cmpt_factors;

  sqfr_cmpts = DUPFFsqfrd(f);
  ans = NULL;

  /* Apply Berlekamp to each component... */
  for (iter=sqfr_cmpts; iter; iter = iter->next)
  {
    cmpt_factors = Berlekamp(iter->poly);
    for (iter2 = cmpt_factors; iter2; iter2 = iter2->next)
      iter2->deg = iter->deg;
    ans = DUPFFlist_append(ans, cmpt_factors);
  }

  DUPFFlist_dtor(sqfr_cmpts);

  return ans;
}
