#include "DUPZcontent.h"


void DUPZcontent(mpz_t ans, const DUPZ f)
{
  int i, min, minsz, sz, df;

  df = DUPZdeg(f);
  /* Search for the "smallest" non-zero coefficient as our initial value */
  min = 0; minsz = mpz_sizeinbase(f->coeffs[0], 2);
  for (i=1; i <= df; i++)
  {
    if (mpz_sgn(f->coeffs[i]) == 0) continue;
    sz = mpz_sizeinbase(f->coeffs[i], 2);
    if (sz < minsz) { minsz = sz; min = i; }
  }

  mpz_set(ans, f->coeffs[min]);
  for (i=0; i <= df; i++)
  {
    if (i == min) continue; /* we started with this value so can skip it now */
    if (mpz_cmp_ui(ans, 1) == 0) break;  /* answer is 1 */
    if (mpz_sgn(f->coeffs[i]) == 0) continue; /* ignore zero coeffs */
    mpz_gcd(ans, ans, f->coeffs[i]);
  }
}
