#include "DUPZevaluate.h"

void DUPZevaluate(mpz_t value, const DUPZ f, int x)
{
  int i, df, negative;

  df = DUPZdeg(f);
  mpz_set_ui(value, 0);
  negative = x < 0;
  if (negative) x = -x;
  for(i=df; i >= 0; i--)
  {
    mpz_mul_ui(value, value, x);
    if (negative) mpz_neg(value, value);
    mpz_add(value, value, f->coeffs[i]);
  }
}

