#ifndef DUPZFACTOR_BOUND_H
#define DUPZFACTOR_BOUND_H

#include "DUPZ.h"

struct DUPZfactor_bound_struct
{
  int df;
  double leading_coeff;
  double trailing_coeff;
  int dmax;
  double Bombieri2;
  double Mahler;
  double root_bound;
  double reverse_root_bound;
  double all_factors; /* a bound for all factors except perhaps one */
  double lift_bound;
};

typedef struct DUPZfactor_bound_struct *bound_info;

bound_info DUPZfactor_bound_ctor(const DUPZ f, int dmax);
void DUPZfactor_bound_dtor(bound_info bd);
void DUPZrefine_bound(bound_info bd, const DUPZ f, int dmax);
bound_info DUPZcopy_refine_bound(bound_info bd, const DUPZ f, int dmax);


#endif
