#ifndef DUPZfactor_info_h
#define DUPZfactor_info_h

#include "DUPZ.h"
#include "DUPZfactors.h"
#include "DUPFFlist.h"
#include "FF.h"
#include "DUPZfactor_bound.h"
#include "DUPZfactor_liftq.h"

#include "DUPZfactor_info1.h"
/* typedef struct DUPZfactor_info_struct *DUPZfactor_info; */

struct DUPZfactor_info_struct
{
  DUPZ f;                           /* poly to be factorized           */
  DUPZfactors irreds;               /* where to put factors            */
  int p;                            /* chosen prime modulus            */
  int p_index;                      /* index into FFq and qfactors     */
  DUPFFlist pfactors;               /* factors modulo p                */
  int nprimes;                      /* number of primes used           */
  int max_nprimes;                  /* max number of primes to be tried*/
  FF *FFq;                          /* finite fields for those primes  */
  DUPFFlist *qfactors;              /* several modular factorizations  */
  int *fds;                         /* factor degree set               */
  int dmax;                         /* maximum degree of any factor    */

  bound_info bounds;                /* bound information for poly      */
  int target_height;                /* a priori lift height needed     */
  int current_height;               /* height of factors in lifter     */
  mpz_t recip_lcf;                  /* 1/lc(f) modulo Q                */
  mpz_t Q;                          /* p^height                        */
  DUPZfactor_lifter lifter;         /* tree for Hensel lifting         */
};


DUPZfactor_info DUPZfactor_info_ctor(DUPZ f, DUPZfactors output);
void DUPZfactor_info_dtor(DUPZfactor_info this);
void DUPZfactor_info_set_target_height(DUPZfactor_info this);

#endif
