#ifndef DUPZfactor_liftq_h
#define DUPZfactor_liftq_h

#include "DUPZ.h"
#include "DUPFF.h"
#include "DUPFFlist.h"
#include "DUPZfactor_info1.h"

/* The factorization to be lifted is arranged in a binary tree            */
/* using the struct below.                                                */

struct DUPZfactor_lift_struct;
typedef struct DUPZfactor_lift_struct *DUPZfactor_lifter;

struct DUPZfactor_lift_struct
{
  DUPZ g, h;       /* p-adic approximations of the factors              */
  DUPZ corr_factor;/* correction factor for g                           */
  DUPZfactor_lifter g_lifter, h_lifter;
};


/***************************************************************************/

DUPZfactor_lifter DUPZfactor_lifter_ctor(DUPFF g, DUPFF h, DUPZfactor_lifter g_lifter, DUPZfactor_lifter h_lifter);
void DUPZfactor_lift_init(DUPZfactor_info this);
void DUPZfactor_lift_step(DUPZfactor_lifter, DUPZ f, mpz_t Q);
int DUPZfactor_lift_output(DUPZ **factors, const DUPZfactor_lifter this, int i);
void DUPZfactor_lift_dtor(DUPZfactor_lifter);

void DUPZfactor_lift_revise(DUPZfactor_info info);
/*****void DUPZfactor_lift_revise1(DUPZfactor_info info, int height);*****/


#endif
