#include "DUPZfactor_refine_fds.h"

/***************************************************************************/
/* This function updates a "factor degree set", an array of booleans.      */
/* If slot n is true then all modular factorizations so far permit the     */
/* polynomial to have a factor of degree n.                                */
/* If fact we use two bits in each slot during updating, and then tidy up  */
/* the array before returning.                                             */
/* The result is non-zero iff we have proved irreducibility.               */

int DUPZfactor_refine_fds(int *fds, DUPFFlist factors)
{
  int i, max, d;
  const int bit=2, both=3;
  DUPFFlist iter;
  
  fds[0] |= bit;
  max = 0;
  for (iter=factors; iter; iter = iter->next)
  {
    d = DUPFFdeg(iter->poly);
    for (i=max; i >= 0; i--) if (fds[i] & bit) fds[i+d] |= bit;
    max += d;
  }
  d = 0;
  for (i=0; i <= max; i++)
    d += (fds[i] = (fds[i] == both));
/*
  printf("Poss degs: ");
  for (i=0; i <= max; i++) if (fds[i]) printf("%d ",i);printf("\n");
*/
  return (d == 2);
}

