#ifndef DUPZFACTORS_H
#define DUPZFACTORS_H

#include <gmp.h>
#include "DUPZ.h"
#include "DUPZlist.h"

struct DUPZfactors_struct
{
  mpz_t content;
  DUPZlist list;
  int multiplicity;
  int reversed;  /* flag to say whether to reverse factors or not */
};

typedef struct DUPZfactors_struct *DUPZfactors;


DUPZfactors DUPZfactors_ctor();
void DUPZfactors_dtor(DUPZfactors A);
void DUPZfactors_content(DUPZfactors A, mpz_t n);
void DUPZfactors_negate(DUPZfactors A);
void DUPZfactors_add(DUPZfactors A, const DUPZ f);
void DUPZfactors_multiplicity(DUPZfactors A, int m);
void DUPZfactors_reversed(DUPZfactors A, int yes_no);
int DUPZfactors_nfactors(const DUPZfactors A);


#endif
