#include "DUPZformal_deriv.h"

#include <gmp.h>
#include "jerror.h"

DUPZ DUPZformal_deriv(const DUPZ f)
{
  DUPZ ans;
  int df = DUPZdeg(f);
  
  if (df < 1) return DUPZnew(-1);
  ans = DUPZnew(df-1);
  DUPZformal_deriv2(ans, f);
  return ans;
}


/* f and f prime may be identical */
void DUPZformal_deriv2(DUPZ fprime, const DUPZ f)
{
  int i;
  const int df = DUPZdeg(f);

  if (df < 1) { fprime->deg = -1; return; }
  if (df - 1 > fprime->maxdeg) { JERROR(JERROR_DEG_TOO_LOW); return; }
  fprime->deg = df-1;
  for (i=1; i <= df; i++)
    mpz_mul_ui(fprime->coeffs[i-1], f->coeffs[i], i);
}
