#ifndef FF_h
#define FF_h

#include "jaa.h"

struct FFstruct
{
  FFelem prime;
  unsigned int *LogTable; /* this may be NULL */
  FFelem       *ExpTable; /* this may be NULL */
  FFelem k, shift;
};

typedef struct FFstruct *FF;

extern struct FFstruct CurrentFF;

FF FFctor(FFelem p);
void FFdtor(FF Fp);
void FFselect(const FF Fp);

FFelem FFchar(const FF Fp);

/*inline*/ FFelem FFadd(const FFelem x, const FFelem y);
/*inline*/ FFelem FFsub(const FFelem x, const FFelem y);
/*inline*/ FFelem FFmul(const FFelem x, const FFelem y);
/*inline*/ FFelem FFdiv(const FFelem x, const FFelem y);

/*inline*/ unsigned int FFlog(FFelem x);
/*inline*/ FFelem FFexp(unsigned int x);

FFelem FFpower(const FFelem x, int e); /* computes x to the power e */

#endif
