#ifndef FFsolve_h
#define FFsolve_h

#include "FFmat.h"

/* Find a solution to a system of linear equations (in place).          */
/* The finite field is specified using FFselect (see file ../FF.h).     */
/* Input: matrix (not necessarily square)                               */
/*        RHS "right hand side" vectors held as columns of a matrix     */
/* Output: the value returned is the rank of matrix.                    */
/*         the solutions are placed in the columns of soln.             */
/*         If no solution exists for some vector then its first coord   */
/*         is set to p (the characteristic).                            */
/* With luck, if the solution space has positive dimension then the     */
/* solutions found should be correspond to the same rational solution   */
/* provided rank(M) mod p is equal to rank(M) without modulus.          */

/* Two bits used in the return value */
extern const int FFsolve_new_pivot;
extern const int FFsolve_invalid;

int FFsolve(FFmat soln, int* shape, FFmat matrix, FFmat RHS);

#endif
