#ifndef Qsolve_h
#define Qsolve_h

#include "Qmat.h"

/* Solve a system of linear equations over the rationals.                  */
/* The right hand side contains one or more vectors (as cols of a matrix). */

/* Input: solns space for the solutions (i.e. M->nrows by rhs->ncols).     */
/*        M is the "left hand side" matrix.                                */
/*        rhs is a matrix whose columns are these vectors.                 */
/* Output: the return value is the rank of M.                              */
/*        The solutions are written into soln; a zero denominator of the   */
/*        first coordinate of a solution means that no solution exists.    */

int Qsolve(Qmat soln, Qmat M, Qmat rhs);


#endif
