#include <gmp.h>

/* Reconstruction of a rational from its modular image.                   */
/* Input:  res is the modular image of the rational.                      */
/*         mod is the corresponding modulus.                              */
/*         Q is the denominator bound (must have 2*Q < mod).              */
/*         Implicit numerator bound is mod/(2*Q).                         */
/* Output: value returned is non-zero if the result is wrong (meaning     */
/*         that there is no rational with denominator at most Q for that  */
/*         (residue, modulus) pair.                                       */
/*         num is the numerator reconstructed                             */
/*         den is the denominator reconstructed (always positive)         */

int modular_to_rational(mpz_t num, mpz_t den, const mpz_t Q, const mpz_t res, const mpz_t mod);
int modular_to_rational2(mpz_t num, mpz_t den, int log2_den, const mpz_t res, const mpz_t mod);
