#ifndef Zkernel_h
#define Zkernel_h

#include "Zmat.h"

/* Function to compute a Z basis of the kernel of a matrix with integer  */
/* entries.  A randomized algorithm is used so several calls with the    */
/* same arguments may produce different bases; the algorithm was inspired*/
/* by work by G. Havas.  A Z basis is clearly also a Q basis.            */

/* Input:  nrows, ncols -- the size of the matrix M.                     */
/* Output: value returned is dimension of the kernel.                    */
/* Basis vectors are put in Zbasis[0], Zbasis[1], etc.                   */
/* Note that when freeing the space for Zbasis, it was created with space*/
/* for ncols vectors (even if the answer has smaller dimension).         */
/* The matrix M is generally altered by calling this function.           */

int Zmat_left_kernel_Zbasis(Zmat *Zbasis, Zmat M);

#endif
