#ifndef Zmat_det_bound_h
#define Zmat_det_bound_h

#include "Zmat.h"

/************************************************************************/
/* Two functions for computing (Hadamard's) determinant bound of a      */
/* matrix or of one of its principal minors.                            */

/************************************************************************/
/* Compute logarithm of a bound for the determinant of M.               */
/* If M is not square, value returned is 0.                             */
double Zmat_det_bound(Zmat M);

/************************************************************************/
/* This function computes a determinant bound for the leading nxn minor */
/* If n exceeds number of rows or cols in M then 0 is returned.         */
double Zmat_det_bound2(Zmat M, int n);

#endif
