#include <stdio.h>
#include "jerror.h"

int LAST_ERROR = 0;    /* 0 means no error */
int PRINT_ERRORS = 1;  /* zero means don't print, non-zero means print */


static char *err_msg[] =
{
  "no error has occurred",
  "division by zero",
  "argument to FFctor not an odd prime or greater than 65535",
  "memory space exhausted",
  "maximum deg in destination polynomial too low",
  "unspecified error",
  "zero to power zero",
  "DUPFFdiv4, illegal arg sharing",
  "DUPZfactors_add: not enough space",
  "DUPIsubtract_product: illegal arg sharing",
  "DUPZreverse: polynomial has zero constant coefficient",
  "Hensel error: factors not coprime",
  "DUPFFexpt3mod: power not positive",
  "Illegal argument aliasing",
  "Matrix problem (wrong size)",
  "CRA failed: prime list exhausted"
};

static int MAXERRCODE = 15;


void JERROR(int errcode)
{
  LAST_ERROR = errcode;
  if (!PRINT_ERRORS) return;
  if (errcode < 1 || errcode > MAXERRCODE)
    fprintf(stderr, "ERROR: unknown error number, %d\n", errcode);
  else
    fprintf(stderr, "ERROR: %s\n", err_msg[errcode]);
  
}
