#ifndef mpz_lift_recip_h
#define mpz_lift_recip_h

#include <gmp.h>

/* Lift a reciprocal value using Hensel lifting                          */
/* Assume that inputs satisfy for some integer M:                        */
/*   recip*value = 1 mod M  and                                          */
/*   M | modulus  and                                                    */
/*   modulus | M^2                                                       */
/* Upon return recip will be altered so that recip*value = 1 mod modulus */

void mpz_lift_recip(mpz_t recip, mpz_t value, mpz_t modulus);

#endif
