/*  First test for DUPI implementation */
/*  This is virtually a copy of test1  */

#include <stdio.h>

#include "jaa.h"
#include "DUPI.h"
#include "DUPIprint.h"


void singletest(FFelem p, int d);

int main(int argc, char **argv)
{
  singletest(19, 5);
  singletest(19, 18);
  singletest(97, 5);
  singletest(97, 25);
  singletest(3571, 5);
  singletest(3571, 15);
  singletest(3571, 25);
  singletest(7, 19);
  singletest(3, 37);

  return(0);
}

void singletest(FFelem p, int d)
{
  DUPI f, g, h, k, tmp, tmp2;
  int i;

  printf("Starting test for p=%d and d=%d\n", p, d);
  f = DUPInew(d);
  g = DUPInew(d);
  for (i=0; i<=d; i++) f->coeffs[i] = (d+i)%p - (p-1)/2;
  g->coeffs[0] = p/2;
  for (i=1; i<=d; i++) g->coeffs[i] = (g->coeffs[i-1]+f->coeffs[i])%p;
  f->deg = d; f->coeffs[d] = 1;  /* to avoid problems when remaindering */
  g->deg = d; g->coeffs[d] = -1; /*                                     */


  printf("f is ");
  DUPIprint(f);
  printf("g is ");
  DUPIprint(g);

  h = DUPInew(2*d);
  DUPImul3(h, g, f);
  if (DUPIdeg(h) != DUPIdeg(f)+DUPIdeg(g))
    printf("degree loss in multiply\n");
  printf("h:=f*g\n");

  tmp = DUPIdiv(h,g);
  if (!DUPIequal(tmp, f)) printf("h/g != f\n");
  DUPIfree(tmp);

  tmp = DUPIdiv(h,f);
  if (!DUPIequal(tmp, g)) printf("h/f != g\n");
  DUPIfree(tmp);

  tmp = DUPIrem(h,g);
  if (tmp->deg >= 0) printf("h mod g is not zero\n");
  DUPIfree(tmp);

  tmp = DUPIrem(h,f);
  if (tmp->deg >= 0) printf("h mod f is not zero\n");
  DUPIfree(tmp);

  k = DUPIadd(h, f);
  tmp = DUPIrem(k,g);
  tmp2 = DUPIrem(f,g);
  if (!DUPIequal(tmp, tmp2)) printf("h+f != f mod g\n");
  DUPIfree(tmp);
  DUPIfree(tmp2);
  DUPIfree(k);

  k = DUPIadd(h, g);
  tmp = DUPIrem(k,f);
  tmp2 = DUPIrem(g,f);
  if (!DUPIequal(tmp, tmp2)) printf("h+g != g mod f\n");
  DUPIfree(tmp);
  DUPIfree(tmp2);

  DUPIfree(k);
  DUPIfree(f);
  DUPIfree(g);
  DUPIfree(h);
  printf("test for p=%d and d=%d complete\n\n\n\n\n\n", p, d);
}
